/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/23 22:48:26 jun>

 */
//package jp.co.lmer.mail;

import java.awt.*;
import java.util.Vector;
import java.util.StringTokenizer;
import javax.mail.*;
import java.io.IOException;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.FileNotFoundException;

import MailFieldConvert;
import MailFileException;
import MailProperties;
import Reference;
import ReferenceInterface;

import WordOutLog;

/**
 * Describe class <code>AbsContents</code> here.
 *
 * @author Jun Kurabe
 * @author Hiroshi Ichiji
 * @version 1.0
 * @date   2001/11/11
 * @date   2002/01/26
 */
public class AbsContents 
    extends TextArea
	    //    implements ReferenceInterface 
{
    /** */
    public static final int NOMESSAGE = -1;

    /**
     * Creates a new <code>AbsContents</code> instance.
     *
     * @param ref
     * @param mp ġΥץѥƥ֥
     */
    public AbsContents(Reference ref, MailProperties mp) {
	super("",11,80,TextArea.SCROLLBARS_VERTICAL_ONLY);
	setRows(10);
	//	setRows(14);
	this.setEditable(false);
	this.ref = ref;
	this.mp = mp;
    }

    /**
     * Ѥѽñν̤ꤹ
     *
     * @param n an <code>int</code> value
     */
    public void setMaxLevel(int n) {
	maxLevel = n;
    }

    /**
     * show the contents of message
     * @param msgId a <code>String</code> value
     * @exception MailFileException if an error occurs
     */
    public void change(String msgId) 
	throws MailFileException {

	class MakeSummary 
	    extends RIImpl {
	    /**
	     * @param ac 
	     * @param ref
	     */
	    public MakeSummary(AbsContents ac, Reference ref) {
		this.ac = ac;
		this.ref = ref;
	    }

	    /** 
	     * @param msgId
	     * @return boolean
	     */
	    public boolean doIt(String msgId) {
		try {
		    Message msg = ref.getMsg(msgId);

		    String s = MailFieldConvert.getBodyText(msg);
		    MailSentence ms = new MailSentence(s);
		    ms.setMaxLevel(maxLevel);
		    ms.setMailProperties(this.mp);
		    refSentence = ms.divide(refSentence);
		    change(msg, false, ms);
		    return false;
		} catch (MailFileException mfe) {
		    //	    mfe.printStackTrace();
		    return true;
		} catch (NullPointerException e) {
		    return false;
		} // end of catch
		
	    }

	    public Vector doIt(String msgId, Vector eo) {
		try {
		    Message msg = ref.getMsg(msgId);
		    
		    String s = MailFieldConvert.getBodyText(msg);
		    MailSentence ms = new MailSentence(s);
		    ms.setMaxLevel(maxLevel);
		    ms.setMailProperties(this.mp);
		    Vector rs = ms.divide(eo);
		    // System.err.println("MsgId(DoIt): " + msgId);
		    change(msg, false, ms);
		    return rs;
		} catch (MailFileException mfe) {
		    //	    mfe.printStackTrace();
		    return null;
		} catch (NullPointerException npe) {
		    return null;
		} // end of catch
		
	    }

	    public void setRefSentence(Vector refSentence) {
		this.refSentence = refSentence;
	    }

	    public void setMailProperties(MailProperties mp) {
		this.mp = mp;
	    }

	    /** */
	    private AbsContents ac = null;
	    /** */
	    private Reference ref = null;
	    /** */
	    private Vector refSentence = null;
	    /** */
	    private MailProperties mp = null;
	}

	if(msgId == null)  return;
	this.setText("\n");
	MailSentence.clearCurrentLabel();

	currentMailIndex = 0;
	openHTML();
	//	ref.enumerationToTop(msgId, this);
	MakeSummary ms = new MakeSummary(this, ref);
	ms.setMailProperties(this.mp);
	Vector refS = ref.enumerationFromBottom(msgId, ms);
	ms.setRefSentence(refS);
	ref.enumerationToTop(msgId, ms, true);
	moveToStartMessage(msgId);
	closeHTML();
	//	change(msg, true);
    }

    /**
     * åȤ򥵥ޥ꡼εȤʤäᥤƬ˰ư롣
     *
     * @param msgId a <code>String</code> value
     */
    private void moveToStartMessage(String msgId) {
	String summary = this.getText();
	int pos = summary.indexOf(LABEL_MSGID + msgId);
	int rows = getRows();
	for (int i = 0; i < rows-5; i++) {
	    pos = summary.indexOf("\n",pos+1);
	} // end of for (int i = 0; i < rows-4; i++)
	try {
	    setCaretPosition(pos);	     
	} catch (IllegalArgumentException e) {
	} // end of try-catch
    }

    /** ʸɽѤ٥ */
    static private final String SEPARATOR = "***************\n";
    static private final String LABEL_FROM = "From: ";
    static private final String LABEL_DATE = "Date: ";
    static private final String LABEL_MSGID = "Message-Id: ";
    static private final String LABEL_SUBJECT = "Subject: ";
    static private final String LABEL_INREPLYTO = "In-Reply-To: ";
    static private final String LABEL_REFERENCES = "REFERENCES: ";

    /**
     * ᥤΥإåˤ
     * @param msg
     * @return String ᥤFrom, Date Υǡ
     */
    private String getHeader(Message msg) {
	StringBuffer rv = new StringBuffer();
	rv.append(SEPARATOR);
	rv.append(LABEL_FROM + 	MailFieldConvert.convertFrom(msg) + "\n");
	rv.append(LABEL_DATE + MailFieldConvert.convertDate(msg) + "\n");
	rv.append(LABEL_MSGID + MailFieldConvert.getMsgId(msg) + "\n");
	rv.append(LABEL_REFERENCES + getRelMsgId(msg,"REFERENCES") + "\n");
	rv.append(LABEL_INREPLYTO + getRelMsgId(msg,"In-Reply-To") + "\n");
	rv.append(LABEL_SUBJECT + MailFieldConvert.convertSubject(msg) + "\n");
	return rv.toString();
    }

    /**
     * ѡȤƤåID
     *
     * @param msg a <code>Message</code> value
     * @return a <code>String</code> value
     */
    private String getRelMsgId(Message msg, String key) {
	StringBuffer sb = new StringBuffer();
	String refs[] = null;
	try {
	    refs = msg.getHeader(key);	     
	} catch (MessagingException e) {
	} // end of try-catch

	if (refs == null ) return "";
	int j = 0;
	// Sprit Value into elements
	for (int i = 0; i<refs.length; i++) {
	    StringTokenizer st = new StringTokenizer(refs[i],"\"\'<>, ");
	    while(st.hasMoreTokens()) {
		String ss = st.nextToken();
		if ( ss.indexOf("@") == -1) continue;

		if (j!=0) {
		    sb.append(",\n");
		} // end of if (j!=0)
		
		sb.append(ss);
		j++;
	    }
	}
	return sb.toString();
    }

    /**
     * Add From Fields values to StringBuffer
     * @param msg a <code>Message</code> å֥
     * @param sb a <code>StringBuffer</code> value
     * @exception MailFileException throws when something 
     *            MessagingException occars
     */
    private void getFrom(Message msg, StringBuffer sb) 
	throws MailFileException {
	sb.append(MailFieldConvert.convertFrom(msg));
    }

    /**
     * Print message containts 
     * @param head Headers
     * @param body Body text
     */
    private void printMe(String head, String body) {
	String tmpHtmlPath = mp.getHTMLDir() + "Mail" + (new Integer(++currentMailIndex)).toString() + ".html";
	try {
	    fh = new File(tmpHtmlPath);
	    FileOutputStream fos = new FileOutputStream(fh);
	    PrintStream xps = new PrintStream(fos);
	    xps.println("<html>");
	    xps.println("<head>");
	    xps.println("<title>Abstract</title>");
	    xps.println("</head>");
	    xps.println("<body>");
	    xps.println("<a href=\"./"+mp.getHTMLSUM()+"#Mail"+currentMailIndex+"\">[BACK]</a>");
	    xps.println("<table width=\"600\">");
	    xps.println("<tr><td>");
	    xps.println("<pre>");

	    xps.println(head);
	    xps.println(body);

	    xps.println("</pre>");
	    xps.println("</td></tr>");
	    xps.println("</table>");
	    xps.println("</body>");
	    xps.println("</html>");
	    xps.close();
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	    fh = null;
	    ps = null;
	}catch (IOException e) {
	    e.printStackTrace();
	    fh = null;
	    ps = null;
        }
    }

    /**
     * Describe <code>change</code> method here.
     *
     * @param msg
     * @param clean
     * @param ms a <code>MailSentence</code> value
     * @exception MailFileException if an error occurs
     */
    private synchronized void change(Message msg, boolean clean,
				     MailSentence ms) 
	throws MailFileException {	
	String sepString = getHeader(msg);
	String s = MailFieldConvert.getBodyText(msg);

	printMe(sepString, s);
	WordOutLog.out.print(sepString);
	String toThisMail = "<a href=\"Mail"+(new Integer(currentMailIndex)).toString()+".html\">[ToThisMail]</a><a name=\""+currentMailIndex+"\"></a>\n";

	ms.printMessage();
	insert(sepString + ms.getMessage(), 0);
	setCaretPosition(0);
	printHTML(toThisMail + sepString + ms.getMessage(true));
    }
    
    /** 
     * @param msgId
     * @return boolean
     */
    public boolean doIt(String msgId) {
	try {
	    Message msg = ref.getMsg(msgId);
	    if ( msg == null ) return false;

	    String s = MailFieldConvert.getBodyText(msg);
	    MailSentence ms = new MailSentence(s);
	    change(msg, false, ms);
	    return false;
	} catch (MailFileException mfe) {
	    //	    mfe.printStackTrace();
	    return true;
	}
    }

    /**
     */
    public void openHTML() {
	String tmpHtmlFile = mp.getHTMLPath();
	if (tmpHtmlFile != null ) htmlFile = tmpHtmlFile;
	try {
	    fh = new File(htmlFile);
	    FileOutputStream fos = new FileOutputStream(fh);
	    ps = new PrintStream(fos);
	    ps.println("<html>");
	    ps.println("<head>");
	    ps.println("<title>Abstract</title>");
	    ps.println("</head>");
	    ps.println("<body>");

	    ps.println("<table width=\"600\">");
	    ps.println("<tr><td>");
	    ps.println("<pre>");
	    pdb = new String("");
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	    fh = null;
	    ps = null;
	}catch (IOException e) {
	    e.printStackTrace();
	    fh = null;
	    ps = null;
        }
    }

    /**
     *  close output stream for HTMLFile
     */
    public void closeHTML() {
	if ( ps == null ) return;
	ps.println(pdb);
	ps.println("</pre>");

	ps.println("</td></tr>");
	ps.println("</table>");
	ps.println("</body>");
	ps.println("</html>");
	ps.close();
	pdb = null;
	ps = null;
	fh = null;
    }

    /**
     * printOut the HTML statement 
     * @param s HTML Statement
     */
    public void printHTML(String s) {
	if ( ps == null ) return;
	pdb = s + pdb;
    }

    /** */
    private static String htmlFile = "/tmp/a.html";
    
    /** */
    private File fh = null;
    /** */
    private PrintStream ps = null;
    /** */
    private String pdb = null;

    /** */
    private Reference ref = null;
    /** */
    private String folderName = null;
    /** */
    private int index = NOMESSAGE;
    /** */
    private MailProperties mp = null;

    /** */
    private int currentMailIndex = 0;

    /** */
    private int maxLevel = 3;
}
