/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/11 18:08:02 jun>

 */
//package jp.co.lmer.mail;

import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.MessagingException;
import javax.mail.Address;
import javax.mail.internet.MimeUtility;
import javax.mail.internet.ParseException;
import java.io.UnsupportedEncodingException;
import java.io.IOException;
import java.lang.Character;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.StringTokenizer;

/**
 * Created by Jun Kurabe
 * 2002/01/14
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 * @date 2002/01/14
 */
public class MailFieldConvert {
    /**
     * convert subject which is not correct format
     * @param msg
     * @return String 
     */
    public static String convertSubject(Message msg) {
	StringBuffer rv = new StringBuffer();
	String subjects[] = null;
	try {
	    subjects = msg.getHeader("subject");	     
	} catch (MessagingException e) {
	} // end of try-catch

	String subject = "<NULL>";
	if (subjects != null) {
	    subject = subjects[0];
	} // 
	
	StringTokenizer st = new StringTokenizer(subject,"\n\r");
	while (st.hasMoreElements()) {
	    subject = (String)st.nextElement();
	try {
	    if (subject.indexOf("=?") == -1) {
		rv.append(subject);
	    } // end of if (subject.indexOf("=?") == -1)
	    else {
		String s = subject;
		while (s != null) {
		    int p = s.indexOf("=?");
		    if (p == -1) {
			rv.append(s);
			break;
		    } // end of if (p == -1)

		    if (p != 0) {
			rv.append(s.substring(0,p-1));
			s = s.substring(p);
			continue;
		    } // end of if (p != 0)

		    int pe = s.indexOf("?=");
		    try {
			rv.append(MimeUtility.decodeWord(s.substring(0,pe+2)));			
		    } catch (ParseException e) {
			/*
			  System.err.println("org: " + subjects[0]);
			  System.err.println("error: " + s.substring(0,pe+2));
			  System.err.println("rv: " + rv);
			  e.printStackTrace();
			*/
			rv.append(s.substring(0,pe+2));
		    } // end of try-catch

		    try {
			s = s.substring(pe+2);			
		    } catch (StringIndexOutOfBoundsException e) {
			s = null;
		    } // end of try-catch
		} // end of while (true)
		
	    } // end of else
	} catch (UnsupportedEncodingException e) {
	    e.printStackTrace();
	} catch (NullPointerException e) {
	    //	    e.printStackTrace();	    
	}
	} // end of while (st.hasMoreElements())

	/*
        int p = rv.indexOf("\n");
        while(p!=-1) {
            rv = rv.substring(0,p-1) + rv.substring(p+1);
            p = rv.indexOf("\n", p);
        }
	*/
	return rv.toString();
    }

    /**
     * convert to basic subject, which means remove ML's counter / Re: 
     * @param msg
     * @return String 
     */
    public static String getBareSubject(Message msg) {
	String orgSubject = convertSubject(msg);
	orgSubject=orgSubject.toLowerCase();
	int p = 0;
	int ps = -1;
	int pe = -1;
	if (orgSubject != null ) {
	    if ((ps = orgSubject.indexOf("[")) != -1 && 
		(pe = orgSubject.indexOf("]", ps+1)) != -1 ) {
		orgSubject = orgSubject.substring(pe+1);
		//		System.err.println("orgSubject ] =" + orgSubject);
	    }

	    // re: 
	    p = orgSubject.lastIndexOf("re:");
	    if ( p != -1 ) orgSubject = orgSubject.substring(p+3);
	    p = orgSubject.lastIndexOf("RE:");
	    if ( p != -1 ) orgSubject = orgSubject.substring(p+3);
	    p = orgSubject.lastIndexOf("Re:");
	    if ( p != -1 ) orgSubject = orgSubject.substring(p+3);

	    // fw: 
	    p = orgSubject.lastIndexOf("fw:");
	    if ( p != -1 ) orgSubject = orgSubject.substring(p+3);
	    p = orgSubject.lastIndexOf("FW:");
	    if ( p != -1 ) orgSubject = orgSubject.substring(p+3);
	    p = orgSubject.lastIndexOf("Fw:");
	    if ( p != -1 ) orgSubject = orgSubject.substring(p+3);
	    
	    orgSubject = orgSubject.trim();

	    StringBuffer sb = new StringBuffer(orgSubject) ;
	    for (int i = 0; i< sb.length(); ) {
		if (Character.isWhitespace( sb.charAt(i))) {
		    sb.deleteCharAt(i);
		    continue;
		}
		i++;
	    } 
	    orgSubject = sb.toString();
	}
	
	return orgSubject;
    }

    public static String convertFromAddress(Message msg) {
	String rv = null;
	try {
	    Address from = msg.getFrom()[0];
	    String fromA = from.toString();

	    StringTokenizer st = new StringTokenizer(fromA, "<> ,\"\'");
	    while (st.hasMoreTokens()) {
		rv = (String)st.nextElement();
		if (rv.indexOf("@")!=-1) break;
	    } // end of while (st.hasMoreToken())
	    
	} catch (MessagingException me) {
	    me.printStackTrace();
	}
	return rv;
    }

    /**
     * convert from which has Japanese text
     * @param msg
     * @return String 
     */
    public static String convertFrom(Message msg) {
	StringBuffer rv = new StringBuffer();
	try {
	    Address from = msg.getFrom()[0];
	    String fromA = from.toString();
	    if (fromA.indexOf("=?") == -1) {
		rv.append(fromA);
	    } // end of if (fromA.indexOf("=?") == -1)
	    else {
		String s = fromA;
		while (s != null) {
		    int p = s.indexOf("=?");
		    if (p == -1) {
			rv.append(s);
			break;
		    } // end of if (p == -1)

		    if (p != 0) {
			rv.append(s.substring(0,p-1));
			s = s.substring(p);
			continue;
		    } // end of if (p != 0)

		    int pe = s.indexOf("?=");
		    rv.append(MimeUtility.decodeWord(s.substring(0,pe+2)));
		    s = s.substring(pe+2);
		} // end of while (true)
		
	    } // end of else
	    /*
	      String s = rv.toLowerCase();
	    if (s.indexOf("-2022-") != -1 ||
		s.indexOf("sjis") != -1 ||
		s.indexOf("euc") != -1 ) {
		int p = rv.indexOf("?=");
		if (p != -1) {
		    rv = MimeUtility.decodeWord(rv) + rv.substring(p+3);
		} // end of if (p != -1)
	    }
	    */
	} catch (MessagingException me) {
	    me.printStackTrace();
	} catch (UnsupportedEncodingException e) {
	    e.printStackTrace();
	} catch (NullPointerException e) {
	    //	    e.printStackTrace();	    
        } 

	for (int j = 0; j < rv.length();) {
	    switch (rv.charAt(j)) {
	    case '\n':
	    case '\r':
		rv.deleteCharAt(j);
		break;
	    default:
		j++;
		break;
	    } // end of switch (rv.charAt(j))
	    
	} // end of for (int j = 0; j < rv.length();)
	
	return rv.toString();
    }

    /**
     * Get the Text from Body part
     * @param msg     Target Message
     * @return String Text which is in Body Part
     */
    public static String getBodyText(Message msg) 
	throws MailFileException {
	String body = "";
	try {
            String type = msg.getContentType().toUpperCase();
            if (type.indexOf("MULTIPART") != -1) {
                Multipart mp = (Multipart)msg.getContent();
                int n = mp.getCount();
                for(int i =0;i<n;i++) {
                    BodyPart bp = mp.getBodyPart(i);
                    String bpType = bp.getContentType().toUpperCase();
		    // System.err.println(i + ":" + bpType);

                    try {
                        if (bpType.indexOf("TEXT/PLAIN") != -1 ) {
                            String s = (String)bp.getContent();
			     body = s + body;
			 }
		     } catch ( Exception e) {
			 System.err.println("Error");
			 e.printStackTrace();
		     }

		 }
		 return body;
	     }

	     if (type.indexOf("TEXT/PLAIN") != -1) {
		 String s = "";
		 try {
		     s = (String)msg.getContent();		      
		 } catch (sun.io.MalformedInputException e) {
		     
		 } // end of try-catch

		 if ( type.indexOf("CHARSET") == -1 ) 
		     s = new String(s.getBytes(), "ISO-2022-JP");
		 body = s + body;

		 return body;
	     }
	 } catch (IOException e) {
	     e.printStackTrace();
	 } catch (MessagingException me) {
	     me.printStackTrace();
	     throw new MailFileException();
	 }
	 return "";
     }

    /**
     * Describe <code>convertDate</code> method here.
     *
     * @param msg a <code>Message</code> value
     * @return a <code>String</code> value
     */
    public static String convertDate(Message msg) {
	Date date = null;
	int n = 0;
	try {
	    date = msg.getSentDate();
	} catch (MessagingException me) {
	    me.printStackTrace();
	} catch (NullPointerException e) {
	    //	    e.printStackTrace();	    
	}

	SimpleDateFormat sdf = new SimpleDateFormat();
	return sdf.format(date);
    }

    /**
     * åID
     * @param msg å֥
     * @return String
     */
    public static String getMsgId(Message msg) {
	try {
	    String hdrs[] = msg.getHeader("Message-ID");
	    if ( hdrs == null) return null;

	    StringBuffer sb = new StringBuffer(hdrs[0]);
	    int pos = sb.toString().indexOf("<");
	    sb.delete(pos,pos+1);
	    pos = sb.toString().indexOf(">");
	    sb.delete(pos,pos+1);
	    //	    return hdrs[0];
	    return sb.toString();
	} catch (MessagingException me) {
	    return null;
	}
    }


}
