/*
  (c) 2002,2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/16 16:08:20 jun>
 */

// 2002/10/09
// Jun Kurabe

import java.awt.*;
import javax.mail.Message;
import javax.mail.MessagingException;
import EDU.auburn.VGJ.gui.GraphCanvasInterface;

import MailFieldConvert;
import Reference;
import Selection;
import ThreadWord;
import TWData;

/**
 * Describe class <code>MailPopup</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
public class MailPopup 
    extends Frame
    implements GraphCanvasInterface {

    /**
     * Creates a new <code>MailPopup</code> instance.
     *
     * @param frame a <code>Frame</code> value
     * @param ref a <code>Reference</code> value
     */
    public MailPopup(Frame frame, Reference ref) {
	this.frame = frame;
	this.ref = ref;
    }

    /**
     * Describe <code>pointDown</code> method here.
     *
     * @param target a <code>Component</code> value
     * @param x an <code>int</code> value
     * @param y an <code>int</code> value
     * @param msgId a <code>String</code> value
     */
    public synchronized void pointDown(Component target, 
				       int x, int y, String msgId) {
	try {
	    // å֥Ȥ
	    Message msg = ref.getMsg(msgId);
	    // ѽñ׻
	    String words = getWords(ref, msgId);
	    // ݥåץåץɥ
	    popup = new PopupWindow(frame,msg,words);
	    // ɽꤹ
	    Point dim = getGlobalPos(target, x, y);
	    popup.setLocation(dim.x+10,dim.y);
	    /* ɽ */
	    popup.setVisible(true);
	} catch (MailFileException e) {
	    e.printStackTrace();
	} // end of try-catch
    }

    /**
     * ꡼Υޥΰ֤֤
     *
     * @param target a <code>Component</code> value
     * @param x an <code>int</code> value
     * @param y an <code>int</code> value
     * @return a <code>Point</code> ꡼Υޥΰ
     */
    private Point getGlobalPos(Component target, int x, int y) {
	int global_x = x;
	int global_y = y;
	while (target != null) {
	    global_x += target.getLocation().x;
	    global_y += target.getLocation().y;
	    if (target instanceof Frame) break;
	    target = target.getParent();
	} // end of while (true))

	return new Point(global_x, global_y);
    }

    /**
     * Describe <code>pointUp</code> method here.
     *
     * @param x an <code>int</code> value
     * @param y an <code>int</code> value
     * @param msgId a <code>String</code> value
     */
    public synchronized void pointUp(Component target, 
				     int x, int y, String msgId) {
	/* ä */
	try {
	    popup.setVisible(false);
	} catch (NullPointerException e) {
	    
	} // end of try-catch
	// ֥Ȥ
	popup = null;

	Selection.set(msgId);
    }

    /**
     * Describe <code>setOffset</code> method here.
     *
     */
    public void setOffset() {
    }

    /**
     * ѽñ׻ȥ󥰷֤
     *
     * @param ref a <code>Reference</code> value
     * @param msgId a <code>String</code> messageId
     * @return ѽñ줬","ʬΥƳǼƤ
     */
    private String getWords(Reference ref, String msgId) {
	ThreadWord tw = new ThreadWord(ref);
	tw.countWordInThisMail(msgId);
	TWData[] twd = tw.getOrderedCount();
	StringBuffer sb = new StringBuffer();

	for (int i = 0; i<twd.length; i++) {
	    sb.append(twd[i].getString());
	    sb.append(", ");
	} // end of for (int i = 0; i<twd.length; i++))
    
	tw = null;
	return (sb.toString());
    }

    /** */
    private Frame frame = null;
    /** */
    private Reference ref = null;
    /** */
    private PopupWindow popup = null;
}

/**
 * Describe class <code>PopupWindow</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class PopupWindow extends Dialog {

    /**
     * Creates a new <code>PopupWindow</code> instance.
     *
     * @param frame a <code>Frame</code> value
     * @param msg a <code>Message</code> value
     */
    public PopupWindow(Frame frame, Message msg, String words) {
	super(frame);
	//	super("Mail");
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	setLayout(gbl);

	gbc.weightx = 0;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbc.fill = GridBagConstraints.VERTICAL;

	Label label =  new Label ("Mail Information");
	gbc.gridx = 0;
	gbc.gridy = 0;
	gbl.setConstraints(label, gbc);
	
	label = new Label("Subject:");
	gbc.gridx = 0;
	gbc.gridy = 1;
	gbl.setConstraints(label, gbc);
	add(label);

	label = new Label("From:");
	gbc.gridx = 0;
	gbc.gridy = 2;
	gbl.setConstraints(label, gbc);
	add(label);

	label = new Label("Date:");
	gbc.gridx = 0;
	gbc.gridy = 3;
	gbl.setConstraints(label, gbc);
	add(label);

	label = new Label("Words:");
	gbc.gridx = 0;
	gbc.gridy = 4;
	gbl.setConstraints(label, gbc);
	add(label);

	subject = new TextField(30);
	from = new TextField(30);
	date = new TextField(30);

	// Dialog
	// SansSerif
	// Serif
	// Monospaced
	// DialogInput

	Font f = new Font("Dialog",Font.PLAIN,12);
	subject.setFont(f);

	// ֥Ȥꤹ
	subject.setText(MailFieldConvert.convertSubject(msg) );
	subject.setFont(f);

	// Ԥꤹ
	from.setText(MailFieldConvert.convertFrom(msg));

	// ȯꤹ
	try {
	    date.setText((msg.getSentDate()).toString());	     
	} catch (MessagingException e) {
	} // end of try-catch
	
	gbc.gridx = 1;
	gbc.gridy = 1;
	gbl.setConstraints(subject, gbc);
	add(subject);

	gbc.gridx = 1;
	gbc.gridy = 2;
	gbl.setConstraints(from, gbc);
	add(from);

	gbc.gridx = 1;
	gbc.gridy = 3;
	gbl.setConstraints(date, gbc);
	add(date);

	wordField = new TextField(30);
	wordField.setText(words);
	gbc.gridx = 1;
	gbc.gridy = 4;
	gbl.setConstraints(wordField, gbc);
	add(wordField);

	this.setSize(350,175);
	this.setVisible(false);
    }

    /** */
    TextField subject = null;
    /** */
    TextField date = null;
    /** */
    TextField from = null;

    /** */
    TextField wordField = null;
}
