/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
import java.util.Properties;
import java.io.FileInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * Describe class <code>MailProperties</code> here.
 *
 * @author Jun Kurabe ( jun-krb@mars.dti.ne.jp )
 * @version 1.0
 * @date   2002/01/26
 */
public class MailProperties
    extends Properties {

    /** ᥤġץѥƥեΥѥ */
    static private final String DEFAULTPROPPATH = "./data/MailTool.prop";

    /**
     * MailProperties ֥Ȥ롣
     * @param fp ץѥƥեΥѥ
     *        fpnullʤХǥեȤΥѥȤ
     * @throws FileNotFoundException ե뤬̵
     * @throws IOException ե򳫤Ȥ˼
     */
    public MailProperties(String fp) 
    throws FileNotFoundException, IOException {
	super();
	if (fp == null) {
	    fp = DEFAULTPROPPATH;
	} // end of if (fp == null)
	
	File fh = new File(fp);
	FileInputStream fis = new FileInputStream(fh);

	load(fis);
    }

    /**
     * ᥤѥ֤
     * @return String ᥤΥѥ
     */
    public String getMailPath () {
	return getProperty("MailPath");
    }

    /**
     * ᥤΥǥ쥯ȥ֤
     * @return String ᥤΥѥ
     */
    public String getMailDir () {
	return getProperty("MailDir");
    }

    /**
     * HTMLΥѥ֤
     * @return String HTMLΥѥ
     */
    public String getHTMLSUM () {
	return getProperty("HTMLSUM");
    }

    /**
     * HTMLΥѥ֤
     * @return String HTMLΥѥ
     */
    public String getHTMLDir () {
	String dir = getProperty("HTMLPath");
	if ( dir.charAt(dir.length()-1) != '/' ) dir += "/";
	return dir;
    }

    /**
     * HTMLΥѥ֤
     * @return String HTMLΥѥ
     */
    public String getHTMLPath () {
	return getHTMLDir() + getHTMLSUM();
    }

    /**
     * Describe <code>getUsedWordLogPath</code> method here.
     *
     * @return a <code>String</code> value
     */
    public String getUsedWordLogPath() {
	String logDir = getProperty("LogDir");
	String file = getProperty("UsedWordLog");

	return logDir + "/" + file;
    }
}
