/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
// Created by Jun Kurabe
// 2001/09/24
// Copyright by Jun Kurabe, All rights reserved.

//package jp.co.lmer.mail;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;

import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;


import java.util.Comparator;
import java.util.Arrays;
import java.lang.Character;

import Chasen;
import MailString;
import MailProperties;
import Preface;
import PrefaceDebug;
import WordOutLog;

/**
 * Describe class <code>MailSentence</code> here.
 *
 * @author Jun Kurabe
 * @version 1.0
 */
public class MailSentence     {

    /** */
    public static final int ABSMAXLEVEL = 3;
    public static final int ABSDEFAULTLEVEL = 1;

    /**
     * Creates a new <code>MailSentence</code> instance.
     *
     * @param s
     */
    public MailSentence(String s) {
	this.s = s;
	wordCnt = new HashMap();
	wordPlace = new HashMap();
	allSentences = new Vector();

	PrefaceDebug.println("Sentence = " + s,this);
    }

    /**
     * Describe <code>addBefore</code> method here.
     *
     * @param s
     */
    public void addBefore(String s) {
	this.s = s + "\n" + this.s;
    }

    /**
     * Describe <code>addAfter</code> method here.
     *
     * @param s
     */
    public void addAfter(String s) {
	this.s = this.s + "\n" + s;
    }

    /**
     * ñ̤ʬ򤹤
     *
     * @param upperSentence a <code>Vector</code> value
     * @return Vector
     */
    public Vector divide(Vector upperSentence) {
	int level = 0;
	int preLevel = -1;

	String groupString = "";
	String preToken = "";

	// changed 2001/11/05
	// by Jun Kurabe
	boolean trail = false;

	// 2002/11/09
	Vector groups = new Vector();

	// ꥸʥʸֿʸʤɤΥ٥ʻʬ롣
	StringTokenizer st = new StringTokenizer(s, "\n", true);
	while(st.hasMoreTokens()) {
	    level = 0;
	    String ss = st.nextToken();
	    // Signature will start with "--"
	    // if ( ss.startsWith("--")) trail = true;
	    
	    if ( !ss.equals("\n")) {
		// ƬΥڡ
		ss = ss.trim();
		while (ss.startsWith("")) 
		    ss = ss.substring(1);

		// ">"ο
		while (ss.indexOf(">") == 0) {
		    level++;
		    ss = ss.substring(1);
		    ss = ss.trim();
		    while (ss.startsWith("")) 
			ss = ss.substring(1);
		}
	    }

	    // 2001/10/31
	    // add prevToken
	    if (ss.equals("\n")) {
		if ( preToken.equals("\n")) ss = "";
		else {
		    preToken = ss;
		    continue;
		}
	    }
	    preToken = ss;

	    // ʸ󤬤ꡢġƱ٥ʸǤꡢġ
	    // ˥̵ɲä
	    if ( ss.length() != 0 && 
		 preLevel == level && 
		 !trail ) { 
		groupString += ss;
		continue;
	    }
	    
	    //copy sentence with level
	    // ǽιԤ̵С<code>AllSentences</code>ɲä롣

	    if (preLevel != -1) {
		groups.add(new SentenceGroup(preLevel, groupString));  
		System.err.println("GroupString: " + groupString);
	    }
	    /*
	      if ( preLevel != -1 ) {
	      Vector v = divideBySentence(groupString, false);
	      Enumeration e = v.elements();
	      while(e.hasMoreElements()){
	      String sent = (String)e.nextElement();
	      if (sent.length() == 0) continue;
	      allSentences.add(new ASentence(sent, preLevel));
	      }
	      }
	    */
	    preLevel = level;
	    groupString = ss;
	}

	if (groupString.length() != 0) {
	    groups.add(new SentenceGroup(preLevel, groupString));
	    System.err.println("GroupString(Last): " + groupString + "\n");
	} // end of if (groupString.length() != 0)

	// ʸʬ롣

	Enumeration g = groups.elements();
	while (g.hasMoreElements()) {
	    SentenceGroup sg = (SentenceGroup)g.nextElement();
	    Vector v = divideBySentence(sg.getSentences(), false);
	    //copy sentence with level
	    Enumeration e = v.elements();
	    while(e.hasMoreElements()){
		String sent = (String)e.nextElement();
		allSentences.add(new ASentence(sent, sg.getLevel()));
	    }
	} // end of while (gs.hasMoreElements())
	
	/*
	  if ( groupString.length() != 0) {
	  Vector v = divideBySentence(groupString, false);
	  //copy sentence with level
	  Enumeration e = v.elements();
	  while(e.hasMoreElements()){
	  String sent = (String)e.nextElement();
	  allSentences.add(new ASentence(sent, preLevel));
	  }
	}
	*/

	Vector refSentences = null;
	try {
	    //ʸñ̤ǷǲϤԤ
	    int lines = 0;
	    Enumeration e = allSentences.elements();
	    while(e.hasMoreElements()) {
		ASentence aSen = (ASentence)e.nextElement();
		String y = Chasen.parse(aSen.getSentence());
		calc(y, lines++);
	    }
	    refSentences = checkSentence(upperSentence);
	} catch (Exception e) {
	    e.printStackTrace();
	}

	return refSentences;
    }

    /** 
     * print Abstracted Message
     */
    public void printMessage() {
	printMessage(false);
    }

    /** 
     * print Abstracted Message
     * @param boolean true if printHTML tag
     */
    public void printMessage(boolean htmlFile) {
	String msg = getMessage(htmlFile);
	System.err.print(msg);
	if (!htmlFile) {
	    WordOutLog.out.print(msg);
	} // end of if (htmlFile)
	
    }

    /** 
     * print Abstracted Message
     * @return String
     */
    public String getMessage() {
	return getMessage(false);
    }

    /** 
     * Get Abstracted Message
     * @return String
     */
    public String getMessage(boolean htmlFile) {
	int numOfPrint = 0;
	int numOfTotal = 0;
	final String x = ">>>>>>>>>>";
	final String xx = "            ";
	int preLevel = -1;
	String rv = "";
	Enumeration e = allSentences.elements();
	while(e.hasMoreElements()) {
	    ASentence aSen = (ASentence)e.nextElement();
	    if ( aSen.getShow()) {
		// htmlFileؤνϤʤNameLabel
		if (preLevel != aSen.getLevel()) rv += "\n";

		if (htmlFile) {
		    //		    for (int i =0; i<aSen.getLevel(); i++)
		    //			rv += "<ul>";
		    rv += xx.substring(0,aSen.getLevel()*2);
		} else rv += x.substring(0,aSen.getLevel());

		if (htmlFile && aSen.getLabel() != -1) {
		    rv += "<a name=\"";
		    rv += (new Integer(aSen.getLabel())).toString();
		    rv += "\"></a><u><font >";
		}
		if (htmlFile && aSen.getToLabel() != -1 ) {
		    rv += "<a href=\"#";
		    rv += (new Integer(aSen.getToLabel())).toString();
		    rv += "\">";
		}

		//if ( Preface.debug  ) rv += "("+aSen.getCount() + ")";

		rv += aSen.getSentence();

		if (htmlFile && aSen.getToLabel() != -1 ) rv += "</a>";
		if (htmlFile && aSen.getLabel() != -1 ) rv += "</font></u>";

		if (htmlFile) {
		    // 		    for (int i =0; i<aSen.getLevel(); i++)
		    //			rv += "</ul>";
		}

		rv += "\n";
		numOfPrint++;
		preLevel = aSen.getLevel();
	    }
	    numOfTotal++;
	}

	rv += "Print = " + numOfPrint;
	rv += "\n";
	rv += "Total = " + numOfTotal;
	rv += "\n";
	rv += "-----------------------------------";
	rv += "\n";
	return rv;
    }

    /**
     * @param s
     * @param level
     * @return Vector
     */
    private Vector divideBySentence(String s) {
	return divideBySentence(s, true);
    }
    
    /**
     * Describe <code>divideBySentence</code> method here.
     *
     * @param s
     * @param all 
     * @return Vector
     */
    private Vector divideBySentence(String s, boolean all) {
	Vector sV = new Vector();
	String buf = "";
	/** Separators */
	final String seps[] = {"", "", ".", "?", "", ":-)"};

	while (true) {
	    int pMax = 10000;
	    String sep = seps[0];

	    // find minimum separator 
	    for(int j=0;j<seps.length;j++) {
		int p = s.indexOf(seps[j]);
		if (p == -1) continue;

		if ( p > pMax ) continue;
		
		// 2002/11/06
		// ѥ졼'.'ξϡʸ
		// 뤤ȾѥڡޤϡԤξΤߡ
		// ѥ졼ǧ롣
		if (seps[j].equals(".")) {
		    if (s.length() > p + 1) {
			char c = s.charAt(p+1);
			switch (c) {
			case ' ':
			case '':
			    break;
			default:
			    continue;
			} // end of switch (c)
		    } // end of if (s.length() >= p + 1)
		} // end of if (seps[j].equals("."))
		
		pMax = p;
		sep = seps[j];
	    }

	    int l = s.length();
	    if ( pMax > l || pMax == l - 1) {
		// add by Jun Kurabe
		// 2001/11/04
		// l !=1 
		if ( l != 1 ) buf += s;
		sV.add(buf);
		break;
	    } 

	    // add by Jun Kurabe
	    // 2001/11/04
	    // pMax !=0 
	    if (pMax != 0) buf += s.substring(0, pMax+sep.length());
	    // 2002/11/06
	    //	    if ( !sep.equals(".")) {
	    sV.add(buf);
	    buf = "";

	    // Comment out 
	    // 2002/11/06
	    //	    } else {
	    // ᥤ륢ɥ쥹URLʸȤƥХХˤʤ
	    /*		String sbuf = s.substring(0,pMax+1);
			for(int i =0; i<sbuf.length(); i++) {
			char ch = sbuf.charAt(i);
			if ( ch == '@' ) continue;
			if ( ch == '-' ) continue;
			if ( ch == '_' ) continue;
			if ( ch == '/' ) continue;
			if ( ch == ':' ) continue;
			if ( ch == '.' ) continue;
			if (Character.isUpperCase(ch)) continue;
			if (Character.isLowerCase(ch)) continue;
			if (Character.isDigit(ch)) continue;

			sV.add(buf);
			buf = "";
			break;
		    } */
		//	    }
	    s = s.substring(pMax+sep.length());
	}

	return sV;
    }

    /** 
     * ̤ˡиñϿ
     * @param s
     * @param lines
     */
    private void calc(String s, int lines) {
	StringTokenizer lineSt = new StringTokenizer(s, "\n");
	while(lineSt.hasMoreTokens()) {
	    String line = lineSt.nextToken();
	    //	System.err.println("line = " +line);
	    //  UnixǤǥƥ󥹤νEOSǼƤ롣
	    if ( line.equals("EOS") ) continue;
	    if ( line.equals("EOM") ) continue;

	    StringTokenizer blockSt = new StringTokenizer(line);
	    
	    int i = 0;
	    String org = blockSt.nextToken();
	    String kana = blockSt.nextToken();
	    String kihon = blockSt.nextToken();
	    String hinsi = blockSt.nextToken();

	    MailString kihon2 = new MailString(kihon);

	    if (
		// ̾ǡ̾졢졢Ω̵Τԥååפ
		(hinsi.indexOf("̾") != -1 && 
		 ( hinsi.indexOf("̾") == -1  &&
		   hinsi.indexOf("") == -1  &&
		   hinsi.indexOf("Ω") == -1  )
		 ) || (
		       //̤θǡѿʪĤ
		       hinsi.indexOf("̤θ") != -1 &&
		       kihon2.isLetterAndDigit()
		       )
		 ) {
		//	    System.err.println(hinsi);
		//		if (hinsi.indexOf("̤θ") != -1) System.err.println(kihon);
		Integer ix = (Integer)wordCnt.get(kihon);
		if ( ix == null ) {
		    wordCnt.put(kihon, new Integer(1));
		    Vector place = new Vector();
		    place.add(new Integer(lines));
		    wordPlace.put(kihon, place);
		} else{
		    wordCnt.put(kihon, new Integer(ix.intValue() + 1));
		    Vector place = (Vector)wordPlace.get(kihon);
		    place.add(new Integer(lines));
		    //		wordPlace.put(kihon, place);
		}
	    }
	}

    }

    /**
     * Describe <code>showMostUsedWords</code> method here.
     *
     * @param maxLevel an <code>int</code> value
     * @param kv a <code>KV[]</code> value
     */
    private void showMostUsedWords(int maxLevel, KV[] kv) {
	System.err.println("JMax: " + maxLevel);	
	WordOutLog.out.println("JMax: " + maxLevel);	
    }

    /**
     * Describe <code>checkSentence</code> method here.
     *
     * @param upperSentence a <code>Vector</code> value
     * @return a <code>Vector</code> value
     */
    private Vector checkSentence(Vector upperSentence) {
	/** Top n */
	int jMax = maxLevel;

	/** count array length */
	int n = wordCnt.keySet().size();
	if ( n == 0) return null;

	KV nKv[] = new KV[n];
	int i = 0;
	Iterator it = (wordCnt.keySet()).iterator();
	while(it.hasNext()) {	
	    String ss = (String)it.next();
	    nKv[i++] = new KV(ss, ((Integer)wordCnt.get(ss)).intValue());
	}

	// Sort by Word count
	Arrays.sort(nKv, new KV());
	int maxCnt = nKv[0].n;
	int j = 0;

	showMostUsedWords(jMax, nKv);

	for(i=0;i<n;i++) {
	    if ( maxCnt != nKv[i].n ) {
		if (i > jMax-1) {
		    j=jMax+1;
		} // end of if (i > jMax)
		maxCnt = nKv[i].n;
	    }

	    // 
	    if ( j < jMax ) {
		System.err.print("*"); 
		WordOutLog.out.print("*"); 
	    }
	    else {
		// ̳
		System.err.print(" ");
		WordOutLog.out.print(" ");
	    }
	    System.err.println(nKv[i].key + "<<" + nKv[i].n + ">>");
	    WordOutLog.out.println(nKv[i].key + "<<" + nKv[i].n + ">>");

	    Enumeration e = ((Vector)wordPlace.get(nKv[i].key)).elements();
	    while(e.hasMoreElements()){
		int p = ((Integer)e.nextElement()).intValue();
		//		System.err.print(p +",");
		if ( j < jMax ) {
		    ASentence aSen = (ASentence)allSentences.elementAt(p);
		    aSen.setShow(true);
		    aSen.addCount();
		}
	    }
	    //	    System.err.println("");
	}
	return threeSentences(upperSentence);
    }

    /**
     * Ѹʸ(n, 3Ĥ)Ĥ
     * ΥᥤǰѤƤʸ֤
     * @param upperSentence ѤƤʸ
     * @return Vector 
     */
    private Vector threeSentences(Vector upperSentence) {
	int preLevel = -1;
	int preLine = -1;
	int showLines = 0;
	boolean isTop = true;
	final int linesMax = 3;
	Vector refSentence = new Vector();
	Enumeration e = allSentences.elements();
	while(e.hasMoreElements()) {
	    ASentence as = (ASentence)e.nextElement();
	    //ʬֻʤ
	    if ( as.getLevel() == 0 ) {
		if (!isTop) {
		    //ʸ鼫ʬΰոѤäʤ
		    if (preLevel != as.getLevel()) {
			((ASentence)allSentences.elementAt(preLine)).setShow(true);
			((ASentence)allSentences.elementAt(preLine)).setToLabel(++MailSentence.currentLabel);
			//refSentence.add(((ASentence)allSentences.elementAt(preLine)).getSentence());
			refSentence.add(((ASentence)allSentences.elementAt(preLine)));
			showLines=0;
			
		    }
		    //ʸ̤ʤ
		    if (showLines<MailSentence.SENTENCES) as.setShow(true);
		    showLines++;

		    // ѤƤʸʤлĤ
		    if ( upperSentence != null ) {
			Enumeration use = upperSentence.elements();
			while(use.hasMoreElements()) {
			    ASentence rs = (ASentence)use.nextElement();
			    String upperS = rs.getSentence();
			    if (as.getSentence().equals(upperS)) {
				as.setShow(true);
				as.setLabel(rs.getToLabel());
			    }
			}
		    }
		}
	    } else isTop = false;
	    preLevel = as.getLevel();
	    preLine++;
	}
	return refSentence;
    }

    /**
     * Crear Current Label
     */
    public static void clearCurrentLabel() {
	currentLabel = -1;
    }

    /**
     * Describe <code>setMaxLevel</code> method here.
     *
     * @param n an <code>int</code> value
     */
    public void setMaxLevel(int n) {
	maxLevel = n;
    }

    /**
     * Describe <code>setMailProperties</code> method here.
     *
     * @param mp a <code>MailProperties</code> value
     */
    public void setMailProperties(MailProperties mp) {
	this.mp = mp;
    }

    /** */
    private String s = null;
    /** */
    private HashMap wordCnt = null;
    /** */
    private HashMap wordPlace = null;
    /** */
    private Vector allSentences = null;

    /** */
    public static final int SENTENCES = 3;
    /** */
    public static final int TOPWORDS= 3;
    /** */
    public static final int TOPWORDSALL = 3;

    /** */
    private static int currentLabel = -1;

    /** */
    private int maxLevel = TOPWORDS;

    /** */
    private MailProperties mp = null;
}

/**
 * Describe class <code>ASentence</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class ASentence {
    /**
     * Creates a new <code>ASentence</code> instance.
     *
     * @param sentence 
     * @param level
     */
    ASentence(String sentence, int level) {
	this.sentence = sentence;
	this.level = level;
	this.count = 0;
    }

    /** 
     * Get Sentence
     * @return String
     */
    String getSentence() {
	return this.sentence;
    }

    /** 
     * Set this sentence show
     * @param show
     */
    void setShow(boolean show) {
	this.show = show;
    }

    /** 
     * @return boolean
     */
    boolean getShow() {
	return this.show;
    }

    /** 
     * Level֤
     * @return int
     */
    int getLevel() {
	return level;
    }

    /** 
     * ñδޤޤƤû롣
     * @param n ñδޤޤƤ
     */
    void addCount(int n) {
	count += n;
    }

    /** 
     * ñδޤޤƤ򣱸Ĥû롣
     */
    void addCount() {
	count++;
    }

    /** 
     * ޤޤƤñο֤
     * @return int
     */
    int getCount() {
	return count;
    }

    /**
     * HTMLѴΥ٥Ͽ롣
     * @param label Ͽ٥
     */
    void setLabel(int label) {
	this.label = label;
    }

    /**
     * ٥֤
     * @return int
     */
    int getLabel() {
	return this.label;
    }

    /** 
     * Υ٥ꤹ롣
     * @param toLabel
     */
    void setToLabel(int toLabel) {
	this.toLabel = toLabel;
    }

    /**
     * toLabel 
     * @return int
     */    
    int getToLabel() {
	return this.toLabel;
    }


    /** */
    private String sentence = null;
    /** Line Number */
    private int level = -1;
    /** Line Number */
    private boolean show = false;
    /** Count */
    private int count = 0;
    /** Label for HTML 
    * ٥ϿͷǤ롣
    */
    private int label = -1;
    /** */
    private int toLabel = -1;
}

/**
 * Describe class <code>KV</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class KV 
    implements Comparator {

    /**
     * Creates a new <code>KV</code> instance.
     *
     */
    KV() {
    }

    /**
     * Creates a new <code>KV</code> instance.
     *
     * @param key
     * @param n
     */
    KV(String key, int n) {
	this.key = key;
	this.n = n;
    } 

    /**
     * Describe <code>compare</code> method here.
     *
     * @param o1
     * @param o2
     * @return an <code>int</code> value
     */
    public int compare(Object o1, Object o2) {
	if (((KV)o1).n < ((KV)o2).n) return 1;
	if (((KV)o1).n == ((KV)o2).n) return 0;
	return -1;
    }

    /**
     * Describe <code>equals</code> method here.
     *
     * @param obj
     * @return boolean
     */
    public boolean equals(Object obj) {
	return false;
    }

    /** */
    public String key = null;

    /** */
    public int n = -1;
}

/**
 * Describe class <code>SentencesLevel</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class SentencesLevel {
    /**
     * Creates a new <code>SentencesLevel</code> instance.
     *
     * @param level an <code>int</code> value
     * @param sentences a <code>Vector</code> value
     */
    SentencesLevel(int level, Vector sentences) {
	this.level = level;
	this.sentences = sentences;
    }

    /**
     * Describe <code>containts</code> method here.
     *
     * @param words
     * @return SentenceLevel
     */
    SentencesLevel containts(Vector words) {
	boolean rv = false;
	Enumeration wordEnu = words.elements();
	Vector sent = new Vector();
	while(wordEnu.hasMoreElements()){
	    String w = (String)wordEnu.nextElement();
	    Enumeration senEnu = this.sentences.elements();
	    while(senEnu.hasMoreElements()) {
		String s = (String)senEnu.nextElement();
		if ( s.indexOf(w) == -1 ) continue;
		sent.add(s);
	    }
	}
	if (sent.size() == 0) return null;
	return new SentencesLevel(this.level, sent);
    }

    /** */
    private int level = 0;
    /** */
    private Vector sentences = null;
}

/**
 * Describe class <code>SentenceGroup</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 * @date 2002/11/09
 */
class SentenceGroup {
    /**
     * Creates a new <code>SentenceGroup</code> instance.
     *
     * @param level an <code>int</code> value
     * @param sentences a <code>String</code> value
     */
    public SentenceGroup(int level, String sentences) {
	this.level = level;
	this.sentences = sentences;
    }

    /**
     * Describe <code>getLevel</code> method here.
     *
     * @return an <code>int</code> value
     */
    public int getLevel() {
	return level;
    }

    /**
     * Describe <code>getSentences</code> method here.
     *
     * @return a <code>String</code> value
     */
    public String getSentences() {
	return sentences;
    }

    /** */
    private int level = -1;
    /** */
    private String sentences = null;
}
