/*
  (c) 2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/18 22:57:19 jun>

  $Revision$
  $Date$
*/

import LinkInfo;

/**
 * Describe class <code>NodeState</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */

public class NodeState {

    // state 
    public static final int NONE = 0;
    public static final int MARKED = 1;
    public static final int TEMPORARY_MARKED = 2;
    public static final int SELECTED = 3;
    public static final int PASSED = 4;

    /**
     * Creates a new <code>NodeState</code> instance.
     *
     * @param id a <code>String</code> value
     * @param state an <code>int</code> value
     */
    public NodeState() {
    }

    public NodeState(String id, int state) {
	this.id = id;
	this.state = state;
    }

    /**
     * Describe <code>getId</code> method here.
     *
     * @return a <code>String</code> value
     */
    public String getId () {
	return id;
    }

    /**
     * Describe <code>setId</code> method here.
     *
     * @param id a <code>String</code> value
     */
    public void setId(String id) {
	this.id = id;
    }

    /**
     * Describe <code>getState</code> method here.
     *
     * @return an <code>int</code> value
     */
    public int getState () {
	return state;
    }

    /**
     * ơꤹ
     *
     * @param newState an <code>int</code> ơ
     */
    public void setState(int newState) {
	this.state = newState;
    }

    /** */
    protected String id = null;
    /** */
    protected int state = NONE;
}

/**
 * Describe class <code>AddressNodeState</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class AddressNodeState 
    extends NodeState {

    /**
     * Creates a new <code>AddressNodeState</code> instance.
     *
     * @param address a <code>String</code> value
     * @param mode an <code>int</code> value
     * @param linkInfo a <code>LinkInfo</code> value
     */
    public AddressNodeState (String address, int state, 
			     LinkInfo linkInfo, double angle) {
	super();

	this.id = address;
	this.state = state;
	this.linkInfo = linkInfo;
	this.angle = angle;

	System.err.print("address:"+address);
	System.err.print(",state:"+state);
	System.err.print(",linkInfo:"+linkInfo);
	System.err.println(",angle:"+angle);
    }

    /**
     * Describe <code>getLinkInfo</code> method here.
     *
     * @return a <code>LinkInfo</code> value
     */
    public LinkInfo getLinkInfo() {
	return linkInfo;
    }

    public double getAngle() {
	return angle;
    }

    /** */
    LinkInfo linkInfo = null;
    double angle = 0.0d;
}
