/*
  (c) 2002,2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/26 00:26:23 jun>


 Created by Jun Kurabe
 Data: $Date$
 Revision: $Revision$

*/

//package jp.co.lmer.mail;

import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Locale;
import java.util.Properties;
import java.util.Set;
import java.util.Vector;
import java.io.*;
import javax.mail.*;
import javax.activation.*;

import EDU.auburn.VGJ.algorithm.tree.TreeAlgorithm;
import EDU.auburn.VGJ.gui.GraphCanvasInterface;
import EDU.auburn.VGJ.gui.GraphCanvas;
import EDU.auburn.VGJ.graph.Node;
import EDU.auburn.VGJ.util.DDimension;

import Chasen;
import MailFieldConvert;
import MailFile;
import MailFileException;
import MailFolder;
import MailGraph;
import MailMessage;
import MailPopup;
import MailProperties;
import MailScrolledPanel;
import MailSentence;
import PrefaceDebug;
import Reference;
import Selection;
import SelectionListener;
import SizeMenu;
import StartBrowser;
import ThreadWord;
import TWData;
//import VisualSearch;
import WordPanel;
import PrefaceLog;
import WordOutLog;

/**
 * Describe class <code>Preface</code> here.
 *
 * @author Jun Kurabe (jun-krb@mars.dti.ne.jp )
 * @version 1.0
 */
public class Preface {

    public static final int FRAME_WIDTH = 700;
    public static final int FRAME_HEIGHT = 600;
    
    static {
	new WordOutLog();
    }
    /** 
     *
     * @param argc ץѥƥեΥѥ
     */
    public static void main(String argc[]) {
	try {
	    String fp = null;
	    if (argc.length > 0) fp = argc[0];

	    // ѥ᡼İʾʤСǥХå⡼ɤˤ롣
	    if (argc.length > 1  ) { 
		PrefaceDebug.setStatus(false);
		debug = false;
	    }

	    // Chasen ư롣
	    try {
		Chasen.parse("preface");		 
	    } catch (Exception e) {
		System.err.println("Chasen NotFound");
		System.exit(1);
	    } // end of try-catch
	    
	    // ץѥƥեƤɤߤȤ
	    mp = new MailProperties(fp);

	    // ȴط
	    Reference ref = new Reference();

	    MailFile mf = new MailFile(ref, mp);
	    mf.open();

	    // ġPresentation롣
	    PrefaceFrame aFrame = new PrefaceFrame(mf, ref, mp);
	    System.err.println("Messages = " + ref.size());
	    aFrame.show();
	    aFrame.validate();

	    TreeAlgorithm alg = new TreeAlgorithm('d');
	    //	    alg.compute(aFrame.graph, aFrame.gc);
	    //	    aFrame.gc.update(true);
	} catch (MailFileException e) {
	    e.printStackTrace();
	} catch (FileNotFoundException e) {
	    System.err.println("ץѥƥե뤬ޤ");
	} catch (IOException e) {
	    System.err.println("ץѥƥեɤޤ");
	}
    }


    /** */
    public static MailProperties mp = null;

    /** */
    public static boolean debug = false;

    /** 
     * 줿HTMLեΥե̾
     */
    public static String htmlFileName = "/tmp/abstractmail.html";
}

/**
 * Describe class <code>PrefaceFrame</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class PrefaceFrame 
    extends Frame 
    implements ActionListener {

    static final String MAXMENULABEL = "MaxLevel: ";

    /** 
     *
     * @param mf Mail File Object 
     * @param ref
     */
    public PrefaceFrame (MailFile mf, Reference ref, MailProperties mp) {
	super();
	setLocale(Locale.JAPANESE);

	/* */
	setSize(Preface.FRAME_WIDTH,Preface.FRAME_HEIGHT);
	//	setSize(700,800);
	//	setSize(700,700);
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	setLayout(gbl);

	/* Create object*/
	// ˥塼롣
	MenuBar mb = new MenuBar();
	setMenuBar(mb);

	//maxLevelMenu = new Menu(MAXMENULABEL + MailSentence.ABSMAXLEVEL);
	maxLevelMenu = new Menu(MAXMENULABEL + MailSentence.ABSDEFAULTLEVEL);
	for (int i = 0; i <= MailSentence.ABSMAXLEVEL; i++)  {
	    MenuItem menuItem = new MenuItem((new Integer(i)).toString());
	    menuItem.addActionListener(this);
	    maxLevelMenu.add(menuItem);
	} // end of for (int i = 0; i < MAXLEVEL; i++) )
    
	mb.add(maxLevelMenu);

	sizeMenu = new SizeMenu();
	mb.add(sizeMenu);
	sizeMenu.setFrame(this);

	graph = new MailGraph();
	mgc = new MailGraphCanvas(graph,this);
	viewPanel = new MailScrolledPanel(mgc);

	sizeMenu.setMailGraphCanvas(mgc);
	/*
	  int fId = graph.insertNode();
	  Node node = graph.getNodeFromIndex(fId);
	  node.setBoundingBox(300.0d, 40.0d);
	  node.setShape(Node.RECTANGLE);
	*/
	viewPanel.setSize(400,600);

	// ᥤʸɽꥢ
	MailContents aContents = new MailContents(ref);
	// ޥ꡼ɽꥢ
	AbsContents absContents = new AbsContents(ref, mp);
	// ֥̾ɽꥢ
	subjectList = new SubjectList(12, mf, aContents);
	// ե
	FolderList folderList = new FolderList(12, mf, subjectList, mp);
	// ɽɥ
	MailGraphWindow mgw = new MailGraphWindow();

	// ñ쥳ޥWindow
	WordPanel wordPanel = new WordPanel();
	// 2002/11/08
	//	wordPanel.setMailGraphWindow(mgw);
	// ɥѥͥȥեɥϢŤ
	wordPanel.setMailGraphCanvas(mgc);
	wordPanel.setVisible(false);

	vsPanel = createVSPanel(this,ref);
	vsPanel.setVisible(false);

	// ɽܥ
	CmdButton cmdButton = new CmdButton("Graph", ref, mgw, wordPanel, mgc);
	Selection.addListener(cmdButton);
	cmdButton.setVisible(false); // 2002/11/08

	// CmdButton cmdButton = new CmdButton("Graph", ref, this);
	// ޥ꡼ܥ
	AbsButton absButton = new AbsButton("Summary", ref, absContents, mp);
	Selection.addListener(absButton);
	// ޥ꡼ܥ (եꥢ)
	AbsButton2 absButton2 = new AbsButton2("Summary From Graph", ref, absContents, mgw, mgc, mp);
	//	absButton2.setVisible(false);

	// åɤñɽܥ
	ThreadWordButton threadWordButton = new ThreadWordButton("WordsInThread",ref,mgw,mgc);
	//	threadWordButton.setVisible(false);

	// ᥤñɽܥ
	MailWordButton mailWordButton = new MailWordButton("WordsInMail",ref,mgw);
	mailWordButton.setVisible(false); // 2002/11/10
	// ܥ¾ѥ֥
	CheckboxGroup textGraphicsGroup = new CheckboxGroup();

	TextGraphicsListener tgl = new TextGraphicsListener();
	tgl.setWordPanel(wordPanel);
	tgl.setMailGraphWindow(mgw);
	tgl.setMailGraphCanvas(mgc);
	tgl.setMailScrolledPanel(viewPanel);
	tgl.setReference(ref);

	// Textܥ
	Checkbox textButton = new Checkbox("Text", true, textGraphicsGroup);

	// Graphicsܥ
	GraphicsCheckbox graphicsButton = new GraphicsCheckbox("Graphics", false, textGraphicsGroup);
	graphicsButton.setEnabled(false);
	Selection.addListener(graphicsButton);

	Checkbox vsButton = new Checkbox("VisualSearch", false, textGraphicsGroup);
	textButton.addItemListener(tgl);
	graphicsButton.addItemListener(tgl);
	vsButton.addItemListener(tgl);

	Vector textGroup = new Vector();
	textGroup.add(folderList);
	textGroup.add(subjectList);
	// textGroup.add(absButton);

	Vector graphicsGroup = new Vector();
	//	graphicsGroup.add(gc);
	graphicsGroup.add(viewPanel);
	graphicsGroup.add(wordPanel);
	// graphicsGroup.add(absButton2);
	// graphicsGroup.add(threadWordButton);

	Vector vsGroup = new Vector();
	vsGroup.add(vsPanel);

	Vector otherGroup = new Vector();
	otherGroup.add(aContents);
	otherGroup.add(absContents);

	tgl.addGroups(textGroup, graphicsGroup, vsGroup, otherGroup);

	// ᥤξɽѥݥåץå
	MailPopup mpu = new MailPopup(mgw, ref);

	// Visual Search Area
	//	visualSearch = new VisualSearch(this, ref);
	//	visualSearch.show();

	/* setup listeners */
	this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	//	this.addWindowListener(new AFrameAdapter());
	mgw.addCanvasAdapter(aContents);
	mgw.addCanvasAdapter(mpu);

	mgc.addCanvasAdapter(aContents);
	mgc.addCanvasAdapter(mpu);

	threadWordButton.setWordPanel(wordPanel);
	/* set layout */
	int y = 0;

	Panel topPanel = new Panel();
	GridBagLayout gblTop = new GridBagLayout();
	GridBagConstraints gbcTop = new GridBagConstraints();
	topPanel.setLayout(gblTop);
	
	// cmdButton
	gbcTop.weightx = 1;
	gbcTop.weighty = 1;
	gbcTop.gridx = 0;
	gbcTop.gridy = y;
	gbcTop.gridwidth = 1;
	gbcTop.gridheight = 1;
	// gbcTop.fill = GridBagConstraints.HORIZONTAL;
	gbcTop.fill = GridBagConstraints.NONE;
	gblTop.setConstraints(cmdButton, gbcTop);
	topPanel.add(cmdButton);

	// absButton
	gbcTop.weightx = 1;
	gbcTop.weighty = 1;
	gbcTop.gridx = 1;
	gbcTop.gridy = y;
	gbcTop.gridwidth = 1;
	gbcTop.gridheight = 1;
	//	gbcTop.fill = GridBagConstraints.BOTH;
	gblTop.setConstraints(absButton, gbcTop);
	topPanel.add(absButton);

	// absButton2
	gbcTop.weightx = 1;
	gbcTop.weighty = 1;
	gbcTop.gridx = 2;
	gbcTop.gridy = y;
	gbcTop.gridwidth = 1;
	gbcTop.gridheight = 1;
	//	gbcTop.fill = GridBagConstraints.BOTH;
	gblTop.setConstraints(absButton2, gbcTop);
	topPanel.add(absButton2);

	// Mail ñܥ
	gbcTop.weightx = 1;
	gbcTop.weighty = 1;
	gbcTop.gridx = 3;
	gbcTop.gridy = y;
	gbcTop.gridwidth = 1;
	gbcTop.gridheight = 1;
	//	gbcTop.fill = GridBagConstraints.BOTH;
	gblTop.setConstraints(mailWordButton, gbcTop);
	topPanel.add(mailWordButton);

	// Thread ñܥ
	gbcTop.weightx = 1;
	gbcTop.weighty = 1;
	gbcTop.gridx = 4;
	gbcTop.gridy = y;
	gbcTop.gridwidth = 1;
	gbcTop.gridheight = 1;
	//	gbcTop.fill = GridBagConstraints.BOTH;
	gblTop.setConstraints(threadWordButton, gbcTop);
	topPanel.add(threadWordButton);

	// Textܥ
	gbcTop.gridx = 5;
	gblTop.setConstraints(textButton, gbcTop);
	topPanel.add(textButton);
	// Graphics ܥ
	gbcTop.gridx = 6;
	gblTop.setConstraints(graphicsButton, gbcTop);
	topPanel.add(graphicsButton);
	// VisualSearchButton
	gbcTop.gridx = 7;
	gblTop.setConstraints(vsButton, gbcTop);
	topPanel.add(vsButton);
	// TopPanel λ

	// TopPanelɲ
	gbc.weightx = 0;
	gbc.weighty = 1;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 1; 
	gbc.fill = GridBagConstraints.HORIZONTAL;
	gbl.setConstraints(topPanel, gbc);
	add(topPanel);

	// Ԥɲ
	y++;

	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 4; 
	//	gbc.gridheight = 3; 
	gbc.fill = GridBagConstraints.VERTICAL;
	gbl.setConstraints(vsPanel, gbc);
	add(vsPanel);

	//folderList ե
	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 1;
	gbc.gridheight = 1; 
	//	gbc.gridheight = 3; 
	gbc.fill = GridBagConstraints.BOTH;
	gbl.setConstraints(folderList, gbc);
	add(folderList);

	//subjectList ֥Ȱ
	gbc.weightx = 0;
	gbc.gridx = 1;
	gbc.gridy = y;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbl.setConstraints(subjectList, gbc);
	add(subjectList);

	// GraphWindow
	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 1;
	gbl.setConstraints(viewPanel, gbc);
	add(viewPanel);

	y++;
	// Word Panel
	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 1;
	gbl.setConstraints(wordPanel, gbc);
	add(wordPanel);


	// Ťʤβ
	y++;
	Label dummyLabel = new Label();
	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 1;
	gbl.setConstraints(dummyLabel, gbc);
	add(dummyLabel);

	y++;
	//MailContents
	gbc.weightx = 0;
	//	gbc.gridx = 1;
	gbc.gridx = 0;
	gbc.gridy = y;
	//	gbc.gridwidth = 4;
	gbc.gridwidth = 2;
	gbc.gridheight = 1;
	gbl.setConstraints(aContents, gbc);
	add(aContents);

	// Ԥɲ
	y++;

	//AbsContents
	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 1;
	gbl.setConstraints(absContents, gbc);
	add(absContents);

	// Ԥɲ
	y++;

	//	setSize(getPreferredSize());

    }

    /**
     * Describe <code>createVSPanel</code> method here.
     *
     * @param parent a <code>Frame</code> value
     * @param ref a <code>Reference</code> value
     * @return a <code>Panel</code> value
     */
    private Panel createVSPanel(Frame parent, Reference ref) {
	Panel panel = new Panel();
	panel.setSize(Preface.FRAME_WIDTH, Preface.FRAME_HEIGHT-10);

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	panel.setLayout(gbl);

	VisualSearchArea visualSearchArea = new VisualSearchArea(parent, ref);
	VSCommandArea cmdArea = new VSCommandArea(parent, ref);	

	gbc.weightx = 10;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;

	gbc.fill = GridBagConstraints.VERTICAL;


	// Command Area

	gbc.gridx = 0;
	gbc.gridy = 0;
	gbc.gridwidth = 1;
	gbc.gridheight = 2;
	gbl.setConstraints(cmdArea, gbc);
	panel.add(cmdArea);

	Label label =  new Label ("ɽꥢ");
	gbc.gridx = 1;
	gbc.gridy = 0;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbl.setConstraints(label, gbc);
	panel.add(label);


	gbc.gridx = 1;
	gbc.gridy = 1;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbc.fill = GridBagConstraints.BOTH;
	gbl.setConstraints(visualSearchArea, gbc);
	panel.add(visualSearchArea);

	cmdArea.addSearchArea(visualSearchArea);
	return panel;
}

    /** 
     * close the window & shutdown the tool
     * @param e Window event occar in the frame
     */
    protected void processWindowEvent(WindowEvent e) {
	if (e.getID() == WindowEvent.WINDOW_CLOSING) {
	    System.exit(0);
	}
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e an <code>ActionEvent</code> value
     */
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	try {
	    maxLevel = Integer.parseInt(cmd);
	    maxLevelMenu.setLabel(MAXMENULABEL + maxLevel);
	    validate();
	} catch (NumberFormatException nfe) {
	} // end of try-catch
    }

    /**
     * Describe <code>getMaxLevel</code> method here.
     *
     * @return an <code>int</code> value
     */
    public int getMaxLevel() {
	return maxLevel;
    }

    /**
     * Describe <code>pointUp</code> method here.
     *
     * @param taret a <code>Component</code> value
     * @param x an <code>int</code> value
     * @param y an <code>int</code> value
     */
    public void pointUp(Component taret, int x, int y, String msgId) { }
    public void pointDown(Component taret, int x, int y, String msgId) { }

    public void setOffset() {
	//	DDimension tmp_dim = viewPanel.getOffset();
	//	portScroller_.setOffset(tmp_dim.width, tmp_dim.height);
    }

    /** */
    public MailGraphCanvas mgc = null;
    public MailScrolledPanel viewPanel = null;
    //    public ScrolledPanel viewPanel = null;
    /** */
    public MailGraph graph = null;
    /** */
    public MailGraphWindow mgw = null;

    /** */
    public SubjectList subjectList = null;

    private Menu maxLevelMenu = null;

    /** */
    private int maxLevel = 3;

    /** */
    private SizeMenu sizeMenu = null;

    /** */
    private int displaySize = 100;

    /** */
    private VisualSearch visualSearch = null;

    /** */
    private Panel vsPanel = null;
}

/**
 * Describe class <code>CmdButton</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class CmdButton 
    extends Button
    implements ActionListener, SelectionListener {

    /**
     * Creates a new <code>CmdButton</code> instance.
     *
     * @param name
     * @param ref
     * @param mgw a <code>MailGraphWindow</code> value
     * @param wp a <code>WordPanel</code> value
     * @param mgc a <code>MailGraphCanvas</code> value
     */
    public CmdButton (String name, 
		      Reference ref, 
		      MailGraphWindow mgw,
		      WordPanel wp,
		      MailGraphCanvas mgc
		      ) {
	super(name);
	setLocale(Locale.JAPANESE);

	addActionListener(this);

	this.ref = ref;
	this.mgw = mgw;
	this.wp = wp;
	this.mgc = mgc;

	setEnabled(false);
	/*
	  this.aFrame = aFrame;
	*/
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
	if (selected == null) return;

	wp.removeAll();
	mgw.clear();
	//	mgw.show();
	mgw.setVisible(false);
	if (mgw.isVisible()) {
	    mgw.draw(Selection.get(), ref);	     
	} // end of if (mgw.getVisible())

	mgc.setVisible(true);
	mgc.clear();
	//	mgc.show();
	if (mgc.isVisible()) {
	    mgc.draw(Selection.get(), ref);
	}
    }

    /**
     * Describe <code>selectionChanged</code> method here.
     *
     * @param msgId a <code>String</code> value
     */
    public void selectionChanged(String msgId) {
	selected = msgId;
	if (selected == null) {
	    setEnabled(false);
	} // end of if (selected == null)
	else {
	    setEnabled(true);
	} // end of else
    }

    /** */
    private MailGraphWindow mgw = null;
    /** */
    private MailGraphCanvas mgc = null;

    /** */
    private Reference ref = null;
    /** */
    private PrefaceFrame aFrame = null;

    /** */
    private WordPanel wp = null;

    /** */
    private String selected = null;
}

/**
 * Describe class <code>AbsButton</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class AbsButton 
    extends Button
    implements ActionListener, SelectionListener {

    /** 
     * Create Abstract Button Object
     * @param name Name of Button
     * @param ref Mail References
     * @param ac
     * @param mp
     */
    public AbsButton (String name, 
		      Reference ref, 
		      AbsContents ac,
		      MailProperties mp) {
	super(name);
	setLocale(Locale.JAPANESE);

	addActionListener(this);

	this.ref = ref;
	this.ac = ac;
	this.mp = mp;

	setEnabled(false);
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
	int n = ((PrefaceFrame)((Panel)getParent()).getParent()).getMaxLevel();
	if (selected == null) return;
	try {
	    PrefaceLog.start();
	    ac.setMaxLevel(n);
	    ac.change(selected);
	    PrefaceLog.finish();
	    String tmpFilePath = mp.getHTMLPath();
	    //	    StartBrowser.openBrowser(FILEPATH);
	} catch (MailFileException mfe) {
	    mfe.printStackTrace();
	}
    }

    /**
     * Describe <code>selectionChanged</code> method here.
     *
     * @param msgId a <code>String</code> value
     */
    public void selectionChanged(String msgId) {
	selected = msgId;

	if (selected == null) {
	    setEnabled(false);
	} // end of if (selected == null)
	else {
	    setEnabled(true);
	} // end of else
	
    }

    /** */
    private Reference ref = null;
    /** */
    private AbsContents ac = null;
    /** */
    private MailProperties mp = null;
    /** */
    private String selected = null;
    /** */
    static private final String FILEPATH = "/tmp/a.html";
    
}

/**
 * Describe class <code>AbsButton2</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class AbsButton2
    extends Button
    implements ActionListener {

    /** 
     * Create Abstract Button Object
     * @param name Name of Button
     * @param ref Mail References
     * @param ac  
     * @param mgw 
     * @param mp  
     */
    public AbsButton2(String name, 
		      Reference ref, 
		      AbsContents ac,
		      MailGraphWindow mgw,
		      MailGraphCanvas mgc,
		      // AFrame aFrame,
		      MailProperties mp) {
	super(name);
	setLocale(Locale.JAPANESE);

	addActionListener(this);

	this.ref = ref;
	this.ac = ac;
	this.mgw = mgw;
	this.mgc = mgc;
	/* 
	   this.aFrame = aFrame;
	*/
	this.mp = mp;
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
	/*
	  String msgId = aFrame.mgd.getSelectedMsgId();
	*/
	String msgId = mgw.getSelectedMsgId();
	if (msgId == null) {
	    msgId = mgc.getSelectedMsgId();
	    if (msgId == null) {
		return;
	    } // end of if (msgId == null)
	}

	try {
	    ac.change(msgId);
	    String tmpFilePath = mp.getHTMLPath();
	    //	    StartBrowser.openBrowser(FILEPATH);
	} catch (MailFileException mfe) {
	    mfe.printStackTrace();
	}
    }

    /** */
    private Reference ref = null;
    /** */
    private AbsContents ac = null;
    /** */
    private MailGraphWindow mgw = null;
    /** */
    private MailGraphCanvas mgc = null;

    /** */
    private MailProperties mp = null;
    /** */
    static private String FILEPATH = "/tmp/a.html";

    /** */
    private PrefaceFrame aFrame = null;

}

/**
 * Describe class <code>MailWordButton</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 * @date 2002/10/07
 */
class MailWordButton
    extends Button
    implements ActionListener {

    /**
     * Creates a new <code>MailWordButton</code> instance.
     *
     * @param name a <code>String</code> value
     * @param ref a <code>Reference</code> value
     * @param mgw a <code>MailGraphDrawing</code> value
     */
    MailWordButton(String name, Reference ref, MailGraphWindow mgw) {
	super(name);
	setLocale(Locale.JAPANESE);

	addActionListener(this);
	this.ref = ref;
	this.mgw = mgw;
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
	/*
	  String msgId = aFrame.mgd.getSelectedMsgId();
	*/
	String msgId = mgw.getSelectedMsgId();
	if (msgId == null) return;
	ThreadWord tw = new ThreadWord(ref);
	tw.countWordInThisMail(msgId);
	TWData twd[] = tw.getOrderedCount();

	int order = 0;
	int minN = -1;

	String inString = "*";

	for (int i=0; i<twd.length; i++) {
	    if (twd[i].getCount() != minN) {
		order++;
		minN = twd[i].getCount();
		if (order > MAXORDER) {
		    inString = " ";
		    //		    break;
		} // end of if (order > MAXORDER)
		
	    } // end of if (twd[i].getCount() != minN)
	    
	    System.out.println(inString + " " + i+" : "+twd[i].getString() + " : " + twd[i].getCount());
	} // end of for (int i=0; i<twd.length; i++))
    }

    /**
     * Describe variable <code>ref</code> here.
     *
     */
    private Reference ref = null;

    /**
     * Describe variable <code>mgw</code> here.
     *
     */
    private MailGraphWindow mgw = null;

    /**
     */
    private static final int MAXORDER = 3;

}

/**
 * Describe class <code>ThreadWordButton</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class ThreadWordButton
    extends Button
    implements ActionListener {

    /**
     * Creates a new <code>ThreadWordButton</code> instance.
     *
     * @param name a <code>String</code> value
     * @param ref a <code>Reference</code> value
     * @param mgw a <code>MailGraphWindow</code> value
     */
    ThreadWordButton(String name, Reference ref, MailGraphWindow mgw,
		     MailGraphCanvas mgc) {
	super(name);
	setLocale(Locale.JAPANESE);

	addActionListener(this);
	this.ref = ref;
	this.mgw = mgw;
	this.mgc = mgc;
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
	/*
	  String msgId = aFrame.mgw.getSelectedMsgId();
	*/
	String msgId = mgw.getSelectedMsgId();
	if (msgId == null) {
	    msgId = mgc.getSelectedMsgId();
	    if (msgId == null) {
		return;
	    } // end of if (msgId == null)
	}
	ThreadWord tw = new ThreadWord(ref);
	tw.countWordInThisThread(msgId);
	TWData twd[] = tw.getOrderedCount();
	
	//ߤκǾϽ
	int minN = -1;

	//Ϥ̤ο
	int order = 0;

	String inString = "*";
	for (int i=0; i<twd.length; i++) {
	    if (twd[i].getCount() != minN) {
		order++;
		minN = twd[i].getCount();
		if (order > MAXORDER) {
		    inString = " ";
		    //		    break;
		} // end of if (order > MAXORDER)
		
	    } // end of if (twd[i].getCount() != minN)
	    System.out.println(inString + " " + i+" : "+twd[i].getString() + " : " + twd[i].getCount());
	} // end of for (int i=0; i<twd.length; i++))

	if (wordPanel != null) {
	    wordPanel.add(tw);
	} // end of if (wp != null)
	
    }

    /**
     * Describe <code>setWordPanel</code> method here.
     *
     * @param wp a <code>WordPanel</code> value
     */
    public void setWordPanel(WordPanel wp) {
	this.wordPanel = wp;
    }

    /**
     * Describe variable <code>ref</code> here.
     *
     */
    private Reference ref = null;

    /**
     * Describe variable <code>mgw</code> here.
     *
     */
    private MailGraphWindow mgw = null;
    private MailGraphCanvas mgc = null;

    private static final int MAXORDER = 10;

    private WordPanel wordPanel = null;
}

/** */
class FolderList 
    extends List 
    implements ItemListener {
    /** 
     *
     * @param nRow
     * @param mf
     * @param sl
     * @param mp
     */
    public FolderList(int nRow, 
		      MailFile mf, 
		      SubjectList sl,
		      MailProperties mp) {
	super(nRow);
	setLocale(Locale.JAPANESE);
	try {
	    this.mf = mf;
	    subFolders = mf.getSubFolders(mp.getMailDir());
	    showList();
	    //	aList.makeVisible(0);

	} catch (MailFileException e) {
	    e.printStackTrace();
	}
	this.sl = sl;
	addItemListener(this);
    }

    /**
     * ꥹȤɽ롣
     *
     */
    private void showList () {
	//	this.setVisible(false);
	invalidate();
	Enumeration folders = subFolders.elements();
	while(folders.hasMoreElements()) {
	    MailFolder folder = (MailFolder)folders.nextElement();
	    int level = folder.getLevel();
	    StringBuffer sb = new StringBuffer();
	    for(int j=0;j<level;j++) 
		sb.append("");
	    
	    String s = sb.toString();
	    this.add(s + folder.getName());
	}
	//	this.setVisible(true);
	validate();
    }

    /**
     * Describe <code>getMailFolder</code> method here.
     *
     * @param index
     * @return MailFolder
     */
    public MailFolder getMailFolder(int index) {
	return (MailFolder)subFolders.elementAt(index);
    }

    /**
     * Describe <code>itemStateChanged</code> method here.
     *
     * @param e
     */
    public void itemStateChanged (ItemEvent e) {
	try { 
	    if ( e.getStateChange() == java.awt.event.ItemEvent.SELECTED ) {
		Integer item = (Integer)e.getItem();
	    
		sl.change(getMailFolder(item.intValue()));
	    };
	} catch (MailFileException me) {
	}
    }

    /** */
    private SubjectList sl = null;

    /** */
    private MailFile mf = null;

    /** */
    private Vector subFolders = null;
}

/**
 * ֥ȤΥꥹȤκɽ
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class SubjectList 
    extends List 
    implements ItemListener{

    /**
     * Creates a new <code>SubjectList</code> instance.
     *
     * @param nRow number of rows
     * @param mf Mail File Object
     * @param mc Mail Contents Object
     */
    public SubjectList(int nRow, MailFile mf, MailContents mc) {
	super(nRow);
	setLocale(Locale.JAPANESE);

	//	aList.makeVisible(0);
	this.mf = mf;
	this.mc = mc;
	addItemListener(this);
    }

    /**
     * Describe <code>change</code> method here.
     *
     * @param mFolder
     * @exception MailFileException
     */
    public void change(MailFolder mFolder ) 
	throws MailFileException  {
	try {
	    this.mFolder = mFolder;
	    showList();
	    //	    System.err.println("Font: " + this.getFont().toString());
	} catch (MessagingException e) {
	    e.printStackTrace();
	    throw new MailFileException();
	} 
    }

    /**
     * Show the Header Fields Value
     * @exception MessagingException 
     * @exception MailFileException
     */
    public void showList()
	throws MessagingException, MailFileException {    

	this.removeAll();
	Folder f = mf.getFolder(mFolder.getFullName());
	//	Message[] tmpMsgs = mf.getMessages(mFolder.getFullName());
	//	msgs = new MailMessage[tmpMsgs.length];
	// 2002/01/20
	// Message֥ȤȤΤǤϤʤե֥Ȥȥݥ󥿤ǥåؤˡѹ
	msgs = new MailMessage[f.getMessageCount()];
	//	if ( folderName != null) mf.getMessages(folderName);
	//	else mf.getMessages(urlName);
	Date[] dates = new Date[f.getMessageCount()];

	for (int i =0; i < msgs.length; i++) {
	    //	    msgs[i] = new MailMessage(tmpMsgs[i]);
	    msgs[i] = new MailMessage(f.getMessage(i+1));
	    dates[i] = msgs[i].getMessage().getSentDate();
	}

	for (int i=0; i< msgs.length; i++) {
	    for (int j=i+1; j<msgs.length; j++) {
		int k = dates[i].compareTo(dates[j]); 
		if (k<=0) continue;
		
		MailMessage tmp = msgs[i];
		msgs[i] = msgs[j];
		msgs[j] = tmp;

		Date sTmp = dates[i];
		dates[i] = dates[j];
		dates[j] = sTmp;
	    }
	}
	for ( int i =0;i <msgs.length; i++) {
	    Message msg = msgs[i].getMessage();
	    StringBuffer sb = new StringBuffer();

	    //getFrom(msg,sb);
	    //	    sb.append(":");
	    //	    this.getTo(msg,sb);
	    //	    sb.append(":");
	    String x = MailFieldConvert.convertFrom(msg) + "          ";
	    sb.append(msg.getSentDate().toString().substring(4,20));
	    sb.append(" | ");
	    sb.append(x.substring(0,20)); //
	    sb.append(" | ");
	    sb.append(MailFieldConvert.convertSubject(msg));
	    this.add(sb.toString());
	}
    } 

    /**
     * Add From Fields values to StringBuffer
     * @param msg a <code>Message</code> value
     * @param sb a <code>StringBuffer</code> value
     * @exception MailFileException throws when something 
     *            MessagingException occars
     */
    private void getFrom(Message msg, StringBuffer sb) 
	throws MailFileException {
	try {
	    Address[] froms = msg.getFrom();
	    if (froms != null) 
		for(int j=0;j<froms.length;j++) {
		    //		    if (j>0) System.err.print(", ");
		    //		    System.err.print(froms[j].toString());
		    sb.append(froms[j]);
		}
	    //	    System.err.println("");
	} catch ( MessagingException me) {
	    me.printStackTrace();
	    throw new MailFileException();
	}
    }

    /** 
     * Add To Fields values to StringBuffer
     * @param msg
     * @param sb 
     */
    private void getTo(Message msg, StringBuffer sb)  {
	try {
	    Address[] tos = msg.getRecipients(Message.RecipientType.TO);
	    if (tos != null) 
		for(int j=0;j<tos.length;j++) {
		    if (j>0) sb.append(", ");
		    sb.append(tos[j].toString());
		}
	} catch (MessagingException me) {
	    me.printStackTrace();
	    //	    throw new MailFileException();
	}
    }

    /** 
     * Get Message Object with index
     * @param idx index value
     * @return Message
     * @exception MailFileException
     */
    public Message getMail(int idx) 
	throws MailFileException {
	//	Message msgs[] = mf.getMessages(mFolder.getFullName());
	return msgs[idx].getMessage();
    }

    /**
     * Describe <code>itemStateChanged</code> method here.
     *
     * @param e Event occars in a Subject List Object
     */
    public void itemStateChanged (ItemEvent e) {
	try { 
	    //	System.err.println("Called");
	    if ( e.getStateChange() == java.awt.event.ItemEvent.SELECTED ) {
		Integer item = (Integer)e.getItem();
		//System.err.println("changed = " + item.toString());
		Message msg = getMail(item.intValue());
		mc.change(msg);
		
		PrefaceDebug.println("Bare Subject = " + MailFieldConvert.getBareSubject(msg),this);
		PrefaceDebug.println("Bare Subject = " + MailFieldConvert.getBareSubject(msg).length(),this);
		PrefaceDebug.println("Bare Subject = " + msg.getSentDate(),this);
	    };
	} catch (MailFileException me) {
	} catch (MessagingException me) {
	}
    }

    /** Mail Contents Object */
    private MailContents mc = null;

    /** */
    private MailFile mf = null;

    /** */
    private MailFolder mFolder = null;

    /** */
    private MailMessage[] msgs = null;
}

/**
 * ᥤʸɽ륨ꥢ
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class MailContents 
    extends TextArea 
    implements GraphCanvasInterface {
    /** */
    public static final int NOMESSAGE = -1;

    /**
     * Creates a new <code>MailContents</code> instance.
     *
     * @param ref a <code>Reference</code> value
     */
    public MailContents(Reference ref) {
	//	super("",11,60,TextArea.SCROLLBARS_VERTICAL_ONLY);
	super("",9,60,TextArea.SCROLLBARS_VERTICAL_ONLY);
	setLocale(Locale.JAPANESE);

	this.setEditable(false);
	//	this.mf = mf;
	this.ref = ref;
    }

    /**
     * show the contents of message
     * @param msg
     * @exception MailFileException if an error occurs
     */
    public synchronized void change(Message msg) 
	throws MailFileException {
	String body = "";
	setSelectionToMsg(msg);
	//	this.setText("\n");
	this.setText("From: " + MailFieldConvert.convertFrom(msg) + "\n");
	this.append("Date: " + MailFieldConvert.convertDate(msg) + "\n");
	this.append("Message-Id: " + MailFieldConvert.getMsgId(msg) + "\n");
	this.append("Subject: " + MailFieldConvert.convertSubject(msg) + "\n");
	this.append("\n");
	body = MailFieldConvert.getBodyText(msg);

	this.append(body);
	//	setEditable(true);
	setCaretPosition(0);
	//	setEditable(false);
    }

    /** 
     * Selection֥Ȥ򤵤줿MessageId򥻥åȤ롣
     * @param msg 
     */
    private void setSelectionToMsg(Message msg) {
	//	    String hdrs[] = msg.getHeader("Message-Id");	
	String id = MailFieldConvert.getMsgId(msg);
	Selection.set(id);
    }

    /**
     * Describe <code>pointUp</code> method here.
     *
     * @param target a <code>Component</code> value
     * @param x an <code>int</code> value
     * @param y an <code>int</code> value
     * @param msgId a <code>String</code> value
     */
    public void pointUp(Component target, int x, int y, String msgId) {
	try {
	    Message msg = ref.getMsg(msgId);
	    change(msg);
	} catch (MailFileException e) {
	    e.printStackTrace();
	} // end of try-catch
	
    }

    /**
     * Describe <code>pointDown</code> method here.
     *
     * @param target a <code>Component</code> value
     * @param x an <code>int</code> value
     * @param y an <code>int</code> value
     * @param msgId a <code>String</code> value
     */
    public void pointDown(Component target, int x, int y, String msgId) {
    }

    /**
     * Describe <code>setOffset</code> method here.
     *
     */
    public void setOffset() {
    }

    /** */
    private MailFile mf = null;

    /** */
    private Reference ref = null;

    /** */
    private String folderName = null;
    /** */
    private int index = NOMESSAGE;
}

/**
 * Describe class <code>TextGraphicsListener</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class TextGraphicsListener 
    implements ItemListener {
    /**
     * Creates a new <code>TextGraphicsListener</code> instance.
     *
     */
    public TextGraphicsListener() {
    }

    /**
     * Creates a new <code>TextGraphicsListener</code> instance.
     *
     * @param a a <code>Vector</code> value
     * @param b a <code>Vector</code> value
     */
    public TextGraphicsListener(Vector a, Vector b, Vector c, Vector d) {
	groupA = a;
	groupB = b;
	groupC = c;
	groupD = d;
    }

    /**
     * Describe <code>itemStateChanged</code> method here.
     *
     * @param e an <code>ItemEvent</code> value
     */
    public void itemStateChanged(ItemEvent e){
	Component c = null;
	if (e.getItem().toString().equals("Text")) {
	    c= changeVisibility(true,false,false,true);
	} // end of if (e.getItem().toString().equals("Text"))
	else if (e.getItem().toString().equals("Graphics")) {
	    c= changeVisibility(false,true,false,true);
	    actionPerformed();
	} // end of else
	else {
	    c= changeVisibility(false,false,true,false);
	} // end of else
	
	c.getParent().validate();
    }

    /**
     * Describe <code>changeVisibility</code> method here.
     *
     * @param a a <code>boolean</code> value
     * @param b a <code>boolean</code> value
     * @param c a <code>boolean</code> value
     * @param d a <code>boolean</code> value
     * @return a <code>Component</code> value
     */
    private Component changeVisibility(boolean a, 
				       boolean b, 
				       boolean c, 
				       boolean d){
	Component comp = null;
	for (int i = 0; i < groupA.size(); i++) {
	    ((Component)groupA.elementAt(i)).setVisible(a);
	} // end of for (int i = 0; i < Vector.size(); i++)
	for (int i = 0; i < groupB.size(); i++) {
	    ((Component)groupB.elementAt(i)).setVisible(b);
	} // end of for (int i = 0; i < Vector.size(); i++)
	for (int i = 0; i < groupC.size(); i++) {
	    ((Component)groupC.elementAt(i)).setVisible(c);
	    // System.err.println("Called: " + c);
	} // end of for (int i = 0; i < Vector.size(); i++)
	for (int i = 0; i < groupD.size(); i++) {
	    ((Component)groupD.elementAt(i)).setVisible(d);
	    comp = (Component)groupD.elementAt(i);
	} // end of for (int i = 0; i < Vector.size(); i++)
	return comp;
    }

    /**
     * Describe <code>addGroups</code> method here.
     *
     * @param a a <code>Vector</code> value
     * @param b a <code>Vector</code> value
     * @param c a <code>Vector</code> value
     * @param d a <code>Vector</code> value
     */
    public void addGroups (Vector a, Vector b, Vector c, Vector d) {
	groupA = a;
	groupB = b;
	groupC = c;
	groupD = d;
    }

    /**
     * Describe <code>setWordPanel</code> method here.
     *
     * @param wp a <code>WordPanel</code> value
     */
    public void setWordPanel(WordPanel wp) {
	this.wp = wp;
    }

    /**
     * Describe <code>setMailGraphWindow</code> method here.
     *
     * @param mgw a <code>MailGraphWindow</code> value
     */
    public void setMailGraphWindow(MailGraphWindow mgw) {
	this.mgw = mgw;
    }

    /**
     * Describe <code>setMailGraphCanvas</code> method here.
     *
     * @param mgc a <code>MailGraphCanvas</code> value
     */
    public void setMailGraphCanvas(MailGraphCanvas mgc) {
	this.mgc = mgc;
    }

    public void setMailScrolledPanel(MailScrolledPanel msp) {
	this.msp = msp;
    }

    /**
     * Describe <code>setReference</code> method here.
     *
     * @param ref a <code>Reference</code> value
     */
    public void setReference(Reference ref) {
	this.ref = ref;
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     */
    private void actionPerformed() {
	wp.removeAll();
	mgw.clear();
	//	mgw.show();
	mgw.setVisible(false);
	if (mgw.isVisible()) {
	    mgw.draw(Selection.get(), ref);	     
	} // end of if (mgw.getVisible())

	mgc.setVisible(true);
	mgc.clear();
	//	mgc.show();
	if (mgc.isVisible()) {
	    mgc.draw(Selection.get(), ref);
	}

	if (msp != null) {
	    msp.center();
	} // end of if (msp != null)
    }

    /** */
    private WordPanel wp = null;
    /** */
    private MailGraphWindow mgw = null;
    /** */
    private MailGraphCanvas mgc = null;
    /** */
    private MailScrolledPanel msp = null;
    /** */
    private Reference ref = null;

    /** */
    Vector groupA = null;
    Vector groupB = null;
    Vector groupC = null;
    Vector groupD = null;
}

/**
 * Describe class <code>GraphicsCheckbox</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class GraphicsCheckbox 
    extends Checkbox 
    implements SelectionListener {
    /**
     * Creates a new <code>GraphicsCheckbox</code> instance.
     *
     * @param label a <code>String</code> value
     * @param status a <code>boolean</code> value
     * @param group a <code>CheckboxGroup</code> value
     */
    public GraphicsCheckbox(String label, boolean status, 
			    CheckboxGroup group){
	super(label, status, group);
    }

    /**
     * Describe <code>selectionChanged</code> method here.
     *
     * @param msgId a <code>String</code> value
     */
    public void selectionChanged(String msgId) {
	selected = msgId;
	if (selected == null) {
	    setEnabled(false);
	} // end of if (selected == null)
	else {
	    setEnabled(true);
	} // end of else
    }

    /** */
    private String selected = null;
}
