/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
// $Date$
// $Revision$

import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.Vector;
import MailProperties;
import PrefaceLogListener;

/**
 * Describe class <code>PrefaceLog</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 * @date 2002/11/03
 */
class PrefaceLog {
    /** */
    static private Vector adapters = null;

    static {
	adapters = new Vector();
    }

    /**
     * Creates a new <code>PrefaceLog</code> instance.
     *
     */
    public PrefaceLog() {
    }

    /**
     * Describe <code>start</code> method here.
     *
     */
    public static void start() {
	String ext = currentDateAndTime();
	ext += ".log";

	Enumeration e = adapters.elements();
	while (e.hasMoreElements()) {
	    PrefaceLogListener pla = (PrefaceLogListener)e.nextElement();
	    pla.startLog(ext);
	} // end of while (e.hasMoreElements())
	
    }

    /**
     * Describe <code>finish</code> method here.
     *
     */
    public static void finish() {
	Enumeration e = adapters.elements();
	while (e.hasMoreElements()) {
	    PrefaceLogListener pla = (PrefaceLogListener)e.nextElement();
	    pla.finishLog();
	} // end of while (e.hasMoreElements())
    } 

    /**
     * Describe <code>set</code> method here.
     *
     * @param mp a <code>MailProperties</code> value
     */
    public static void setMailProperties(MailProperties mp) {
	_mp = mp;
    }

    /**
     * Listener ɲä롣
     *
     * @param pla a <code>PrefaceLogAdapter</code> Adapter饹
     */
    public static void addListener(PrefaceLogListener pla) {
	adapters.add(pla);
    }

    /**
     * Describe <code>currentDateAndTime</code> method here.
     *
     * @return a <code>String</code> value
     */
    private static String currentDateAndTime() {
	SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMddhhmmss");
	Date currentTimeAndDate = new Date();
	return formatter.format(currentTimeAndDate);
    }

    /**
     * Describe <code>getDir</code> method here.
     *
     * @return a <code>String</code> value
     */
    public static String getDir() {
	String dir = Preface.mp.getProperty(dirPropKey);
	if (dir == null || dir.equals("")) {
	    dir = "/tmp";
	} // end of if (dir == null || dir.equals(""))
	return dir;
    }

    /** */
    static private MailProperties _mp = null;

    /** */
    static private final String dirPropKey = "LogDir";
}
