/*
  (c) 2001-2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.
  Time-stamp: <2003/02/16 16:26:29 jun>

  Date:  $Date$
  Revision:  $Revision$

 */
// Created by Jun Kurabe
// 2001/09/16
// 2002/01/25
// 2002/02/23

//package jp.co.lmer.mail;

import java.io.UnsupportedEncodingException;

import java.util.GregorianCalendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;
import java.util.StringTokenizer;

import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Folder;
import javax.mail.internet.MimeUtility;
import javax.mail.internet.ParseException;

import MailDraw;
import PrefaceDebug;
import ReferenceInterface;
import RelationDistance;
import MailFileException;
import MailMessage;

/**
 * Describe class <code>Reference</code> here.
 *
 * @author Jun Kurabe
 * @version 1.0
 * @see MailDraw
 */
public class Reference {

    /**
     * 
     */
    public Reference () {
	//	isTop = new HashMap();
	refMap = new HashMap();
	replyMap = new HashMap();
	cntRefMap = new HashMap();
	cntReplyMap = new HashMap();

	subjectMap = new HashMap();

	msgMap = new HashMap();

	toFromMap = new HashMap();
	fromToMap = new HashMap();
    }

    /**
     * Return number of messages
     * @return int
     */
    public int size() {
	return msgMap.size();
    }

    /**
     * Describe <code>getFromCount</code> method here.
     *
     * @param addr a <code>String</code> value
     * @return a <code>Hashmap</code> value
     */
    public HashMap getFromCount(String addr) {
	return (HashMap)fromToMap.get(addr);
    }

    /**
     * Describe <code>getToCount</code> method here.
     *
     * @param addr a <code>String</code> value
     * @return a <code>Hashmap</code> value
     */
    public HashMap getToCount(String addr) {
	return (HashMap)toFromMap.get(addr);
    }

    /**
     * ȯԥɥ쥹ǡ뤤ϰޥåɥ쥹֤
     *
     * @param addr a <code>String</code> ᥤ륢ɥ쥹
     * @param top a <code>boolean</code> Ƭפtrue
     * @return a <code>Vector</code> ޥåɥ쥹
     */
    public Vector getFromAddrs(String addr, boolean top) {
	Set keys = fromToMap.keySet();
	Vector rv = new Vector();

	Iterator ite = keys.iterator();
	while (ite.hasNext()) {
	    String s = (String)ite.next();
	    if (top) {
		if (s.startsWith(addr)) rv.add(s);
	    } // end of if (top)
	    else {
		if (s.indexOf(addr) != -1 ) rv.add(s);
	    } // end of if (top)else
	} // end of while (ite.hasNext())
	
	return rv;
    }

    /**
     * 襢ɥ쥹ǡ뤤ϰޥåɥ쥹֤
     *
     * @param addr a <code>String</code> ᥤ륢ɥ쥹
     * @param top a <code>boolean</code> Ƭޥåtrue
     * @return a <code>Vector</code> פᥤ륢ɥ쥹
     */
    public Vector getToAddrs(String addr, boolean top) {
	Set keys = toFromMap.keySet();
	Vector rv = new Vector();

	Iterator ite = keys.iterator();
	while (ite.hasNext()) {
	    String s = (String)ite.next();
	    if (top) {
		if (s.startsWith(addr)) rv.add(s);
	    } // end of if (top)
	    else {
		if (s.indexOf(addr) != -1) rv.add(s);
	    } // end of if (top)else
	} // end of while (ite.hasNext())
	
	return rv;
    }

    /**
     * ᥤȯɥ쥹ȼɥ쥹δط롣
     *
     * @param id a <code>String</code> value
     * @param msg a <code>Message</code> value
     */
    private void getFromTo(String id, Message msg) {
	// ToեɤͤФ
	String from = MailFieldConvert.convertFromAddress(msg);
	if (from == null) return;

	String addresses[] = null;
	try {
	    addresses = msg.getHeader("TO");
	} catch (MessagingException e) {
	    return;
	} // end of catch

	if (addresses != null) getToOrCC(id, from, addresses);

 	// CCեɤͤФ
	try {
	    addresses = msg.getHeader("CC");
	} catch (MessagingException e) {
	    return;
	} // end of catch

	if (addresses != null)  getToOrCC(id, from, addresses);
    }

    /**
     * Describe <code>getToOrCC</code> method here.
     *
     * @param id a <code>String</code> value
     * @param addresses[] a <code>String</code> value
     */
    private void getToOrCC(String id, String from, String addresses[]) {
	// System.err.println("From: " + from);
	for (int i = 0; i < addresses.length; i++) {

	    StringTokenizer st= new StringTokenizer(addresses[i],", <>\"\'");
	    while (st.hasMoreTokens()) {
		String token = st.nextToken();
		// Address եޥåȤǤϤʤ
		if (token.indexOf("@")== -1) continue;

		//	    System.err.println("Address = " + token);
		{
		    HashMap tos = (HashMap)fromToMap.get(from);
		    Vector cnt = null;
		    if (tos == null) {
			tos = new HashMap();
			fromToMap.put(from, tos);
			cnt = new Vector();
		    } else {
			cnt = (Vector)tos.get(token);
			if (cnt == null)  cnt = new Vector();
		    } // end of else
		    cnt.add(id);
		    tos.put(token, cnt);

		    // System.err.print("from:" + from);
		    // System.err.print(",to:" + token);
		    // System.err.println(",cnt:" + cnt.size());
		}

		{
		    HashMap tos = (HashMap)toFromMap.get(token);
		    Vector cnt = null;
		    if (tos == null) {
			tos = new HashMap();
			toFromMap.put(token, tos);
			cnt = new Vector();
		    } else {
			cnt = (Vector)tos.get(from);
			if (cnt == null)  cnt = new Vector();
		    } // end of else
		    cnt.add(id);
		    tos.put(from, cnt);
		}
	    } // end of while (st.nextToke)
	} // end of for (int i = 0; i < addresses.length; i++)
    }

    /**
     * Get Reference and put the reference into refMap
     * @param msg Message Object
     */
    public void getReferences(Message msg) {
	String id = MailFieldConvert.getMsgId(msg);
	if ( id == null ) return;

	msgMap.put(id, new MailMessage(msg));
        //if (id.indexOf("mediafront")!=-1) System.err.println("put = " + id);
	// in-Reply-To δطФ롣
	getCntRelation(id, msg, "In-Reply-to", cntReplyMap);
	// References δطФ롣
	getCntRelation(id, msg, "References", cntRefMap);

	// in-Reply-To εδطФ롣
	getRelation(id, msg, "In-Reply-to", replyMap);
	// References εδطФ롣
	getRelation(id, msg, "References", refMap);

	// Ʊ֥ȤΥᥤФ롣
	makeSubjectMap(id, msg);
       
	// ᥤԤδط
	getFromTo(id, msg);
    }

    /**
     * ƤΥåФ
     *
     * @return an <code>Iterator</code> åIDIterator
     */
    public Iterator getAllMsg() {
	return (msgMap.keySet()).iterator();
    }

    /**
     * Get Message Object from Id
     * 
     * @param id
     * @return Message
     * @exception MailFileException if an error occurs
     */
    public Message getMsg(String id) 
	throws MailFileException  {
	MailMessage mm = (MailMessage)msgMap.get(id);
	if (mm == null) throw new MailFileException();
	return mm.getMessage();
    }

    /**
     * Get Relation 
     * @param id MessageId
     * @param msg Message Object
     * @param kw Header Field Name
     * @param map ФطǼޥåץ֥
     */
    private void getRelation (String id, Message msg,
			      String kw, HashMap map) {
        try {
            // Get Value of Reference
            String refs[] = msg.getHeader(kw);
            if (refs == null ) return;

	    boolean localDebug = false;
	    //	    System.err.println("id =" + id+"\"");
	    // Sprit Value into elements
	    Vector rs = new Vector();
            for (int i = 0; i<refs.length; i++) {
		//   System.err.println("ref[" + i + "]=" + refs[i]);
                StringTokenizer st = new StringTokenizer(refs[i],", <>\"\'");
                while(st.hasMoreTokens()) {
                    String ss = st.nextToken();
                    if ( ss.indexOf("@") == -1) continue;
                    if ( id.equals(ss) ) continue;
                    if ( ss == null ) continue;

		    if (localDebug)    System.err.println("ss =" + ss);
                    rs.addElement(ss);
                }
		// map.put(id, rs);	    
            }
	    map.put(id, rs);	    
	    rs = null;
        } catch (MessagingException me) {
            me.printStackTrace();
        }
    }

    /**
     * Get Counter Relation 
     * @param id MessageId
     * @param msg Message Object
     * @param kw  Header Field Name
     * @param map ФطǼޥåץ֥
     */
    private void getCntRelation (String id, Message msg,
				 String kw, HashMap map) {
        try {
            // Get Value of Reference
            String refs[] = msg.getHeader(kw);
            if (refs == null ) return;

            // Sprit Value into elements
            for (int i = 0; i<refs.length; i++) {
                StringTokenizer st = new StringTokenizer(refs[i],", <>\"\'");
                while(st.hasMoreTokens()) {
                    String ss = st.nextToken();
                    if ( ss.indexOf("@") == -1) continue;
                    if (id.equals(ss)) continue;

		    // System.err.println("ss = " + ss + " id: " + id);
                    // Add Reference to Map
                    Vector rs = (Vector)map.get(ss);
                    if ( rs == null ) rs = new Vector();

                    if (!rs.contains(id)) {
                        rs.addElement(id);
                        map.put(ss, rs);
                    }
		    rs = null;
                }
            }
	    //            isTop.put(id,new Boolean(false));
        } catch (MessagingException me) {
            me.printStackTrace();
        }
    }

    /** 
     * Draw graph follow mail relation and return top id subject
     * @param msgId
     * @param md
     * @return String
     */
    public String draw(String msgId, MailDraw md) {
	PrefaceDebug.println("msgId = " + msgId, this);
	passed = new HashMap();

	passed.put(msgId, msgId);
	String topId = getTop(msgId);
	PrefaceDebug.println("Top id = " + topId, this);

	// ̲ɻѿν
	passed = new HashMap();
	String subject = "";
	//	md.addNode(topId, (Message)msgMap.get(msgId));
	try {
	    md.addNode(topId, ((MailMessage)msgMap.get(topId)).getMessage());
	    followRef(topId, md);

	    try {
		subject = (((MailMessage)msgMap.get(msgId)).getMessage()).getSubject();
	    } catch (MessagingException me) {
		me.printStackTrace();
	    }
	} catch (NullPointerException e) {
	    
	} // end of try-catch
	
	return subject;
    }

    /**
     * Describe <code>getTop</code> method here.
     *
     * @param msgId
     * @return String
     */
    public String getTop(String msgId) {

	// System.err.println("GetTop msgid: " + msgId);
	/**
	 */
	class GetTopOne 
	    extends RIImpl {
	    /**
	     */
	    public GetTopOne () {
		topId = null;
	    }

	    /**
	     * @param msgId
	     * @return String
	     */
	    public boolean doIt (String msgId) {
		PrefaceDebug.println("xGetTop = " + msgId,this);
		// System.err.println("GetTop doIt msgid: " + msgId);
		this.topId = msgId;
		return false;
	    }

	    /**
	     * @return String
	     */
	    public String getTopId() {
		return topId;
	    }

	    /** */
	    private String topId = null;
	}

	GetTopOne gto = new GetTopOne();

	try {
	    //	    this.enumerationToTop(msgId, this);
	    this.enumerationToTop(msgId, gto);
	} catch (MailFileException e) {
	    e.printStackTrace();
	}
	return gto.getTopId();
    }

    /** 
     * in-reply-toδط̤ꡢåɤƬmessage-idꤹ롣
     * @param msgId
     * @return String
     */
    /*
    public String getTop(String msgId) {
	passed.put(msgId, msgId);
	Vector v = (Vector)replyMap.get(msgId);
	System.err.println("getTop = " + msgId );

	// replyMapˤʤrefMap˴طϡreplyMapɤѤ
	if ( v == null ) {
	    v = (Vector)refMap.get(msgId);
	    replyMap.put(msgId, v);
	    System.err.println("REF->REP");
	    System.err.println("size = " );

	    if ( v != null) {
		for (int i = 0; i < v.size(); i++) {
		    String tmp = (String)v.elementAt(i);
		    Vector tmpV = (Vector)cntReplyMap.get(tmp);
		    if (tmpV == null ) tmpV = new Vector();
		    if (!tmpV.contains(msgId)) {
			tmpV.addElement(msgId);
			cntReplyMap.put(tmp, tmpV);
		    }
		    
		}
	    }
	}
	//	    System.err.println("Using");
	if ( v == null) {
	    //		System.err.println("called");
	    try {
		MailMessage mm = (MailMessage)msgMap.get(msgId);
		if (mm == null) return null;

		Message m = mm.getMessage();
		Date sentDate = m.getSentDate();

		String idFromBody = getReferenceFromBodyText(msgId, sentDate);
		if (idFromBody == null ) return msgId;

		System.err.println("Find = " + idFromBody);
		// ȯ줿طɲä 
		v = (Vector)cntReplyMap.get(idFromBody);
		if ( v == null) v = new Vector();
		if (!v.contains(msgId)) {
		    v.addElement(msgId);
		    cntReplyMap.put(idFromBody, v);
		}

		v = new Vector();
		v.addElement(idFromBody);
		replyMap.put(msgId, v);
	    } catch (MessagingException e) {
		e.printStackTrace();
		System.err.println("msgId = " + msgId);
		return(msgId);
	    } catch (NullPointerException e) {
		e.printStackTrace();
		return(msgId);
	    }

	}

	// Υᥤ뤬ܥġǡ¸ߤƤmsgid֤롣
	// ʤ null ֤롣
	String rv = msgId;
	Message m = ((MailMessage)msgMap.get(msgId)).getMessage();
	Date xSentDate = null;
	try {
	    xSentDate =  m.getSentDate();
	} catch (MessagingException e) {
	}

	for (int i = 0; i < v.size(); i++) {
	    String tmp = (String)v.elementAt(i);
	    if ( passed.get(tmp) != null) continue;

	    if ( tmp.indexOf("@") == -1 ) continue;
	    System.err.println("GetTop try= " + tmp);
	    String tmpRv = getTop(tmp);
	    try {
		m = ((MailMessage)msgMap.get(tmpRv)).getMessage();
		if ( xSentDate.compareTo(m.getSentDate())>0) {
		    rv = tmpRv;
		    xSentDate = m.getSentDate();
		}

//		  if ( tmpRv != null) rv = tmpRv;

	    } catch (MessagingException e) {
	    }
	}
	System.err.println("GetTop = " + rv);
	return rv;
    }
*/

    /**
     * Describe <code>getReferenceFromToCc</code> method here.
     *
     * @param id a <code>String</code> value
     * @param lastSentDate a <code>Date</code> value
     * @return a <code>String</code> value
     */
    private String getReferenceFromToCc(String id, Date lastSentDate) {
	MailMessage mm = (MailMessage)msgMap.get(id);
	PrefaceDebug.println("id = " + id,this);
	Message msg = mm.getMessage();

	String subject = MailFieldConvert.getBareSubject(msg);
        PrefaceDebug.println("Bare = " + subject,this);
	String rv = null;
	String from =null;
	Vector v = null;
	String to = null;
	try {
	    from = (msg.getFrom()[0]).toString();
	    v = (Vector)subjectMap.get(subject);
	} catch (MessagingException e) {
	    
	} // end of try-catch

	try {
	    to = (msg.getHeader("To")[0]).toString();
	} catch (MessagingException e) {
	} // end of try-catch

	if (v == null) return null;

	Date tmpDate = null;
	
	for (int i = 0; i < v.size(); i++) {
	    String tid = (String)v.elementAt(i);
	    if (tid.equals(id)) {
		continue;
	    } // end of if (tid.equals(id))
	    
	    MailMessage tmm = (MailMessage)msgMap.get(tid);
	    PrefaceDebug.println("id = " + tid,this);
	    Message tmsg = tmm.getMessage();
	    try {
		Date d = tmsg.getSentDate();
		if (lastSentDate.compareTo(d)>0) {
		    continue;
		} // end of if ()
	    
		String[] tos = tmsg.getHeader("To");
		if (tos != null) {
		    for (int j = 0; j < tos.length; j++) {
			if (tos[j].indexOf(from)!=-1) {
			    try {
				if (tmpDate.compareTo(d)<0) {
				    tmpDate = d;
				    rv = tid;
				    break ;
				} // end of if ()

			    } catch (NullPointerException e) {
				tmpDate = d;
				rv = tid;
			    } // end of try-catch
			
			} // end of if ()
			else if (tos[j].indexOf(to)!=-1) {
			    try {
				if (tmpDate.compareTo(d)<0) {
				    tmpDate = d;
				    rv = tid;
				    break ;
				} // end of if ()

			    } catch (NullPointerException e) {
				tmpDate = d;
				rv = tid;
			    } // end of try-catch
			
			} // end of if ()
		    } // end of for (int j = 0; j < Froms.length(); j++)
		} // end of if (to != null)
	    
		String[] cc = tmsg.getHeader("Cc");
		if (cc != null) {
		    for (int j = 0; j < cc.length; j++) {
			if (cc[j].indexOf(from)!=-1) {
			    try {
				if (tmpDate.compareTo(d)<0) {
				    tmpDate = d;
				    rv = tid;
				    break ;
				} // end of if ()
			    } catch (NullPointerException e) {
				tmpDate = d;
				rv = tid;
			    } // end of try-catch
			} // end of if ()
			else if (cc[j].indexOf(to)!=-1) {
			    try {
				if (tmpDate.compareTo(d)<0) {
				    tmpDate = d;
				    rv = tid;
				    break ;
				} // end of if ()
			    } catch (NullPointerException e) {
				tmpDate = d;
				rv = tid;
			    } // end of try-catch
			} // end of if ()
		    } // end of for (int j = 0; j < Froms.length(); j++)
		} // end of if (cc != null)
	    } catch (MessagingException e) {
		 
	    } // end of catch
	} // end of for (int i = 0; i < v.size(); i++)

	// System.err.println("ToCC:"+rv);
	return rv;
    }

    /**
     * idʬǻȤƤåΤǤ⿷åid֤
     * @param id åid
     * @param lastSentDate a <code>Date</code> value
     * @return String åid
     */
    private String getReferenceFromBodyText(String id, Date lastSentDate) {
	MailMessage mm = (MailMessage)msgMap.get(id);
	PrefaceDebug.println("id = " + id,this);
	Message msg = mm.getMessage();

	String subject = MailFieldConvert.getBareSubject(msg);
        PrefaceDebug.println("Bare = " + subject,this);
	String rv = null;

	Vector v = (Vector)subjectMap.get(subject);
	if (v == null) return null;

	try {
	    String bodyText = MailFieldConvert.getBodyText(msg);
	    String refLine = null;
	    int p = 0;
            String kw = ">";
	    while(p!=-1) {
		p = bodyText.indexOf(kw, p);
		if (p==-1) break;
                kw = "\n>";

		int pCR = bodyText.indexOf("\n", p+2);
		int pGT = bodyText.indexOf(">", p+2);

		PrefaceDebug.println("pCR = " + pCR + " pGT = " + pGT,this);
		if ( pGT == -1 || pGT > pCR ) {
                    
		    refLine = bodyText.substring(p+2, pCR-1);
		    if (refLine.length() < 3) {
                        p++;
                        continue;
                    }
		    break;
		}
                p++;
	    }

	    PrefaceDebug.println("refLine = " + refLine,this);
            if (refLine == null) return null;
	    refLine = "\n" + refLine.trim() ;

	    for(int i = 0; i< v.size(); i++) {
		String targetId = (String)v.elementAt(i);
		if (targetId.equals(id)) {
		    continue;
		} // end of if (targetId.equals(msgId))

                PrefaceDebug.println("targetid2 = " + targetId,this);
	    // Ǥõ
		if ( passed.get(targetId) != null ) continue;
	    //	    System.err.println("targetId = " + targetId );

		MailMessage tmm = (MailMessage)msgMap.get(targetId);
		Message targetMsg = tmm.getMessage();

		String sender = MailFieldConvert.convertFrom(msg);
		String targetBodyText = MailFieldConvert.getBodyText(targetMsg);
		if (targetBodyText.indexOf(refLine)!=-1) {
                    return targetId;
		}
	    }
	} catch (MailFileException e) {
	    e.printStackTrace();
	} catch (StringIndexOutOfBoundsException e) {
            //	    e.printStackTrace();
        }

	return rv;
    }

    /**
     * åɤƬޤ̤ĤġReferenceInterface.doItεǽ򤽤줾ΥåǼ¹Ԥ롣
     * @param msgId åID
     * @param ri    ReferenceInterface֥
     * @return a <code>boolean</code> value
     * @exception MailFileException if an error occurs
     */
    public boolean enumerationToTop(String msgId, ReferenceInterface ri) 
	throws MailFileException  {
	passed = new HashMap();
	return enumerationToTopMain(msgId, ri, false);
    }

    /**
     * Describe <code>enumerationToTop</code> method here.
     *
     * @param msgId ȤåID
     * @param ri ƥåԤ֥
     * @param firstOff a <code>boolean</code> value
     * @return a <code>boolean</code> value
     * @exception MailFileException if an error occurs
     */
    public boolean enumerationToTop(String msgId, 
				    ReferenceInterface ri, 
				    boolean firstOff) 
	throws MailFileException  {
	passed = new HashMap();
	return enumerationToTopMain(msgId, ri, firstOff);
    }

    /**
     * åɤƬޤ̤ĤġReferenceInterface.doItεǽ򤽤줾ΥåǼ¹Ԥ롣
     * @param msgId åID
     * @param ri    ƥåԤ֥
     * @param firstOff a <code>boolean</code> value
     * @return a <code>boolean</code> value
     * @exception MailFileException if an error occurs
     */
    private boolean enumerationToTopMain(String msgId, ReferenceInterface ri, 
					 boolean firstOff) 
	throws MailFileException  {
	if (!firstOff) {
	    if (ri.doIt(msgId)) return false;	     
	} // end of if (firstOff)

	Vector v = (Vector)replyMap.get(msgId);
	// System.err.println("replyMap(msgId): " + v);

	// replyMapˤʤrefMap˴طϡ
	// referenceδطˤᥤΤǤ⿷Τ
	// in-Reply-ToδطɤѤ롣
	if ( v == null ) 
	    v = copyRefToCntRep(msgId);

	// System.err.println("copyRefCntMap(msgId): " + v);
	// in-Reply-to, Referenceˤطʤˤϡ
	// Ʊ֥ȤǡѴطᥤ
	// in-reply-toδطȤ롣
	if ( v == null) {
	    try {
		MailMessage mm = (MailMessage)msgMap.get(msgId);
		// System.err.println("MailMessage mm: " + mm);
		if (mm == null) return false;

		Message m = mm.getMessage();
		Date sentDate = m.getSentDate();

		String idFromBody = getReferenceFromBodyText(msgId, sentDate);
		if (idFromBody != null ) {
		    // System.err.println("Find = " + idFromBody);

		    /* ȯ줿طɲä */
		    v = (Vector)cntReplyMap.get(idFromBody);
		    if ( v == null) v = new Vector();
		    if (!v.contains(msgId)) {
			v.addElement(msgId);
			cntReplyMap.put(idFromBody, v);
		    }

		    v = new Vector();
		    v.addElement(idFromBody);
		    
		    if (msgId.equals(idFromBody)) {
			int x = 1;int y =0;
			int z = x/y;
		    } // end of if (msgId.equals(latestRef))

		    replyMap.put(msgId, v);
		}
	    } catch (MessagingException e) {
		e.printStackTrace();
		System.err.println("msgId = " + msgId);
		return false;
	    } catch (NullPointerException e) {
		e.printStackTrace();
		return false;
	    }
	}

	//	System.err.println("v 4:" + v);

	if (v == null) {
	    return false;
	} // end of if (v == null)
	
	// Υᥤ뤬ܥġǡ¸ߤƤmsgid֤롣
	// ʤ null ֤롣
	String rv = msgId;

	// Get Most recent date
	String xTmp = null;
	Date xSentDate = (new GregorianCalendar(2100,0,1)).getTime(); // tempolary big date
	for (int i = 0; i < v.size(); i++) {
	    String tmp = (String)v.elementAt(i);
	    //	    System.err.println("tmp:" + tmp);

	    /*
	    try {
	    tmp = tmp.substring(0,tmp.indexOf(">")+1);		
	    } catch (NullPointerException e) {
	    continue;
	    } // end of try-catch
	    //	    System.err.println("tmp:" + tmp);
	    */

	    if ( passed.get(tmp) != null) continue;

	    if ( tmp.indexOf("@") == -1 ) continue;
	    //	    String tmpRv = getTop(tmp);
	    try {
		MailMessage mm = (MailMessage)msgMap.get(tmp);
		Message m = mm.getMessage();
		if (xSentDate.compareTo(m.getSentDate())>0 ) {
		    xTmp = tmp;
		    xSentDate = m.getSentDate();
		}
	    } catch (MessagingException e) {
		// e.printStackTrace();
	    } catch (NullPointerException e) {
		// e.printStackTrace();
	    } // end of catch
	    
	    //	    if ( tmpRv != null) rv = tmpRv;
	}

	//	System.err.println("xTmp = " + xTmp);
	// Message ȤƤ뤬ե¸ߤʤ
	if (xTmp == null) {
	    return false;
	} // end of if (xTmp == null)

	passed.put(xTmp, xTmp);
	if (!enumerationToTopMain(xTmp, ri, false)) return false;
	return false;
    }

    /**
     * ᥤin-reply-toδط̤Ĥġط򥰥դɽ롣
     * @param id åID
     * @param md MailDraw֥
     */
    private void followRef(String id, MailDraw md) {
	passed.put(id, id);
	
	Vector v = (Vector)cntReplyMap.get(id);
	// in-reply-map ʤСReferences 椫餵
	if ( v == null ) v = copyCntRefToRep(id);
	if ( v == null ) return;

	Enumeration e = v.elements();
	while(e.hasMoreElements()) {
	    String nextId = (String)e.nextElement();
	    //	    if ( id.equals(nextId) ) continue;
	    if (passed.get(nextId) != null) {
		md.addEdge(id, nextId);
		PrefaceDebug.println(id + "-->" + nextId,this);
		continue;
	    }

	    md.addNode(nextId, ((MailMessage)msgMap.get(nextId)).getMessage());
	    try {
		md.addEdge(id, nextId);		 
	    } catch (Exception xe) {
		xe.printStackTrace();
	    } // end of try-catch

	    PrefaceDebug.println(id + "-->" + nextId,this);
	    followRef(nextId, md);
	}
    }

    /**
     * ᥤin-reply-toδط̤Ĥġط򥰥դɽ롣
     * @param id åID
     * @param ri a <code>ReferenceInterface</code> value
     */
    public void followRef(String id, ReferenceInterface ri) {
	// System.err.println("FollowRef:");
	passed = new HashMap();
	followRefMain(id, ri);
    }

    /**
     * Describe <code>followRefMain</code> method here.
     *
     * @param id a <code>String</code> value
     * @param ri a <code>ReferenceInterface</code> value
     */
    private void followRefMain(String id, ReferenceInterface ri) {
	passed.put(id, id);
	
	//	Vector v = (Vector)cntRefMap.get(id);
	Vector v = (Vector)cntReplyMap.get(id);
	if ( v == null ) return;

	Enumeration e = v.elements();
	while(e.hasMoreElements()) {
	    String nextId = (String)e.nextElement();
	    // System.err.println("NextId: " + nextId);
	    //	    if ( id.equals(nextId) ) continue;
	    if (passed.get(nextId) != null) {
		ri.followDoIt(id, nextId);
		continue;
	    }

	    ri.followDoIt(id, nextId);
	    followRefMain(nextId, ri);
	}
    }

    /**
     * Ʊ֥ȤΥޥåפ
     * @param id åID
     * @param msg å֥
     */
    private void makeSubjectMap(String id, Message msg) {
	String orgSubject = MailFieldConvert.getBareSubject(msg);
	if (orgSubject == null )  orgSubject = "NULL";
	
	Vector v = (Vector)subjectMap.get(orgSubject);
	if ( v == null ) v = new Vector();
	if (!v.contains(id)) {
	    v.addElement(id);
	    subjectMap.put(orgSubject,v);
	}
    }

    /**
     * Describe <code>copyCntRepToRep</code> method here.
     *
     * @param msgId a <code>String</code> value
     * @return a <code>Vector</code> value
     */
    private Vector copyRefToCntRep(String msgId) {
	Vector v = (Vector)refMap.get(msgId);
	Vector newVector = null;
	if (v != null) {
	    String latestRef = getLatestMsgid(v);
	    // System.err.println("LatestRef(RefToCntRep):" + latestRef);
	    if (latestRef == null) {
		return null;
	    } // end of if (latestRef == null)
	    newVector = new Vector();
	    newVector.add(latestRef);
	    if (msgId.equals(latestRef)) {
		int x = 1;int y =0;
		int z = x/y;
	    } // end of if (msgId.equals(latestRef))
	    
	    replyMap.put(msgId, newVector);

	    Vector tmpV = (Vector)cntReplyMap.get(latestRef);
	    if (tmpV == null ) tmpV = new Vector();
	    if (!tmpV.contains(msgId)) {
		tmpV.addElement(msgId);
		cntReplyMap.put(latestRef, tmpV);
	    }
	} // end of if (v != null)
	
	return newVector;
    }

    /**
     * Describe <code>copyCntRepToRep</code> method here.
     *
     * @param msgId a <code>String</code> value
     * @return a <code>Vector</code> value
     */
    private Vector copyCntRefToRep(String msgId) {
	Vector v = (Vector)cntRefMap.get(msgId);
	Vector newVector = null;
	if (v != null) {
	    String latestRef = getLatestMsgid(v);
	    // System.err.println("LatestRef(CNTRefToRep):" + latestRef);
	    if (latestRef == null) {
		return null;
	    } // end of if (latestRef == null)
	    
	    newVector = new Vector();
	    newVector.add(latestRef);
	    cntReplyMap.put(msgId, newVector);

	    Vector tmpV = (Vector)replyMap.get(latestRef);
	    if (tmpV == null ) tmpV = new Vector();
	    if (!tmpV.contains(msgId)) {
		tmpV.addElement(msgId);
		replyMap.put(latestRef, tmpV);
	    if (latestRef.equals(msgId)) {
		int x = 1;int y =0;
		int z = x/y;
	    } // end of if (msgId.equals(latestRef))

	    }
		    
	} // end of if (v != null)
	
	return newVector;
    }

    /**
     * Describe <code>getLatestMsgid</code> method here.
     *
     * @param msgids a <code>Vector</code> value
     * @return a <code>String</code> value
     */
    private String getLatestMsgid(Vector msgids) {
	String rv = null;
	if (msgids != null) {
	    Date latestDate = null;
	    Date sentDate = null;
	    for (int i =0; i< msgids.size(); i++) {
		MailMessage mm = (MailMessage)msgMap.get((String)msgids.elementAt(i));
		if (mm == null) continue;
		Message m = mm.getMessage();
		try {
		    sentDate = m.getSentDate();
		    // System.err.println("SentDate: " + sentDate);
		    if (latestDate.compareTo(sentDate) < 0) {
			rv = (String)msgids.elementAt(i);
			latestDate = sentDate;
		    } // end of if (latestDate.compareTo(sentDate) < 0)
		} catch (MessagingException e) {
		    
		} catch (NullPointerException e) {
		    rv = (String)msgids.elementAt(i);
		    latestDate = sentDate;		    
		} // end of try-catch
	    } // end of for (int i =0; i< msgids.size(); i++)
	} // end of if (msgids != null)
	
	return rv;
    }

    /**
     * Describe <code>enumerationFromBottom</code> method here.
     *
     * @param msgId a <code>String</code> value
     * @param ri a <code>ReferenceInterface</code> value
     * @return a <code>Vector</code> value
     */
    public Vector enumerationFromBottom(String msgId,
					ReferenceInterface ri) {
	passed = new HashMap();
	return enumerationFromBottomMain(msgId, ri);
    }

    /**
     * Describe <code>enumerationFromBottomMain</code> method here.
     *
     * @param msgId a <code>String</code> value
     * @param ri a <code>ReferenceInterface</code> value
     * @return a <code>Vector</code> value
     */
    private Vector enumerationFromBottomMain(String msgId,
					ReferenceInterface ri) {

	Vector mergeV = new Vector();
	Vector v = (Vector)cntReplyMap.get(msgId);

	// replyMapˤʤrefMap˴طϡreplyMapɤѤ
	if ( v == null ) v = copyCntRefToRep(msgId);

	//	String rv = msgId;

	if (v != null)
	    for (int i = v.size()-1; i>-1; i--) {
		String tmp = (String)v.elementAt(i);
		// System.err.println("TMP: " + tmp);
		// tmp = tmp.substring(0,tmp.indexOf(">")+1);
		if ( passed.get(tmp) != null) continue;

		if ( tmp.indexOf("@") == -1 ) continue;
		// String tmpRv = getTop(tmp);
		MailMessage mm = (MailMessage)msgMap.get(tmp);
		Message m = mm.getMessage();
		
		Vector tmpV = enumerationFromBottomMain(tmp, ri);
		// System.err.println("tmvV: " + tmpV);		
		try {
		    for (int j =0; j< tmpV.size(); j++) {
			// ʣʤɲä롣
			if (!mergeV.contains(tmpV.elementAt(j))) 
			    mergeV.add(tmpV.elementAt(j));
		    } // end of for (int j =0; j< v.size(); j++)
		} catch (NullPointerException e) {
		} // end of try-catch
		
	    //	    if ( tmpRv != null) rv = tmpRv;
	}
	try {
	    return ri.doIt(msgId, mergeV);
	} catch (MailFileException e) {
	    e.printStackTrace();
	} // end of try-catch
	return null;	
	//	return false;
    }

    /**
     * Describe <code>getRelatedUser</code> method here.
     *
     * @param addr a <code>String</code> value
     * @return a <code>Vector</code> value
     */
    public RelationDistance[] getFromRelatedUser(String addr) {
	return null;
    }

    /**
     * Describe <code>getToRelatedUser</code> method here.
     *
     * @param addr a <code>String</code> value
     * @return a <code>RelationDistance[]</code> value
     */
    public RelationDistance[] getToRelatedUser(String addr) {
	return null;
    }

    /** */
    //    private HashMap isTop = null;
    /** */
    private HashMap refMap = null;
    /** */
    private HashMap replyMap = null;

    /** */
    private HashMap cntRefMap = null;
    /** */
    private HashMap cntReplyMap = null;
    /** */
    private HashMap msgMap = null;
    /** */ 
    private HashMap subjectMap = null;

    /** */
    private HashMap passed = null;

    /** */
    private HashMap fromToMap = null;
    private HashMap toFromMap = null;
}


