/*
  (c) 2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/20 00:32:49 jun>

  Date: $Date$
  Revision: $Revision$
*/

import java.awt.*;
import java.awt.event.*;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

import PreConditionPanel;
import VSCommandArea;

/**
 * Describe class <code>SearchCondition</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class SearchCondition 
    implements ActionListener {

    /**
     * Describe class <code>ACondition</code> here.
     *
     */
    class ACondition {
	/**
	 * Creates a new <code>ACondition</code> instance.
	 *
	 * @param type an <code>int</code> value
	 * @param s a <code>String</code> value
	 */
	public ACondition(int type, String s, ArrayList copyOfResults,
			  HashMap addressResults) {
	    this.type = type;
	    this.s = s;
	    this.copyOfResults = copyOfResults;
	    this.addressResults = addressResults;
	}

	/**
	 * Describe <code>getType</code> method here.
	 *
	 * @return an <code>int</code> value
	 */
	public int getType () {
	    return type;
	}

	/**
	 * Describe <code>getString</code> method here.
	 *
	 * @return a <code>String</code> value
	 */
	public String getString() {
	    return s;
	}

	/**
	 * Describe <code>getResults</code> method here.
	 *
	 * @return an <code>ArrayList</code> value
	 */
	public ArrayList getResults() {
	    // System.err.print("GET RESULTS\nSize :" + copyOfResults.size());
	    // System.err.println(", toString" + copyOfResults.toString());

	    return copyOfResults;
	}

	/**
	 * Describe <code>getAddressResults</code> method here.
	 *
	 * @return a <code>HashMap</code> value
	 */
	public HashMap getAddressResults() {
	    return addressResults;
	}

	/** */
	private int type = TYPE_NONE;
	/** */
	private String s = null;
	/** */
	private ArrayList copyOfResults = null;
	/** */
	private HashMap addressResults = null;
    }

    // condition type
    public static final int TYPE_NONE = 0;
    public static final int TYPE_WORD = 1;
    public static final int TYPE_FROM = 2;

    /**
     * Creates a new <code>SearchCondition</code> instance.
     *
     * @param pcp a <code>PreConditionPanel</code> value
     */
    public SearchCondition(PreConditionPanel pcp, VSCommandArea commandArea) {
	conditions = new ArrayList();
	this.pcp = pcp;
	this.commandArea = commandArea;
    }

    /**
     * Describe <code>add</code> method here.
     *
     * @param type an <code>int</code> value
     * @param s a <code>String</code> value
     */
    public void add(int type, String s, ArrayList results, 
		    HashMap addressResults) {
	Button cmd = new Button(s);
	ArrayList copyOfResults = new ArrayList();
	Iterator ite = results.iterator();
	while (ite.hasNext()) {
	    copyOfResults.add(ite.next());
	} // end of while (ite.hasNext())

	HashMap tmpAddressResults = (HashMap)addressResults.clone();
	
	//	copyOfResults.addAll(0,results);
	cmd.addActionListener(this);
	conditions.add(new ACondition(type, s, copyOfResults, tmpAddressResults));
	pcp.add(cmd);
    }

    /**
     * Describe <code>clear</code> method here.
     *
     */
    public void clear() {
	pcp.removeAll();
	conditions = new ArrayList();
    }

    /**
     * Describe <code>size</code> method here.
     *
     * @return an <code>int</code> value
     */
    public int size() {
	return conditions.size();
    }

    /**
     * Describe <code>getLastCondition</code> method here.
     *
     * @return a <code>String</code> value
     */
    public String getLastCondition() {
	if (this.size() == 0) return null;
	
	ACondition aCon = (ACondition)conditions.get(conditions.size()-1);
	return aCon.getString();
    }

    public int getLastType() {
	if (this.size() == 0) return TYPE_NONE;
	
	ACondition aCon = (ACondition)conditions.get(conditions.size()-1);
	return aCon.getType();
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e an <code>ActionEvent</code> value
     */
    public void actionPerformed(ActionEvent e) {
	int n = conditions.size();
	conditions.remove(n-1);
	pcp.removeLast();

	if (n-2>=0) {
	    ACondition cnd = (ACondition)conditions.get(n-2);
	    commandArea.setResults(cnd.getString(),
				   cnd.getResults(), 
				   cnd.getAddressResults(), 
				   cnd.getType());
	} else {
	    commandArea.setResults(null,null,null,TYPE_NONE);
	} // end of else
	
    }

    /** */
    private ArrayList conditions = null;
    
    /** */
    private PreConditionPanel pcp = null;

    /** */
    private VSCommandArea commandArea = null;
}
