/*
  (c) 2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/20 00:11:48 jun>

  Date: $Date$
  Revision: $Revision$

*/

import java.util.ArrayList;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;

import javax.mail.Message;

import CountByAddress;
import LinkInfo;
import Reference;
import SearchCondition;

/**
 * Describe class <code>SearchEngine</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
public class SearchEngine {

    public static final int MODE_NONE = 0;
    public static final int MODE_WORD = 1;
    public static final int MODE_ADDRESS = 2;

    /**
     * Creates a new <code>SearchEngine</code> instance.
     *
     * @param ref a <code>Reference</code> value
     */
    public SearchEngine(Reference ref) {
	this.ref = ref;
    }

    /**
     * Describe <code>searchAddress</code> method here.
     *
     * @param c a <code>String</code> value
     */
    public HashMap searchAddress(String from,
				 ArrayList results, 
				 SearchCondition conditions ) {
	HashMap pool = new HashMap();
	if (from == null || from.length() == 0) return pool;

	try {
	    // System.err.println("from = " + from);

	    addFromAddress(pool, from);
	    System.err.println("pool:"+pool);

	    addToAddress(pool, from);
	    System.err.println("pool:"+pool);
	    
	} catch (NullPointerException e) {
	    e.printStackTrace();
	} // end of try-catch

	return pool;
    }

    /**
     * Describe <code>addFromAddress</code> method here.
     *
     * @param pool a <code>HashMap</code> value
     * @param from a <code>String</code> value
     */
    private void addFromAddress(HashMap pool, String from) {
	HashMap counts = ref.getFromCount(from);
	System.err.println("countes:" + counts);
	if (counts == null) return ;
	Set keySet = counts.keySet();
	Iterator ite = keySet.iterator();
	    
	while (ite.hasNext()) {
	    String key = (String)ite.next();
	    int cnt = ((Vector)counts.get(key)).size();

	    // System.err.print("from:" + from );
	    // System.err.print(",to:" + key );
	    // System.err.println(",cnt:" + cnt );

	    LinkInfo li = (LinkInfo)pool.get(from);
	    if (li == null) li = new LinkInfo(from);			 
	    li.add(key,cnt);
	    pool.put(from, li);

	    HashMap mlCheck = ref.getFromCount(key);
	    //System.err.println("key:"+key+",mlcheck:"+mlcheck);
	    if (mlCheck == null || mlCheck.size() == 0) {
		addToAddress(pool, key);
	    } // end of if (cnt == null || cnt.size() == 0)
	} // end of while (ite.hasNext())
	return ;
    }

    /**
     * Describe <code>addToAddress</code> method here.
     *
     * @param pool a <code>HashMap</code> value
     * @param to a <code>String</code> value
     */
    private void addToAddress(HashMap pool, String to) {
	HashMap counts = ref.getToCount(to);
	// System.err.println("countes:" + counts);
	if (counts == null) return ;
	Iterator ite = counts.keySet().iterator();
	while (ite.hasNext()) {
	    String key = (String)ite.next();
	    int cnt = ((Vector)counts.get(key)).size();

	    //System.err.println("key:"+key);
	    LinkInfo li = (LinkInfo)pool.get(key);
	    if (li == null) li = new LinkInfo(key);
	    li.add(to, cnt);
	    pool.put(key, li);
	} // end of while (ite.hasNext())
	return ;
    }

    /**
     * Describe <code>searchWord</code> method here.
     *
     * @param c a <code>String</code> value
     */
    public ArrayList searchWord(String c, 
				ArrayList results, 
				SearchCondition conditions) {
	ArrayList rv = new ArrayList();

	if (conditions.size() == 0) {
	    Iterator ite = ref.getAllMsg();
	    while (ite.hasNext()) {
		String id = (String)ite.next();
		Message msg = null;

		// System.err.println("id = " + id);
		try {
		    msg = ref.getMsg(id);
		    String bodyText = MailFieldConvert.getBodyText(msg);

		    if (bodyText.indexOf(c) != -1) rv.add(id);
		} catch (MailFileException e) {
		} 
	    } // end of while (ite.hasNext())
	} else {
	    for (int i = 0; i < results.size(); i++) {
		 
		String id = (String)results.get(i);
		Message msg = null;
		try {
		    msg = ref.getMsg(id);
		    String bodyText = MailFieldConvert.getBodyText(msg);

		    if (bodyText.indexOf(c) != -1) rv.add(id);
		} catch (MailFileException e) {
		} // end of try-catch
	    } // end of while (ite.hasNext())
	    
	} // end of else
	// end of if (condistions.size() == 0)
	return rv;
    }

    /** */
    private Reference ref = null;
}
