/*
  (c) 2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/15 15:19:39 jun>
*/

import java.awt.*;
import sun.awt.*;
import java.awt.event.*;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Locale;

import EDU.auburn.VGJ.graph.Node;
import EDU.auburn.VGJ.gui.NodeBlink;

import MailGraphCanvas;
import MailGraphWindow;
import ThreadWord;
import TWData;

/**
 * Describe class <code>SearchWordPanel</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
public class SearchWordPanel 
    extends Panel 
    implements ActionListener {

    /** */
    static final int maxRows = 3;
    /** */
    static final int maxColumns = 8;

    /** ܥο */
    static final int NUMOFBUTTONS = 16;

    /** и٤ñбɽ */
    static final int pointX[] = {1,0,2,1,0,2,0,2,1,0,2,1,0,2,0,2};
    static final int pointY[] = {0,1,1,2,0,0,2,2,0,1,1,2,0,0,2,2};
    
    /**
     * Creates a new <code>SearchWordPanel</code> instance.
     *
     */
    public SearchWordPanel() {
	super();

	//	System.err.println("SearchWordPanel Created");

	setSize(300,300);

	GridBagConstraints gbc = new GridBagConstraints();
	setLayout(new VerticalBagLayout());

	Panel upperPanel = new Panel();	// Υѥͥ
	Panel lowerPanel = new Panel(); // Υѥͥ

	add(upperPanel);
	add(lowerPanel);

	GridBagLayout upperGbl = new GridBagLayout();
	GridBagLayout lowerGbl = new GridBagLayout();

	upperPanel.setLayout(upperGbl);
	lowerPanel.setLayout(lowerGbl);

	gbc.weightx = 0;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbc.fill = GridBagConstraints.VERTICAL;

	for (int i = 0; i < NUMOFBUTTONS; i++) {
	    Checkbox button = new Checkbox();
	    buttons[i] = button;

	    gbc.gridx = pointX[i];
	    gbc.gridy = pointY[i];

	    button.setVisible(false);
	    if (i < 8) {
		upperGbl.setConstraints(button, gbc);
		upperPanel.add(button);
	    } else {
		lowerGbl.setConstraints(button, gbc);
		lowerPanel.add(button);
	    } // end of else

	} // end of for (int i = 0; i < BUTTONS: i++)

	// BlackLabel
	Label dummyLabel = new Label();
	dummyLabel.setBackground(Color.black);

	gbc.gridx = 1;
	gbc.gridy = 1;
	upperGbl.setConstraints(dummyLabel, gbc);
	//	upperPanel.add(dummyLabel);

	dummyLabel = new Label();
	dummyLabel.setBackground(Color.black);
	lowerGbl.setConstraints(dummyLabel, gbc);
	//	lowerPanel.add(dummyLabel);
    }
    
    /**
     * Creates a new <code>add</code> instance.
     *
     * @param twd a <code>TWData[]</code> value
     */
    public void add(TWData[] twd){
	this.twd = twd;
	if (twd == null) return;

	int i = 0;

	invalidate();
	// ϿƤܥ
	clear();

	int maxLabels = NUMOFBUTTONS;
	if (twd.length<NUMOFBUTTONS) {
	    maxLabels = twd.length;
	} // end of if (twd.length)
	
	for (i = 0; i<maxLabels; i++) {
	    buttons[i].setLabel(twd[i].getString());
	    buttons[i].setVisible(true);
	} // end of for (i = 0; i<NUMOFLABELS; i++)

	// ϿǤܥο׻롣

	//	setSize(getParent().getWidth(), 100);
	setVisible(true);
		
	validate();
	getParent().repaint();
    }

    /**
     * checkboxΥ٥롣
     *
     */
    public  void clear() {
	for (int i = 0; i < NUMOFBUTTONS; i++) {
	    buttons[i].setLabel("");
	    buttons[i].setState(false);
	    buttons[i].setVisible(false);
	} // end of for (int i = 0; i < BUTTONS; i++)
    }

    /**
     * Describe <code>setMailGraphWindow</code> method here.
     *
     * @param mgw a <code>MailGraphWindow</code> value
     */
    public void setMailGraphWindow(MailGraphWindow mgw) {
	this.mgw = mgw;
	setNodeBlink(mgw.getNodeBlink());
    }

    public void setMailGraphCanvas(MailGraphCanvas mgc) {
	this.mgc = mgc;
	setNodeBlink(mgc.getNodeBlink());
    }

    /**
     * Describe <code>setNodeBlink</code> method here.
     *
     * @param nb a <code>NodeBlink</code> value
     */
    public void setNodeBlink(NodeBlink nb) {
	this.nb = nb;
    }

    /**
     * ܥ򤵤ȸƤӽФ
     *
     * @param e an <code>ActionEvent</code> value
     */
    public String[] getWords() {

	String words[] = new String[NUMOFBUTTONS];
	int j = 0;
	for (int i = 0; i < NUMOFBUTTONS; i++) {
	    if (buttons[i].getState()) {
		words[j++] = buttons[i].getLabel();
	    } // end of if (buttons[i].getState())
	} // end of for (i = 0; i < NUMOFBUTTONS; i++)

	return words;
    }

    public void actionPerformed(ActionEvent e) {
    }

    /** */
    private MailGraphWindow mgw = null;
    /** */
    private MailGraphCanvas mgc = null;

    /** */
    private NodeBlink nb = null;
    /** */
    private ThreadWord tw = null;

    /** */
    private TWData twd[] = null;

    private Checkbox buttons[] = new Checkbox[NUMOFBUTTONS];

    /** */
    GridBagLayout gbl = null;
    GridBagConstraints gbc = null;
}
