/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2002/11/19 23:12:05 jun>

 */
import java.awt.Menu;
import java.awt.MenuItem;
import java.awt.Frame;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import MailGraphCanvas;

/**
 * Describe class <code>SizeMenu</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class SizeMenu 
    extends Menu 
    implements ActionListener {

    /** */
    static final String SIZEMENULABEL = "Size: ";
    /** */
    static final int DEFAULTSIZE = 100;

    /**
     * Creates a new <code>SizeMenu</code> instance.
     *
     */
    public SizeMenu() {
	super(SIZEMENULABEL + DEFAULTSIZE);
	for (int i = 0; i < 4 ; i++)  {
	    MenuItem menuItem = new MenuItem((new Integer(i*25+25)).toString());
	    menuItem.addActionListener(this);
	    this.add(menuItem);
	} // end of for (int i = 0; i < MAXLEVEL; i++) )
    }    

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e an <code>ActionEvent</code> value
     */
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	try {
	    displaySize = Integer.parseInt(cmd);
	    setLabel(SIZEMENULABEL + displaySize);
	    mgc.setScale((double)displaySize / (double)100.00);
	    frame.invalidate();
	    frame.validate();
	} catch (NumberFormatException nfe) {
	} // end of try-catch
    }

    /**
     * Describe <code>setFrame</code> method here.
     *
     * @param frame a <code>Frame</code> value
     */
    public void setFrame(Frame frame) {
	this.frame = frame;
    }

    public void setMailGraphCanvas(MailGraphCanvas mgc) {
	this.mgc = mgc;
    }

    /** */
    private int displaySize = DEFAULTSIZE;

    /** */
    private Frame frame = null;

    /** */
    private MailGraphCanvas mgc = null;

}
