/*
  (c) 2002,2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.
  Time-stamp: <2003/02/23 22:49:10 jun>
 */

import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.mail.Message;

import MailFileException;
import MailString;
import Reference;
import RIImpl;
import TWData;

/**
 * Describe class <code>ThreadWord</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 * @date 2002/10/06
 */
public class ThreadWord 
    extends RIImpl {
    
    /**
     * Creates a new <code>ThreadWord</code> instance.
     *
     * @param ref a <code>Reference</code> value
     */
    public ThreadWord (Reference ref) {
	super();
	this.ref = ref;
    }

    /**
     * Describe <code>doIt</code> method here.
     *
     * @return a <code>Vector</code> value
     */
    public Vector doIt(String msgId, Vector eo) 
	throws MailFileException {

	// System.err.println("MsgId: " + msgId);
	
	/** å ʸФ */
	Message msg = ref.getMsg(msgId);
	if ( msg == null ) return null;
	String s = MailFieldConvert.getBodyText(msg);

	String parsed = null;
	/** ǲϤ򤹤 */
	try {
	    parsed = Chasen.parse(s);	     
	} catch (java.lang.Exception e) {
	    e.printStackTrace();
	} // end of try-catch
	
	/** ñνи */
	HashMap countAMail = calc(parsed, msgId);

	/** ñνиγ׻ */
	int total = ((Integer)countAMail.get(WORDSTOTAL)).intValue();
	Set wordSet = countAMail.keySet();
	Iterator ite = wordSet.iterator();
	if (total == 0) total = 1;
	
	while (ite.hasNext()) {
	    String k = (String)ite.next();
	    int c = ((Integer)countAMail.get(k)).intValue();
	    int p = c * KEISU / total;

	    /** ΥݥȤ˲û */	    
	    Integer v = (Integer)wordCount.get(k);
	    if (v == null) 
		v = new Integer(p);
	    else 
		v = new Integer(v.intValue() + p);
	    wordCount.put(k, v);
	    // end of if (v == null)
	    
	} // end of while (ite.hasNext())
	return null;
    }


    /** 
     * и̾(̾Ͽ
     * @param s
     * @param lines
     */
    private HashMap calc(String s, String msgId) {
	// иǼ
	HashMap wordCnt = new HashMap();

	// ñΥ
	int total = 0;

	// 
	StringTokenizer lineSt = new StringTokenizer(s, "\n");
	while(lineSt.hasMoreTokens()) {
	    String line = lineSt.nextToken();
	    //	System.err.println("line = " +line);
	    //  UnixǤǥƥ󥹤νEOSǼƤ롣
	    if ( line.equals("EOS") ) continue;
	    if ( line.equals("EOM") ) continue;

	    StringTokenizer blockSt = new StringTokenizer(line);

	    // ꥸʥ
	    String org = blockSt.nextToken();
	    // ɤ
	    String kana = blockSt.nextToken();
	    // ܷ
	    String kihon = blockSt.nextToken();
	    // ʻ
	    String hinsi = blockSt.nextToken();

	    // ʸûñ
	    if (kihon.length() < MINIMUMLENGTH) continue;

	    MailString kihon2 = new MailString(kihon);

	    if (
		// ̾ǡ̾졢졢Ω̵Τԥååפ
		(hinsi.indexOf("̾") != -1 && 
		 ( hinsi.indexOf("̾") == -1  &&
		   hinsi.indexOf("") == -1  &&
		   hinsi.indexOf("Ω") == -1  )
		 ) || (
		       //̤θǡѿʪĤ
		       hinsi.indexOf("̤θ") != -1 &&
		       kihon2.isLetterAndDigit()
		       )
		 ) {
		// System.err.println(hinsi);
		// if (hinsi.indexOf("̤θ") != -1) System.err.println(kihon);
		Integer ix = (Integer)wordCnt.get(kihon);
		total++;
		if ( ix == null ) 
		    wordCnt.put(kihon, new Integer(1));
		 else
		    wordCnt.put(kihon, new Integer(ix.intValue() + 1));
		putWordPlace(kihon, msgId);
	    }
	}

	wordCnt.put(WORDSTOTAL,new Integer(total));
	return wordCnt;
    }

    /**
     * Describe <code>countWordInThisMail</code> method here.
     *
     * @param msgId a <code>String</code> value
     */
    public void countWordInThisMail(String msgId) {
	wordCount = new HashMap();
	wordPlace = new HashMap();
	try {
	    doIt(msgId, null);	     
	} catch (MailFileException e) {
	    e.printStackTrace();
	} // end of try-catch
    }

    /**
     * Describe <code>CountThisThread</code> method here.
     *
     * @param msgId a <code>String</code> value
     */
    public void countWordInThisThread(String msgId) {
	wordCount = new HashMap();
	wordPlace = new HashMap();
	String topMsgId = ref.getTop(msgId);
	//	ref.enumerationFromBottom(msgId, this);
	ref.enumerationFromBottom(topMsgId, this);
    }

    /**
     * Describe <code>countWordInThisGroup</code> method here.
     *
     * @param msgIds an <code>ArrayList</code> value
     */
    public void countWordInThisGroup(ArrayList msgIds) {
	wordCount = new HashMap();
	wordPlace = new HashMap();
	Iterator ite = msgIds.iterator();
	while (ite.hasNext()) {
	    try {
		doIt((String)ite.next(), null);	     
	    } catch (MailFileException e) {
		e.printStackTrace();
	    } // end of try-catch
	} // end of while (ite.hasNext())
    }

    /**
     * Describe <code>getCountr</code> method here.
     *
     * @return a <code>HashMap</code> value
     */
    public HashMap getWordCount() {
	return wordCount;
    }

    /**
     * Describe <code>getOrderedCount</code> method here.
     *
     * @return a <code>TWData[]</code> value
     */
    public TWData[] getOrderedCount() {
	int size = wordCount.size();

	TWData twd[] = new TWData[size-1];
	int i = 0;

	// Arrays 饹sort ᥽åɤȤˡ˳Ǽ롣
	Iterator ite = (wordCount.keySet()).iterator();
	while (ite.hasNext()) {
	    String k = (String)ite.next();
	    if (k.equals(WORDSTOTAL)) {
		continue;
	    } // end of if (k.equals())
	    
	    twd[i++] = new TWData(k,((Integer)wordCount.get(k)).intValue());
	} // end of while (ite.hasNext())

	// ߽˥Ȥ
	Arrays.sort(twd, new TWData());
	return twd;
    }

    /**
     * Describe <code>getWordPlace</code> method here.
     *
     * @param word a <code>String</code> value
     * @return an <code>Iterator</code> value
     */
    public Iterator getWordPlace(String word) {
	HashMap v = (HashMap)wordPlace.get(word);
	if (v == null) return null;
	
	return (v.keySet()).iterator();
    }

    /**
     * Describe <code>putWordPlace</code> method here.
     *
     * @param word a <code>String</code> value
     * @param msgId a <code>String</code> value
     */
    private void putWordPlace(String word, String msgId) {
	HashMap v = (HashMap)wordPlace.get(word);
	if (v == null) {
	    v = new HashMap();
	    v.put(msgId,msgId);
	    wordPlace.put(word, v);
	} // end of if (v == null)
	else {
	    if (!v.containsKey(msgId)) {
		v.put(msgId,msgId);
		wordPlace.put(word, v);
	    } // end of if (v.containsKeys(msgId))
	} // end of else
    }

    // ѿ
    /**
     * Describe variable <code>ref</code> here.
     *
     */
    private Reference ref = null;

    /**
     * Describe variable <code>wordCount</code> here.
     *
     */
    private HashMap wordCount = null;

    private HashMap wordPlace = null;

    // 
    /**
     * Describe constant <code>WORDSTOTAL</code> here.
     *
     */
    private static final String WORDSTOTAL = "***WORDSTOTAL***";

    /**
     * Describe constant <code>KEISU</code> here.
     *
     */
    private static final int KEISU = 1000;

    /**
     * Describe constant <code>MINIMUMLENGTH</code> here.
     *
     */
    private static final int MINIMUMLENGTH = 2;
}

    
