/*
  (c) 2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/23 22:37:27 jun>

  Date: $Date$
  Revision: $Revision$

*/

import java.awt.*;
import java.awt.event.*;
import sun.awt.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;
import java.util.Set;
import java.util.Vector;

import CountByAddress;
import PreConditionPanel;
import Reference;
import ThreadWord;
import TWData;
import SearchCondition;
import SearchEngine;
import SearchWordPanel;
import VisualSearchArea;

/**
 * Describe class <code>VSCommandArea</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class VSCommandArea 
    extends Panel 
    implements ActionListener {

    // width of text field
    static final int TXTLENGTH = 20;

    /** ޥɥܥ ٥ */
    static final String CLEAR = "򥯥ꥢ";
    static final String SEARCH = "ξǸ";

    static final int LEVELS = 6;

    static final int GAP = 2;

    public VSCommandArea(Frame frame, Reference ref) {
	super()	;
	setLocale(Locale.JAPANESE);

	// FrameǼ
	this.frame = frame;

	// Reference Ǽ
	this.ref = ref;
	searchEngine = new SearchEngine(ref);

	// conditions, results 

	results = new ArrayList();
	addressResults = new HashMap();

	// ɥΥꤹ
	setSize(150,760);

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	setLayout(gbl);
	//	VerticalBagLayout gbl = new VerticalBagLayout(GAP);
	//	setLayout(gbl);

	gbc.weightx = 10;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;

	gbc.weightx = 1;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;

	gbc.fill = GridBagConstraints.VERTICAL;

	// ٥롣
	Label label =  new Label ("ꥨꥢ");
	gbc.gridx = 0;
	gbc.gridy = 0;
	gbc.gridwidth = 4;
	gbl.setConstraints(label, gbc);
	add(label);

	// ϥꥢ롣
	label = new Label("ᥤ륢ɥ쥹:");
	gbc.gridx = 0;
	gbc.gridy = 1;
	gbc.gridwidth = 1;
	gbl.setConstraints(label, gbc);
	add(label);

	fromText =  new TextField(TXTLENGTH);
	// fromText.setText("jun-krb@mars.dti.ne.jp");
	fromText.setText("");
	gbc.gridx = 1;
	gbc.gridy = 1;
	gbc.gridwidth = 3;
	gbl.setConstraints(fromText, gbc);
	add(fromText);
	
	/*
	  label = new Label("To:");
	  gbc.gridx = 0;
	  gbc.gridy = 2;
	  gbc.gridwidth = 1;
	  gbl.setConstraints(label, gbc);
	  add(label);

	  toText =  new TextField(TXTLENGTH);
	  toText.setText("mitou13@mediafront.co.jp");
	  gbc.gridx = 1;
	  gbc.gridy = 2;
	  gbc.gridwidth = 1;
	  gbl.setConstraints(toText, gbc);
	  add(toText);
	*/

	label = new Label("ñ:");
	gbc.gridx = 0;
	gbc.gridy = 2;
	gbc.gridwidth = 1;
	gbl.setConstraints(label, gbc);
	add(label);

	searchText =  new TextField(TXTLENGTH);
	// searchText.setText("");
	searchText.setText("");
	gbc.gridx = 1;
	gbc.gridy = 2;
	gbc.gridwidth = 3;
	gbl.setConstraints(searchText, gbc);
	add(searchText);

	// ܥ롣
	Button searchCmd = new Button(SEARCH);
	gbc.gridx = 0;
	gbc.gridy = 3;
	gbc.gridwidth = 2;
	gbl.setConstraints(searchCmd, gbc);
	add(searchCmd);
	searchCmd.addActionListener(this);

	// ꥢܥ롣
	Button clearCmd = new Button(CLEAR);
	gbc.gridx = 2;
	gbc.gridy = 3;
	gbc.gridwidth = 2;
	gbl.setConstraints(clearCmd, gbc);
	add(clearCmd);
	clearCmd.addActionListener(this);

	// ѽñɽꥢ롣
	label =  new Label (" ̤˴ޤޤѽñ ");
	gbc.gridx = 0;
	gbc.gridy = 4;
	gbc.gridwidth = 4;
	gbl.setConstraints(label, gbc);
	label.setAlignment(Label.CENTER);
	label.setForeground(Color.white);
	label.setBackground(Color.black);
	add(label);

	searchWordPanel = new SearchWordPanel();
	gbc.gridx = 0;
	gbc.gridy = 5;
	gbc.gridwidth = 4;
	gbl.setConstraints(searchWordPanel, gbc);
	add(searchWordPanel);

	searchWord = new Button("åñˤ븡"); 
	searchWord.addActionListener(this);
	gbc.gridx = 0;
	gbc.gridy = 6;
	gbc.gridwidth = 4;
	gbl.setConstraints(searchWord, gbc);
	add(searchWord);
	searchWord.setEnabled(false);

	setWord = new Button("åñˤʤ"); 
	setWord.addActionListener(this);
	gbc.gridx = 0;
	gbc.gridy = 7;
	gbc.gridwidth = 4;
	gbl.setConstraints(setWord, gbc);
	add(setWord);
	setWord.setEnabled(false);

	Label dummy = new Label(" ");
	gbc.gridx = 0;
	gbc.gridy = 8;
	gbc.gridwidth = 4;
	gbl.setConstraints(dummy, gbc);
	add(dummy);

	// ꥹ
	label =  new Label (" θ򤷤 ");
	gbc.gridx = 0;
	gbc.gridy = 9;
	gbc.gridwidth = 4;
	gbl.setConstraints(label, gbc);
	label.setAlignment(Label.CENTER);
	label.setForeground(Color.white);
	label.setBackground(Color.black);
	add(label);

	label =  new Label ("åȾǤޤ");
	gbc.gridx = 0;
	gbc.gridy = 10;
	gbc.gridwidth = 4;
	gbl.setConstraints(label, gbc);
	label.setAlignment(Label.CENTER);
	label.setForeground(Color.white);
	label.setBackground(Color.black);
	add(label);

	pcp =  new PreConditionPanel();
	gbc.gridx = 0;
	gbc.gridy = 11;
	gbc.gridwidth = 4;
	gbl.setConstraints(pcp, gbc);
	add(pcp);

	conditions = new SearchCondition(pcp,this);
    }

    /**
     * Describe <code>actionPerformed</code> method here.
     *
     * @param e an <code>ActionEvent</code> value
     */
    public void actionPerformed(ActionEvent e) {
	try {
	    getParent().setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));	
	    if (e.paramString().indexOf(searchWord.getLabel()) != -1) {
		doSearch(searchWordPanel.getWords());
		return;
	    } // end of if (e.source.equals(searchButton))

	    if (e.paramString().indexOf(setWord.getLabel()) != -1 ) {
		doSet(searchWordPanel.getWords());
		return;
	    } // end of if (e.source.equals(setButton))

	    // ̤򥯥ꥢ롣
	    if (e.getActionCommand().equals(CLEAR)) {
		clear();
		return;
	    } // end of if (e.getActionCommand().equals("Search"))

	    fromText.setEnabled(false);
	    if (e.getActionCommand().equals(SEARCH)) {
		String condText = searchText.getText();
		String from = fromText.getText();
		
		ArrayList changedObj = null;

		if ((condText == null || condText.length() == 0)
		    && (from == null || from.length() == 0) &&
		    visualSearchArea.getCanvas().getSelectedAddress()==null) {
		    return ;
		} // end of if (condText == null && condText.length() == 0 && from == null || from.length() == 0)

		if ((results == null || results.size() == 0 ) 
		    && visualSearchArea.getCanvas().getSelectedAddress() != null) {
		    String address = visualSearchArea.getCanvas().getSelectedAddress();
		    String addr2 = conditions.getLastCondition();

		    if (results == null) 
			results = new ArrayList();

		    try {
			// System.err.println("addrs2:"+addr2);
			HashMap local = (HashMap)ref.getFromCount(addr2);
			// System.err.println("local:"+local);
			Vector addrs = (Vector)local.get(address);

			for (int i = 0; i < addrs.size(); i++) {
			    results.add(addrs.get(i));
			} // end of for (int i = 0; i < addrs.size(); i++)
		    } catch (NullPointerException ne) {
			
		    } // end of try-catch
		    
		    try {
			HashMap local = (HashMap)ref.getToCount(addr2);
			Vector addrs = (Vector)local.get(address);
			for (int i = 0; i < addrs.size(); i++) {
			    results.add(addrs.get(i));
			} // end of for (int i = 0; i < addrs.size(); i++)
			 
		    } catch (NullPointerException ne) {
			
		    } // end of try-catch
		    
		    
		} // end of if (visualSearchArea.getSelectedAddress != null)

		// Ԥ
		int mode = SearchEngine.MODE_WORD;
		if (from.length() != 0) mode = SearchEngine.MODE_ADDRESS;

		switch (mode) {
		case SearchEngine.MODE_WORD:
		    if (conditions.size() != 0) {
			if (conditions.getLastType() == SearchCondition.TYPE_FROM) {
			    copyFromResults(conditions.getLastCondition());
			    copyToResults(conditions.getLastCondition());
			} // end of if (conditions.getLastType == SearchCondition.TYPE_FROM)
		    } // end of if (conditions.size() == 0)
		    
		    changedObj = searchEngine.searchWord(condText, results, conditions);		    
		    visualSearchArea.setMode(VisualSearchArea.MODE_MSGID);
		    System.err.println("changedObj.size = " + changedObj.size());
		    break;
		case SearchEngine.MODE_ADDRESS:
		    addressResults = searchEngine.searchAddress(from, results, conditions);
		    visualSearchArea.setMode(VisualSearchArea.MODE_ADDRESS);
		    break;
		default:
		    break;
		} // end of switch (mode)

		// 襨ꥢ򹹿ˤ롣
		visualSearchArea.invalidate();

		// 襨ꥢ򥯥ꥢ
		visualSearchArea.clearSpace();

		switch (mode) {
		case SearchEngine.MODE_WORD:   {
		    // Τѽñ׻롣
		    results = changedObj;
		    addResultByWord();
		}		 
		    break;
		case SearchEngine.MODE_ADDRESS: {
		    // results = changedObj;
		    if (addressResults.size() != 0) 
			visualSearchArea.addNode(from, addressResults);
		} 		    
		    break;
		
		default:
		
		    break;
		} // end of switch (mode)
	    
		// ɲä롣
		addCondition(condText, from);

		// 롣
		fromText.setText("");
		searchText.setText("");

		getParent().invalidate();
		getParent().validate();

		frame.invalidate();
		frame.validate();
		return;
	    } // end of if (e.getActionCommand().equals("Search"))
	} catch (NullPointerException nullPointer) {
	    nullPointer.printStackTrace();
	} // end of catch
	
	finally {
	    visualSearchArea.getCanvas().invalidate();
	    visualSearchArea.getCanvas().validate();
	    visualSearchArea.getCanvas().repaint();	
		
	    getParent().invalidate();
	    getParent().validate();

	    getParent().setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	} // end of finally
	
    }

    /**
     * Describe <code>copyFromResults</code> method here.
     *
     */
    private void copyFromResults (String addr) {
	HashMap counts = ref.getFromCount(addr);
	System.err.println("countes(From):" + counts);
	if (counts == null) return ;
	Set keySet = counts.keySet();
	Iterator ite = keySet.iterator();
	    
	while (ite.hasNext()) {
	    String key = (String)ite.next();
	    Vector msgIds = (Vector)counts.get(key);

	    Enumeration enu = msgIds.elements();
	    while (enu.hasMoreElements()) {
		String msgId = (String)enu.nextElement();
		if (!results.contains(msgId)) {
		    results.add(msgId);
		} // end of if (!results.containts(msgId))
		
	    } // end of while (enu.hasNextElements())

	    HashMap mlCheck = ref.getFromCount(key);
	    //System.err.println("key:"+key+",mlcheck:"+mlcheck);
	    if (mlCheck == null || mlCheck.size() == 0) {
		copyToResults(key);
	    } // end of if (cnt == null || cnt.size() == 0)
	} // end of while (ite.hasNext())
    }

    /**
     * Describe <code>copyToResults</code> method here.
     *
     * @param addr a <code>String</code> value
     */
    private void copyToResults (String addr) {
	HashMap counts = ref.getToCount(addr);
	System.err.println("countes(To):" + counts);
	if (counts == null) return ;
	Set keySet = counts.keySet();
	Iterator ite = keySet.iterator();
	    
	while (ite.hasNext()) {
	    String key = (String)ite.next();
	    Vector msgIds = (Vector)counts.get(key);

	    Enumeration enu = msgIds.elements();
	    while (enu.hasMoreElements()) {
		String msgId = (String)enu.nextElement();
		if (!results.contains(msgId)) {
		    results.add(msgId);
		} // end of if (!results.containts(msgId))
		
	    } // end of while (enu.hasNextElements())
	} // end of while (ite.hasNext())
    }

    /**
     * Describe <code>addResultByWord</code> method here.
     *
     */
    private void addResultByWord() {
	ThreadWord tw = new ThreadWord(ref);
	tw.countWordInThisGroup(results);
	twd = tw.getOrderedCount();

	HashMap totalOrder = new HashMap();

	int j = 1;
	for (int i = 0; i<twd.length; i++) {
	    totalOrder.put(twd[i].getString(), new Integer(j++));
	} // end of for (int i = 0; i<twd.length; i++)

	ThreadWord tw2 = new ThreadWord(ref);
	int orders [] = new int[LEVELS];

	// ѽñ˴ŤơޥåפƤ椯
	Iterator ite = results.iterator();
	while (ite.hasNext()) {
	    String msgId = (String)ite.next();
	    tw2.countWordInThisMail(msgId);	    
	    TWData twd2[] = tw2.getOrderedCount();

	    for (int i = 0; i< twd2.length; i++) {
		String s = twd2[i].getString();
		twd2[i].setCount(((Integer)totalOrder.get(s)).intValue());
	    } // end of for (int i = 0; i< twd2.length; i++)

	    Arrays.sort(twd2, new TWData());

	    for (j = 0; j<LEVELS;j++) {
		orders[j]=0;
	    } // end of for (j = 0)
	    
	    j = 0;
	    for (int i = twd2.length-1; i >=0; i--) {
		orders[j++] = twd2[i].getCount();
		if (j >= LEVELS) break;
	    } // end of for (int i = twd2.length-1; i >=0; i--)
	    visualSearchArea.addNode(orders, msgId);
	} // end of while (ite.hasNext())
		 

	// ѽñɽ
	searchWordPanel.add(twd);
	searchWord.setEnabled(true);
	setWord.setEnabled(true);
	
	//	System.err.println("getParent" + getParent());
	getParent().invalidate();
	getParent().validate();
	//	getParent().repaint();

    }

    /**
     * Describe <code>doSearch</code> method here.
     *
     * @param words[] a <code>String</code> value
     */
    private void doSearch(String words[]) {
	// System.err.println("doSearch Called:");
	ArrayList allChanged = results;

	for (int i = 0; words[i] != null; i++) {
	    // System.err.println("Words =" + words[i]);
	    allChanged = searchEngine.searchWord(words[i], allChanged, conditions);
	} // end of while (words[i] != null)

	// System.err.println("All Changed Size " + allChanged.size());

	visualSearchArea.invalidate();
	for (int i = 0; i < results.size(); i++) {
	    visualSearchArea.setState((String)results.get(i), NodeState.MARKED);
	} // end of for (int i = 0; i < results.size(); i++)
			
	for (int i = 0; i < allChanged.size(); i++) {
	    visualSearchArea.setState((String)allChanged.get(i), NodeState.TEMPORARY_MARKED);
	} // end of for (int i = 0; i < results.size(); i++)
	
	visualSearchArea.setMode(VisualSearchArea.MODE_MSGID);
	visualSearchArea.getCanvas().repaint();	
	//	visualSearchArea.validate();
    }

    /**
     * Describe <code>doSet</code> method here.
     *
     * @param words[] a <code>String</code> value
     */
    private void doSet(String words[]) {
	// System.err.println("doSet Called:");
	ArrayList allChanged = results;

	StringBuffer allWords = new StringBuffer();
	for (int i = 0; words[i] != null; i++) {
	    //  System.err.println("Words =" + words[i]);

	    allChanged = searchEngine.searchWord(words[i], allChanged, conditions);
	    if (i > 0) 	allWords.append(",");
	    allWords.append(words[i]);

	} // end of while (words[i] != null)

	// 襨ꥢ򹹿ˤ롣
	visualSearchArea.invalidate();

	// 襨ꥢ򥯥ꥢ
	visualSearchArea.clearSpace();

	results = allChanged;
	addResultByWord();

	addCondition(allWords.toString(), null);

	// 롣
	fromText.setText("");
	searchText.setText("");

	// ̤褹
	visualSearchArea.getCanvas().repaint();	

	getParent().invalidate();
	getParent().validate();
    }

    /**
     * Describe <code>setResults</code> method here.
     *
     * @param results an <code>ArrayList</code> value
     * @param mode an <code>int</code> value
     */
    public void setResults(String s,
			   ArrayList results, 
			   HashMap addressResults, int mode) {
	if (results == null) {
	    this.clear();
	    return;
	} // end of if (results != null)

	visualSearchArea.invalidate();

	// 襨ꥢ򥯥ꥢ
	visualSearchArea.clearSpace();

	this.results = results;
	this.addressResults = addressResults;

	switch (mode) {
	case SearchEngine.MODE_WORD:
	    visualSearchArea.setMode(VisualSearchArea.MODE_MSGID);
	    addResultByWord();
	    break;
	case SearchEngine.MODE_ADDRESS:
	    visualSearchArea.setMode(VisualSearchArea.MODE_ADDRESS);
	    if (addressResults.size() != 0) 
		visualSearchArea.addNode(s, addressResults);
	    break;
	default:
	    break;
	}

	// 롣
	fromText.setText("");
	searchText.setText("");

	// ̤褹
	visualSearchArea.getCanvas().repaint();	

	getParent().invalidate();
	getParent().validate();
    }

    /**
     * Describe <code>addCondition</code> method here.
     *
     * @param condText a <code>String</code> value
     */
    private void addCondition(String condText, String fromText) {
	int mode = SearchCondition.TYPE_WORD;
	String s = condText;
	
	if (fromText != null && fromText.length() != 0) {
	    mode = SearchCondition.TYPE_FROM;
	    s = fromText;
	}

	conditions.add(mode, s, results, addressResults);
    }

    /**
     * Describe <code>clear</code> method here.
     *
     */
    private void clear(){
	visualSearchArea.invalidate();
	visualSearchArea.clearSpace();

	getParent().invalidate();
	results.clear();

	addressResults = new HashMap();

	tmpResults = null;
	getParent().validate();

	conditions.clear();

	fromText.setEnabled(true);

	// searchText.setText("");
	// fromText.setText("jun-krb@mars.dti.ne.jp");
	searchText.setText("");
	fromText.setText("");

	searchWordPanel.clear();
	searchWordPanel.setVisible(false);

	setWord.setEnabled(false);
	searchWord.setEnabled(false);

	pcp.removeAll();
	getParent().repaint();
    }

    /**
     * Describe <code>addSearchArea</code> method here.
     *
     * @param visualSearchArea a <code>VisualSearchArea</code> value
     */
    public void addSearchArea(VisualSearchArea visualSearchArea) {
	this.visualSearchArea = visualSearchArea;
    }

    /** */
    PreConditionPanel pcp = null;

    /** */
    TextField fromText = null;
    TextField searchText = null;

    /** */
    private ArrayList results = null;
    private ArrayList tmpResults = null;

    private HashMap addressResults = null;

    /** */
    private SearchCondition conditions = null;

    /** */
    private Reference ref = null;

    /** */
    private Frame frame = null;

    /** */
    Button searchWord = null;
    Button setWord = null;

    /** */
    private VisualSearchArea visualSearchArea = null;

    /** */
    private SearchWordPanel searchWordPanel = null;

    /** */
    private SearchEngine searchEngine = null;

    /** */
    TWData twd[] = null;
}
