/*
  (c) 2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/19 00:55:05 jun>

  $Date$
  $Revision$
*/

import java.awt.*;
import java.awt.event.*;
import sun.awt.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Locale;
import java.util.Vector;

import CountByAddress;
import PreConditionPanel;
import Reference;
import ThreadWord;
import TWData;
import SearchCondition;
import SearchWordPanel;
import VisualSearchArea;
import VSCommandArea;

/**
 * Describe class <code>VisualSearch</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class VisualSearch 
    extends Frame {

    /**
     * Creates a new <code>VisualSearch</code> instance.
     *
     * @param parent a <code>Frame</code> value
     */
    public VisualSearch (Frame parent, Reference ref) {
	super();
	setLocale(Locale.JAPANESE);

	this.ref = ref;
	this.frame = parent;

	setSize(Preface.FRAME_WIDTH,Preface.FRAME_HEIGHT);

	Panel panel = new Panel();
	add(panel);

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	panel.setLayout(gbl);
	
	gbc.weightx = 10;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;

	gbc.fill = GridBagConstraints.VERTICAL;

	// Command Area
	VSCommandArea cmdArea = new VSCommandArea(parent, ref);
	gbc.gridx = 0;
	gbc.gridy = 0;
	gbc.gridwidth = 1;
	gbc.gridheight = 2;
	gbl.setConstraints(cmdArea, gbc);
	panel.add(cmdArea);

	Label label =  new Label ("ɽꥢ");
	gbc.gridx = 1;
	gbc.gridy = 0;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbl.setConstraints(label, gbc);
	panel.add(label);

	VisualSearchArea visualSearchArea = new VisualSearchArea(parent, ref);
	gbc.gridx = 1;
	gbc.gridy = 1;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbl.setConstraints(visualSearchArea, gbc);
	panel.add(visualSearchArea);

	cmdArea.addSearchArea(visualSearchArea);
    }

    /** */
    private Reference ref = null;

    /** */
    private Frame frame = null;
}

