import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;

import Preface;
import PrefaceLog;
import PrefaceLogListener;

/**
 * Describe class <code>WordOutLog</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class WordOutLog
    implements PrefaceLogListener {
    /** */
    static public PrintStream out = System.out;

    /** */
    static private final String propKey = "wordoutlog";

    static {
	System.err.println("WordoutLog called");
	PrefaceLog.addListener(new WordOutLog());
    }

    /**
     * Describe <code>startLog</code> method here.
     *
     * @param ext a <code>String</code> value
     */
    public void startLog(String ext) {
	String logDir   = PrefaceLog.getDir();
	String fileName = Preface.mp.getProperty(propKey);
	if (fileName == null || fileName.equals("")) {
	    fileName="WordOutLog";
	} // end of if (fileName == null || fileName.equals(""))

	fileName = fileName + "_" + ext;

	File f = new File(logDir + "/" + fileName);
	try {
	    FileOutputStream fos = new FileOutputStream(f);
	    out = new PrintStream(fos);
	} catch (FileNotFoundException e) {
	    System.err.println("WordOutLog FileNotFound");
	    out = System.out;
	} // end of try-catch
    }

    /**
     * Describe <code>finishLog</code> method here.
     *
     */
    public void finishLog() {
	out.flush();
	out = System.out;
    }
}
