/*
  (c) 2002,2003 Jun Kurabe and Hiroshi Ichiji. All rights reserved.

  Time-stamp: <2003/02/05 22:58:17 jun>
*/

import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Locale;

import EDU.auburn.VGJ.graph.Node;
import EDU.auburn.VGJ.gui.NodeBlink;

import MailGraphCanvas;
import MailGraphWindow;
import ThreadWord;
import TWData;

/**
 * Describe class <code>WordPanel</code> here.
 *
 * @author <a href="mailto:jun-krb@mars.dti.ne.jp">Jun Kurabe</a>
 * @version 1.0
 */
class WordPanel 
    extends Panel 
    implements ActionListener {
    /** */
    static final int maxRows = 3;
    /** */
    static final int maxColumns = 8;
    
    /**
     * Creates a new <code>WordPanel</code> instance.
     *
     */
    public WordPanel() {
	super();
	gbl = new GridBagLayout();
	gbc = new GridBagConstraints();
	setLayout(gbl);
    }
    
    /**
     * Creates a new <code>add</code> instance.
     *
     * @param twd a <code>TWData[]</code> value
     */
    public void add(ThreadWord tw){
	this.tw = tw;

	TWData[] twd = tw.getOrderedCount();
	int i = 0;

	// ϿƤܥ
	removeAll();

	// ϿǤܥο׻롣
	int maxItems = maxRows * maxColumns;

	//ܥѥͥĥդ
	gbc.weightx = 0;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbc.fill = GridBagConstraints.VERTICAL;

	int x = 0;
	int y = 0;

	int width = 0;
	int maxWidth = getParent().getSize().width-5;

	while (i < twd.length && i < maxItems) {

	    if (x > maxColumns) {
		y++;
		x=0;
	    } // end of if (x > maxColumns)

	    Button button = new Button(twd[i].getString());
	    button.setLocale(Locale.JAPANESE);
	    button.addActionListener(this);

	    gbc.gridx = x;
	    gbc.gridy = y;
	    gbl.setConstraints(button, gbc);
	    button.setBackground(Color.green);

	    add(button);

	    x++;
	    i++;

	} // end of while (i < twd.length)

	//	setSize(getParent().getWidth(), 100);
	getParent().validate();
    }

    /**
     * Describe <code>setMailGraphWindow</code> method here.
     *
     * @param mgw a <code>MailGraphWindow</code> value
     */
    public void setMailGraphWindow(MailGraphWindow mgw) {
	this.mgw = mgw;
	setNodeBlink(mgw.getNodeBlink());
    }

    public void setMailGraphCanvas(MailGraphCanvas mgc) {
	this.mgc = mgc;
	setNodeBlink(mgc.getNodeBlink());
    }

    /**
     * Describe <code>setNodeBlink</code> method here.
     *
     * @param nb a <code>NodeBlink</code> value
     */
    public void setNodeBlink(NodeBlink nb) {
	this.nb = nb;
    }

    /**
     * ܥ򤵤ȸƤӽФ
     *
     * @param e an <code>ActionEvent</code> value
     */
    public void actionPerformed(ActionEvent e) {
	if (mgw == null) {
	    if (mgc == null) {
		return;
	    } // end of if (mgc == null)
	} // end of if (mgw == null)

	nb.stop();

	// ܥΥ٥
	String label = e.getActionCommand();

	// ޡ򥯥ꥢ
	Enumeration enu = mgw!=null?mgw.getNodes():mgc.getNodes();
	while (enu.hasMoreElements()) {
	    Node n = (Node)enu.nextElement();
	    n.setMark(false);
	}

	// Ρɤޡե饰ꤹ	
	enu = mgw!=null?mgw.getNodes():mgc.getNodes();
	while (enu.hasMoreElements()) {
	    Node n = (Node)enu.nextElement();
	    Iterator ite = tw.getWordPlace(label);
	    while (ite.hasNext()) {
		String msgId = (String)ite.next();
		//		System.err.print("MsgId: " + msgId + ": ");
		//		System.err.println(n.data_.get(MailGraphWindow.PROP_MSGID));
		if (msgId.equals((String)(n.data_.get(MailGraphWindow.PROP_MSGID)))) {
		    n.setMark(true);		     
		    //		    System.err.println("***");
		    break;
		} // end of if (msgId.equals(n.data_.get("msgId"))
	    } // end of while (hasNext())
	} // end of while (e.hasMoreElements())
	nb.start();
    }

    /** */
    private MailGraphWindow mgw = null;
    /** */
    private MailGraphCanvas mgc = null;
    /** */
    private NodeBlink nb = null;
    /** */
    private ThreadWord tw = null;

    /** */
    GridBagLayout gbl = null;
    GridBagConstraints gbc = null;
}
