/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
//package jp.co.lmer.mail;

import java.awt.*;
import java.util.Vector;
import javax.mail.*;
import java.io.IOException;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.FileNotFoundException;

import MailFieldConvert;
import MailFileException;
import MailProperties;
import Reference;
import ReferenceInterface;

/** 
 *@author Jun Kurabe
 *@author Hiroshi Ichiji
 *@date   2001/11/11
 *@date   2002/01/26
*/

public class AbsContents 
    extends TextArea
	    //    implements ReferenceInterface 
{
    /** */
    public static final int NOMESSAGE = -1;

    /** 
     * 
     * @param ref
     * @param mp ġΥץѥƥ֥
     */
    public AbsContents(Reference ref, MailProperties mp) {
	super("",11,80,TextArea.SCROLLBARS_VERTICAL_ONLY);
	setRows(13);
	//	setRows(14);
	this.setEditable(false);
	this.ref = ref;
	this.mp = mp;
    }

    /** 
     * show the contents of message
     * @param msg
     */
    public void change(String msgId) 
	throws MailFileException {

	class MakeSummary 
	    extends RIImpl {
	    /**
	     * @param ac 
	     * @param ref
	     */
	    public MakeSummary(AbsContents ac, Reference ref) {
		this.ac = ac;
		this.ref = ref;
	    }

	    /** 
	     * @param msgId
	     * @return boolean
	     */
	    public boolean doIt(String msgId) {
		try {
		    Message msg = ref.getMsg(msgId);
		    if ( msg == null ) return false;
		    change(msg, false);
		    return false;
		} catch (MailFileException mfe) {
		    //	    mfe.printStackTrace();
		    return true;
		}
	    }

	    /** */
	    private AbsContents ac = null;
	    /** */
	    private Reference ref = null;
	}

	
	if(msgId == null)  return;
	this.setText("\n");
	MailSentence.clearCurrentLabel();

	currentMailIndex = 0;
	openHTML();
	//	ref.enumerationToTop(msgId, this);
	ref.enumerationToTop(msgId, new MakeSummary(this, ref));
	closeHTML();
	//	change(msg, true);
    }

    /**
     * åID
     * @param msg å֥
     * @return String
     */
    private String getMsgId(Message msg) {
	try {
	    String hdrs[] = msg.getHeader("Message-ID");
	    if ( hdrs == null) return null;
	    return hdrs[0];
	} catch (MessagingException me) {
	    return null;
	}
    }

    /**
     * ᥤΥإåˤ
     * @param msg
     * @return String ᥤFrom, Date Υǡ
     */
    private String getHeader(Message msg) {
	StringBuffer sb = new StringBuffer();
	try {
	    getFrom(msg, sb);
	} catch (MailFileException mfe) {
	}
	String rv = "***************\n";
	rv += "MessageId: " + getMsgId(msg) + "\n";
	rv += "From: " + sb.toString() + "\n";

	rv += "Subject: " + MailFieldConvert.convertSubject(msg) + "\n";

	try {
	    rv += "Date: " + msg.getSentDate() + "\n";
	} catch (MessagingException me) {
	}
	return rv ;
    }

    /** 
     * Add From Fields values to StringBuffer
     * @param Message 
     * @param StringBuffer
     * @exception MailFileException throws when something 
     *            MessagingException occars
     */
    private void getFrom(Message msg, StringBuffer sb) 
	throws MailFileException {
	sb.append(MailFieldConvert.convertFrom(msg));
    }

    /**
     * Print message containts 
     * @param head Headers
     * @param body Body text
     */
    private void printMe(String head, String body) {
	String tmpHtmlPath = mp.getHTMLDir() + "Mail" + (new Integer(++currentMailIndex)).toString() + ".html";
	try {
	    fh = new File(tmpHtmlPath);
	    FileOutputStream fos = new FileOutputStream(fh);
	    PrintStream xps = new PrintStream(fos);
	    xps.println("<html>");
	    xps.println("<head>");
	    xps.println("<title>Abstract</title>");
	    xps.println("</head>");
	    xps.println("<body>");
	    xps.println("<a href=\"./"+mp.getHTMLSUM()+"#Mail"+currentMailIndex+"\">[BACK]</a>");
	    xps.println("<table width=\"600\">");
	    xps.println("<tr><td>");
	    xps.println("<pre>");

	    xps.println(head);
	    xps.println(body);

	    xps.println("</pre>");
	    xps.println("</td></tr>");
	    xps.println("</table>");
	    xps.println("</body>");
	    xps.println("</html>");
	    xps.close();
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	    fh = null;
	    ps = null;
	}catch (IOException e) {
	    e.printStackTrace();
	    fh = null;
	    ps = null;
        }
    }

    /** 
     * @param msg
     * @param clean
     */
    private synchronized void change(Message msg, boolean clean) 
	throws MailFileException {	
	String sepString = getHeader(msg);
	String s = MailFieldConvert.getBodyText(msg);

	printMe(sepString, s);
	String toThisMail = "<a href=\"Mail"+(new Integer(currentMailIndex)).toString()+".html\">[ToThisMail]</a><a name=\""+currentMailIndex+"\"></a>\n";

	MailSentence ms = new MailSentence(s);
	refSentence = ms.divide(refSentence);
	ms.printMessage();
	insert(sepString + ms.getMessage(), 0);
	printHTML(toThisMail + sepString + ms.getMessage(true));
    }
    
    /** 
     * @param msgId
     * @return boolean
     */
    public boolean doIt(String msgId) {
	try {
	    Message msg = ref.getMsg(msgId);
	    if ( msg == null ) return false;
	    change(msg, false);
	    return false;
	} catch (MailFileException mfe) {
	    //	    mfe.printStackTrace();
	    return true;
	}
    }

    /**
     */
    public void openHTML() {
	String tmpHtmlFile = mp.getHTMLPath();
	if (tmpHtmlFile != null ) htmlFile = tmpHtmlFile;
	try {
	    fh = new File(htmlFile);
	    FileOutputStream fos = new FileOutputStream(fh);
	    ps = new PrintStream(fos);
	    ps.println("<html>");
	    ps.println("<head>");
	    ps.println("<title>Abstract</title>");
	    ps.println("</head>");
	    ps.println("<body>");

	    ps.println("<table width=\"600\">");
	    ps.println("<tr><td>");
	    ps.println("<pre>");
	    pdb = new String("");
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	    fh = null;
	    ps = null;
	}catch (IOException e) {
	    e.printStackTrace();
	    fh = null;
	    ps = null;
        }
    }

    /**
     *  close output stream for HTMLFile
     */
    public void closeHTML() {
	if ( ps == null ) return;
	ps.println(pdb);
	ps.println("</pre>");

	ps.println("</td></tr>");
	ps.println("</table>");
	ps.println("</body>");
	ps.println("</html>");
	ps.close();
	pdb = null;
	ps = null;
	fh = null;
    }

    /**
     * printOut the HTML statement 
     * @param s HTML Statement
     */
    public void printHTML(String s) {
	if ( ps == null ) return;
	pdb = s + pdb;
    }

    /** */
    private static String htmlFile = "/tmp/a.html";
    
    /** */
    private File fh = null;
    /** */
    private PrintStream ps = null;
    /** */
    private String pdb = null;

    /** */
    private Reference ref = null;
    /** */
    private String folderName = null;
    /** */
    private int index = NOMESSAGE;
    /** */
    private Vector refSentence = null;
    /** */
    private MailProperties mp = null;

    /** */
    private int currentMailIndex = 0;
}
