/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
// Created by Jun Kurabe
//    For Windows Version

//package jp.co.lmer.mail;

import java.util.StringTokenizer;

/**
 */
public class Chasen {
    static String os = null;
    static String kanjiCode = "EUC-JP";
    static {
	System.loadLibrary("JChasen");
	os = System.getProperty("os.name");
	//	System.out.println("name = " + System.getProperty("os.name"));
	if (os.indexOf("Windows")!=-1) kanjiCode = "Shift_JIS";
	if (os.indexOf("Linux")!=-1)   kanjiCode ="EUC-JP";
	//	System.out.println("Kanji code = " + kanjiCode);
    }
    static boolean first = true;
    /**
     * @param argv[]
     */
    public static void main(String argv[]) {
	//	String s = "abc def";
	String s = "Ф줤Ǥ";
	s += "\n";
	s += "ŷϤǤ";
	s += "\n";
	s += "EOM";
	try {
	    byte bs[] = s.getBytes(kanjiCode);
	    byte rv[] = chasen(s, bs, bs.length, first);
	    String xs = new String(rv, kanjiCode);
	    //	    System.out.println("passed");
	    //	    System.err.println("Return Value:" + xs);
	    calc(xs);
	    first =false;
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

    /**
     * Pick up word from sentence.
     * @param s target sentence
     * @return String words 
     * @exception java.lang.Exception
     */
    public synchronized static String parse(String s) 
	throws java.lang.Exception {
	try {
	    //	    if ( kanjiCode.equals("Shift_JIS") )
	    s += "\n\n";
	    //	    else
		//		s += "\n\nEOM\n";
	    byte bs[] = s.getBytes(kanjiCode);
	    byte rv[] = chasen(s, bs, bs.length, first);
	    String xs = new String(rv, kanjiCode);
	    first = false;
	    return xs;
	} catch (Exception e) {
	    e.printStackTrace();
	    throw e;
	}
    }

    /**
     * Calling chasen librally written by C-Lang
     * @param s Target sentence
     * @param bs Target sentence in bytes array 
     *           character encoding : Linux: EUC-JP
     *                                Windows SJIS
     * @param l Length of bs
     * @param first flag for first call or not
     * @return byte[] word in byte array 
     *           character encoding : Linux: EUC-JP
     *                                Windows SJIS
     */
    public static native synchronized byte[] chasen(String s, byte[] bs, int l, boolean first);

    /**
     * Test Program
     * @param s Sequence of Word/Word Type
     */
    private static void calc(String s) {
	StringTokenizer lineSt = new StringTokenizer(s, "\n");
	while(lineSt.hasMoreTokens()) {
	    String line = lineSt.nextToken();
	    //	    if ( line.equals("EOS") ) continue;
	    StringTokenizer blockSt = new StringTokenizer(line);
	    
	    int i = 0;
	    String org = blockSt.nextToken();
	    String kana = blockSt.nextToken();
	    String kihon = blockSt.nextToken();
	    String hinsi = blockSt.nextToken();

	    if ( hinsi.indexOf("̾") != -1 ) {
		//		System.err.println(org + "  " + hinsi);
	    }
	}
	
    }
}
