/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
//package jp.co.lmer.mail;

import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.MessagingException;
import javax.mail.Address;
import javax.mail.internet.MimeUtility;
import javax.mail.internet.ParseException;
import java.io.UnsupportedEncodingException;
import java.io.IOException;
import java.lang.Character;

/**
 * Created by Jun Kurabe
 * 2002/01/14
 */
public class MailFieldConvert {
    /**
     * convert subject which is not correct format
     * @param msg
     * @return String 
     */
    public static String convertSubject(Message msg) {
	String rv = "";
	int n = 0;
	try {
	    rv = msg.getSubject();
	    String[] orgLabel = msg.getHeader("Subject");

	    if ( orgLabel == null) return null;
	    if (orgLabel[0].indexOf("-2022-") == -1 ) 
		rv = new String(orgLabel[0].getBytes(),"ISO-2022-JP");
	} catch (MessagingException me) {
	    me.printStackTrace();
	} catch (UnsupportedEncodingException e) {
	    e.printStackTrace();
	} catch (NullPointerException e) {
	    //	    e.printStackTrace();	    
	}

        int p = rv.indexOf("\n");
        while(p!=-1) {
            rv = rv.substring(0,p-1) + rv.substring(p+1);
            p = rv.indexOf("\n", p);
        }
	return rv;
    }

    /**
     * convert to basic subject, which means remove ML's counter / Re: 
     * @param msg
     * @return String 
     */
    public static String getBareSubject(Message msg) {
	String orgSubject = convertSubject(msg);
	int p = 0;
	if (orgSubject  != null ) {
	    if (orgSubject.indexOf("[") != -1 && 
		orgSubject.indexOf("]") != -1 ) {
		p = orgSubject.indexOf("]");
		orgSubject = orgSubject.substring(p+1);
		//		System.err.println("orgSubject ] =" + orgSubject);
	    }

	    p = orgSubject.indexOf("Re:");
	    if ( p != -1 ) orgSubject = orgSubject.substring(p+3);
	    
	    orgSubject = orgSubject.trim();

	    StringBuffer sb = new StringBuffer(orgSubject) ;
	    for (int i = 0; i< sb.length(); ) {
		if (Character.isWhitespace( sb.charAt(i))) {
		    sb.deleteCharAt(i);
		    continue;
		}

		i++;
	    } 
	    orgSubject = sb.toString();
	}
	
	return orgSubject;
    }

    /**
     * convert from which has Japanese text
     * @param msg
     * @return String 
     */
    public static String convertFrom(Message msg) {
	String rv = "";
	try {
	    Address from = msg.getFrom()[0];
	    
	    rv = from.toString();

	    try {
		if (rv.indexOf("-2022-") != -1 ) {
		    //		    System.err.println("From = " + rv);
		    int p = rv.indexOf("?=");
		    rv = MimeUtility.decodeWord(rv) + rv.substring(p+3);
		    //		    System.err.println("P = " + p);
		}
	    } catch (ParseException e) {
                //		e.printStackTrace();
	    } 
	} catch (MessagingException me) {
	    me.printStackTrace();
	} catch (UnsupportedEncodingException e) {
	    e.printStackTrace();
	} catch (NullPointerException e) {
	    //	    e.printStackTrace();	    
        }
	return rv;
    }

    /**
     * Get the Text from Body part
     * @param msg     Target Message
     * @return String Text which is in Body Part
     */
    public static String getBodyText(Message msg) 
	throws MailFileException {
	String body = "";
	try {
            String type = msg.getContentType().toUpperCase();
            if (type.indexOf("MULTIPART") != -1) {
                Multipart mp = (Multipart)msg.getContent();
                int n = mp.getCount();
                for(int i =0;i<n;i++) {
                    BodyPart bp = mp.getBodyPart(i);
                    String bpType = bp.getContentType().toUpperCase();
		    // System.err.println(i + ":" + bpType);

                    try {
                        if (bpType.indexOf("TEXT/PLAIN") != -1 ) {
                            String s = (String)bp.getContent();
			    //  System.err.println(s);
			    //			    append(s);
			     body = s + body;
			     //insert(s, 0);
			     //			    MailSentence ms = new MailSentence(s);
			     //			    ms.divide();
			     //			    ms.printMessage();
			 }
		     } catch ( Exception e) {
			 System.err.println("Error");
			 e.printStackTrace();
		     }

		 }
		 return body;
	     }

	     if (type.indexOf("TEXT/PLAIN") != -1) {
		 String s = (String)msg.getContent();
		 if ( type.indexOf("CHARSET") == -1 ) 
		     s = new String(s.getBytes(), "ISO-2022-JP");
		 //                System.err.println(s);
		 //		append(s);
		 //		insert(s, 0);
		 body = s + body;
		 //		MailSentence ms = new MailSentence(s);
		 //		ms.divide();
		 //		ms.printMessage();
		 //		System.err.println("Type = " + type);
		 return body;
	     }
	 } catch (IOException e) {
	     e.printStackTrace();
	 } catch (MessagingException me) {
	     me.printStackTrace();
	     throw new MailFileException();
	 }
	 return "";
     }
 }
