/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
// Created by Jun Kurabe
// 2001/09/24
// Copyright by Jun Kurabe, All rights reserved.

//package jp.co.lmer.mail;

import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;


import java.util.Comparator;
import java.util.Arrays;
import java.lang.Character;

import Chasen;
import MailString;
import Preface;

/**
 * @author Jun Kurabe
 */
public class MailSentence     {
    /** 
     * @param s
     */
    public MailSentence(String s) {
	this.s = s;
	wordCnt = new HashMap();
	wordPlace = new HashMap();
	allSentences = new Vector();

	if (Preface.debug) System.err.println("Sentence = " + s);
    }

    /** 
     * @param s
     */
    public void addBefore(String s) {
	this.s = s + "\n" + this.s;
    }

    /** 
     * @param s
     */
    public void addAfter(String s) {
	this.s = this.s + "\n" + s;
    }

    /** 
     * @param uppserSentence
     * @return Vector
     */
    public Vector divide(Vector upperSentence) {
	StringTokenizer st = new StringTokenizer(s, "\n", true);
	int level = 0;
	int preLevel = -1;

	String groupString = "";
	String preToken = "";
	Vector refSentences = new Vector();

	// add 2001/11/05
	// by Jun Kurabe
	boolean trail = false;

	while(st.hasMoreTokens()) {
	    level = 0;
	    String ss = st.nextToken();
	    // Signature will start with "--"
	    if ( ss.startsWith("--")) trail = true;
	    
	    if ( !ss.equals("\n")) {
		// ƬΥڡ
		ss = ss.trim();
		while (ss.startsWith("")) 
		    ss = ss.substring(1);

		// ">"ο
		while (ss.indexOf(">") == 0) {
		    level++;
		    ss = ss.substring(1);
		    ss = ss.trim();
		    while (ss.startsWith("")) 
			ss = ss.substring(1);
		}
	    }

	    // 2001/10/31
	    // add prevToken
	    if (ss.equals("\n")) {
		if ( preToken.equals("\n")) ss = "";
		else {
		    preToken = ss;
		    continue;
		}
	    }
	    preToken = ss;

	    // ʸ󤬤ꡢġƱ٥ʸǤꡢġ
	    // ˥̵ɲä
	    if ( ss.length() != 0 && 
		 preLevel == level && 
		 !trail ) { 
		groupString += ss;
		continue;
	    }
	    
	    //copy sentence with level
	    // ǽιԤ̵Сԡ
	    if ( preLevel != -1 ) {
		Vector v = divide2(groupString, false);
		Enumeration e = v.elements();
		while(e.hasMoreElements()){
		    String sent = (String)e.nextElement();
		    if (sent.length() == 0) continue;
		    allSentences.add(new ASentence(sent, preLevel));
		}
	    }
	    preLevel = level;
	    groupString = ss;
	}

	if ( groupString.length() != 0) {
	    Vector v = divide2(groupString, false);
	    //copy sentence with level
	    Enumeration e = v.elements();
	    while(e.hasMoreElements()){
		String sent = (String)e.nextElement();
		allSentences.add(new ASentence(sent, preLevel));
	    }
	}

	try {
	    //ñ̤ǷǲϤݤ
	    int lines = 0;
	    Enumeration e = allSentences.elements();
	    while(e.hasMoreElements()) {
		ASentence aSen = (ASentence)e.nextElement();
		//		System.err.println(aSen);
		String y = Chasen.parse(aSen.getSentence());
		//		System.err.println("Return of Chasen = " + y);
		calc(y, lines++);
	    }
	    refSentences = checkSentence(upperSentence);
	    //	    String y = Chasen.parse(s);
	} catch (Exception e) {
	    e.printStackTrace();
	}

	return refSentences;
    }

    /** 
     * print Abstracted Message
     */
    public void printMessage() {
	printMessage(false);
    }

    /** 
     * print Abstracted Message
     * @param boolean true if printHTML tag
     */
    public void printMessage(boolean htmlFile) {
	System.err.print(getMessage(htmlFile));
    }

    /** 
     * print Abstracted Message
     * @return String
     */
    public String getMessage() {
	return getMessage(false);
    }

    /** 
     * Get Abstracted Message
     * @return String
     */
    public String getMessage(boolean htmlFile) {
	int numOfPrint = 0;
	int numOfTotal = 0;
	final String x = ">>>>>>>>>>";
	final String xx = "            ";
	int preLevel = -1;
	String rv = "";
	Enumeration e = allSentences.elements();
	while(e.hasMoreElements()) {
	    ASentence aSen = (ASentence)e.nextElement();
	    if ( aSen.getShow()) {
		// htmlFileؤνϤʤNameLabel
		if (preLevel != aSen.getLevel()) rv += "\n";

		if (htmlFile) {
		    //		    for (int i =0; i<aSen.getLevel(); i++)
		    //			rv += "<ul>";
		    rv += xx.substring(0,aSen.getLevel()*2);
		} else rv += x.substring(0,aSen.getLevel());

		if (htmlFile && aSen.getLabel() != -1) {
		    rv += "<a name=\"";
		    rv += (new Integer(aSen.getLabel())).toString();
		    rv += "\"></a><u><font >";
		}
		if (htmlFile && aSen.getToLabel() != -1 ) {
		    rv += "<a href=\"#";
		    rv += (new Integer(aSen.getToLabel())).toString();
		    rv += "\">";
		}

		if ( Preface.debug  ) rv += "("+aSen.getCount() + ")";

		rv += aSen.getSentence();

		if (htmlFile && aSen.getToLabel() != -1 ) rv += "</a>";
		if (htmlFile && aSen.getLabel() != -1 ) rv += "</font></u>";

		if (htmlFile) {
		    // 		    for (int i =0; i<aSen.getLevel(); i++)
		    //			rv += "</ul>";
		}

		rv += "\n";
		numOfPrint++;
		preLevel = aSen.getLevel();
	    }
	    numOfTotal++;
	}

	rv += "Print = " + numOfPrint;
	rv += "\n";
	rv += "Total = " + numOfTotal;
	rv += "\n";
	rv += "-----------------------------------";
	rv += "\n";
	return rv;
    }

    /**
     * @param s
     * @param level
     * @return Vector
     */
    private Vector divide2(String s) {
	return divide2(s, true);
    }
    
    /**
     * @param s
     * @param level
     * @param all 
     * @return Vector
     */
    private Vector divide2(String s, boolean all) {
	Vector sV = new Vector();
	String buf = "";
	/** Separators */
	String seps[] = {"", "", ".", "?", ""};

	while (true) {
	    int pMax = 10000;
	    String sep = seps[0];

	    // find minimum separator 
	    for(int j=0;j<seps.length;j++) {
		int p = s.indexOf(seps[j]);
		if (p == -1) continue;

		if ( p > pMax ) continue;

		pMax = p;
		sep = seps[j];
	    }

	    int l = s.length();
	    if ( pMax > l || pMax == l - 1) {
		// add by Jun Kurabe
		// 2001/11/04
		// l !=1 
		if ( l != 1 ) buf += s;
		sV.add(buf);
		break;
	    } 

	    // add by Jun Kurabe
	    // 2001/11/04
	    // pMax !=0 
	    if (pMax != 0) buf += s.substring(0, pMax+1);
	    if ( !sep.equals(".")) {
		sV.add(buf);
		buf = "";
	    } else {
		// ᥤ륢ɥ쥹URLʸȤƥХХˤʤ
		String sbuf = s.substring(0,pMax+1);
		for(int i =0; i<sbuf.length(); i++) {
		    char ch = sbuf.charAt(i);
		    if ( ch == '@' ) continue;
		    if ( ch == '-' ) continue;
		    if ( ch == '_' ) continue;
		    if ( ch == '/' ) continue;
		    if ( ch == ':' ) continue;
		    if ( ch == '.' ) continue;
		    if (Character.isUpperCase(ch)) continue;
		    if (Character.isLowerCase(ch)) continue;
		    if (Character.isDigit(ch)) continue;

		    sV.add(buf);
		    buf = "";
		    break;
		}
	    }
	    s = s.substring(pMax+1);
	}

	return sV;
    }

    /** 
     * ̤ˡиñϿ
     * @param s
     * @param lines
     */
    private void calc(String s, int lines) {
	StringTokenizer lineSt = new StringTokenizer(s, "\n");
	while(lineSt.hasMoreTokens()) {
	    String line = lineSt.nextToken();
	    //	System.err.println("line = " +line);
	    //  UnixǤǥƥ󥹤νEOSǼƤ롣
	    if ( line.equals("EOS") ) continue;
	    if ( line.equals("EOM") ) continue;

	    StringTokenizer blockSt = new StringTokenizer(line);
	    
	    int i = 0;
	    String org = blockSt.nextToken();
	    String kana = blockSt.nextToken();
	    String kihon = blockSt.nextToken();
	    String hinsi = blockSt.nextToken();

	    MailString kihon2 = new MailString(kihon);

	    if (
		// ̾ǡ̾졢졢Ω̵Τԥååפ
		(hinsi.indexOf("̾") != -1 && 
		 ( hinsi.indexOf("̾") == -1  &&
		   hinsi.indexOf("") == -1  &&
		   hinsi.indexOf("Ω") == -1  )
		 ) || (
		       //̤θǡѿʪĤ
		       hinsi.indexOf("̤θ") != -1 &&
		       kihon2.isLetterAndDigit()
		       )
		 ) {
		//	    System.err.println(hinsi);
		//		if (hinsi.indexOf("̤θ") != -1) System.err.println(kihon);
		Integer ix = (Integer)wordCnt.get(kihon);
		if ( ix == null ) {
		    wordCnt.put(kihon, new Integer(1));
		    Vector place = new Vector();
		    place.add(new Integer(lines));
		    wordPlace.put(kihon, place);
		} else{
		    wordCnt.put(kihon, new Integer(ix.intValue() + 1));
		    Vector place = (Vector)wordPlace.get(kihon);
		    place.add(new Integer(lines));
		    //		wordPlace.put(kihon, place);
		}
	    }
	}

    }

    /**
     */
    private Vector checkSentence(Vector upperSentence) {
	/** Top n */
	int jMax = MailSentence.TOPWORDS;

	/** count array length */
	int n = wordCnt.keySet().size();
	if ( n == 0) return null;

	KV nKv[] = new KV[n];
	int i = 0;
	Iterator it = (wordCnt.keySet()).iterator();
	while(it.hasNext()) {	
	    String ss = (String)it.next();
	    //	    System.err.println(ss + " [" + (Integer)wordCnt.get(ss) + "]");
	    nKv[i++] = new KV(ss, ((Integer)wordCnt.get(ss)).intValue());
	}

	// Sort by Word count
	Arrays.sort(nKv, new KV());
	int maxCnt = nKv[0].n;
	int j = 0;

	if ( maxCnt < 4 ) jMax = 2;
	
	for(i=0;i<n;i++) {
	    if ( maxCnt != nKv[i].n ) {
		j++;
		maxCnt = nKv[i].n;
	    }
	    //	    if ( j < jMax ) 
	    //		System.err.print("*"); 
	    //	    else System.err.print(" ");
	    //	    System.err.print(nKv[i].key + "<<" + nKv[i].n + ">>");
	    Enumeration e = ((Vector)wordPlace.get(nKv[i].key)).elements();
	    while(e.hasMoreElements()){
		int p = ((Integer)e.nextElement()).intValue();
		//		System.err.print(p +",");
		if ( j < jMax ) {
		    ASentence aSen = (ASentence)allSentences.elementAt(p);
		    aSen.setShow(true);
		    aSen.addCount();
		}
	    }
	    //	    System.err.println("");
	}
	return threeSentences(upperSentence);
    }

    /**
     * Ѹʸ(n, 3Ĥ)Ĥ
     * ΥᥤǰѤƤʸ֤
     * @param upperSentence ѤƤʸ
     * @return Vector 
     */
    private Vector threeSentences(Vector upperSentence) {
	int preLevel = -1;
	int preLine = -1;
	int showLines = 0;
	boolean isTop = true;
	final int linesMax = 3;
	Vector refSentence = new Vector();
	Enumeration e = allSentences.elements();
	while(e.hasMoreElements()) {
	    ASentence as = (ASentence)e.nextElement();
	    //ʬֻʤ
	    if ( as.getLevel() == 0 ) {
		if (!isTop) {
		    //ʸ鼫ʬΰոѤäʤ
		    if (preLevel != as.getLevel()) {
			((ASentence)allSentences.elementAt(preLine)).setShow(true);
			((ASentence)allSentences.elementAt(preLine)).setToLabel(++MailSentence.currentLabel);
			//refSentence.add(((ASentence)allSentences.elementAt(preLine)).getSentence());
			refSentence.add(((ASentence)allSentences.elementAt(preLine)));
			showLines=0;
			
		    }
		    //ʸ̤ʤ
		    if (showLines<MailSentence.SENTENCES) as.setShow(true);
		    showLines++;

		    // ѤƤʸʤлĤ
		    if ( upperSentence != null ) {
			Enumeration use = upperSentence.elements();
			while(use.hasMoreElements()) {
			    ASentence rs = (ASentence)use.nextElement();
			    String upperS = rs.getSentence();
			    if (as.getSentence().equals(upperS)) {
				as.setShow(true);
				as.setLabel(rs.getToLabel());
			    }
			}
		    }
		}
	    } else isTop = false;
	    preLevel = as.getLevel();
	    preLine++;
	}
	return refSentence;
    }

    /**
     * Crear Current Label
     */
    public static void clearCurrentLabel() {
	currentLabel = -1;
    }

    /** */
    private String s = null;
    /** */
    private HashMap wordCnt = null;
    /** */
    private HashMap wordPlace = null;
    /** */
    private Vector allSentences = null;

    /** */
    public static final int SENTENCES = 3;
    /** */
    public static final int TOPWORDS= 3;
    /** */
    public static final int TOPWORDSALL = 3;

    /** */
    private static int currentLabel = -1;
}

/**
 */
class ASentence {
    /** 
     * @param sentence 
     * @param level
     */
    ASentence(String sentence, int level) {
	this.sentence = sentence;
	this.level = level;
	this.count = 0;
    }

    /** 
     * Get Sentence
     * @return String
     */
    String getSentence() {
	return this.sentence;
    }

    /** 
     * Set this sentence show
     * @param show
     */
    void setShow(boolean show) {
	this.show = show;
    }

    /** 
     * @return boolean
     */
    boolean getShow() {
	return this.show;
    }

    /** 
     * Level֤
     * @return int
     */
    int getLevel() {
	return level;
    }

    /** 
     * ñδޤޤƤû롣
     * @param n ñδޤޤƤ
     */
    void addCount(int n) {
	count += n;
    }

    /** 
     * ñδޤޤƤ򣱸Ĥû롣
     */
    void addCount() {
	count++;
    }

    /** 
     * ޤޤƤñο֤
     * @return int
     */
    int getCount() {
	return count;
    }

    /**
     * HTMLѴΥ٥Ͽ롣
     * @param label Ͽ٥
     */
    void setLabel(int label) {
	this.label = label;
    }

    /**
     * ٥֤
     * @return int
     */
    int getLabel() {
	return this.label;
    }

    /** 
     * Υ٥ꤹ롣
     * @param toLabel
     */
    void setToLabel(int toLabel) {
	this.toLabel = toLabel;
    }

    /**
     * toLabel 
     * @return int
     */    
    int getToLabel() {
	return this.toLabel;
    }

    /** */
    private String sentence = null;
    /** Line Number */
    private int level = -1;
    /** Line Number */
    private boolean show = false;
    /** Count */
    private int count = 0;
    /** Label for HTML 
    * ٥ϿͷǤ롣
    */
    private int label = -1;
    /** */
    private int toLabel = -1;
}

/** */
class KV 
    implements Comparator {

    /** */
    KV() {
    }

    /** 
     * @param key
     * @param n
     */
    KV(String key, int n) {
	this.key = key;
	this.n = n;
    } 

    /** 
     * @param o1
     * @param o2
     */
    public int compare(Object o1, Object o2) {
	if (((KV)o1).n < ((KV)o2).n) return 1;
	if (((KV)o1).n == ((KV)o2).n) return 0;
	return -1;
    }

    /** 
     * @param obj
     * @return boolean
     */
    public boolean equals(Object obj) {
	return false;
    }

    /** */
    public String key = null;

    /** */
    public int n = -1;
}

/**
 */
class SentencesLevel {
    /** */
    SentencesLevel(int level, Vector sentences) {
	this.level = level;
	this.sentences = sentences;
    }

    /** 
     * @param words
     * @return SentenceLevel
     */
    SentencesLevel containts(Vector words) {
	boolean rv = false;
	Enumeration wordEnu = words.elements();
	Vector sent = new Vector();
	while(wordEnu.hasMoreElements()){
	    String w = (String)wordEnu.nextElement();
	    Enumeration senEnu = this.sentences.elements();
	    while(senEnu.hasMoreElements()) {
		String s = (String)senEnu.nextElement();
		if ( s.indexOf(w) == -1 ) continue;
		sent.add(s);
	    }
	}
	if (sent.size() == 0) return null;
	return new SentencesLevel(this.level, sent);
    }

    /** */
    private int level = 0;
    /** */
    private Vector sentences = null;
}
