/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
// Created by Jun Kurabe
// 2001/09/09
// 2002/01/26
// $Date: 2002/03/02 12:07:28 $
// $Revision: 1.1 $


//package jp.co.lmer.mail;

import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;
import java.util.Set;
import java.util.Vector;
import java.io.*;
import javax.mail.*;
import javax.activation.*;
import MailFieldConvert;
import MailFileException;
import MailGraphDrawing;
import MailMessage;
import MailProperties;
import MailSentence;
import Reference;
import Selection;
import StartBrowser;

/** 
 * @author Jun Kurabe (jun-krb@mars.dti.ne.jp )
 */
public class Preface {
    /** 
     *
     * @param argc ץѥƥեΥѥ
     */
    public static void main(String argc[]) {
	try {
	    String fp = "./data/MailTool.prop";
	    if (argc.length > 0) fp = argc[0];

	    MailProperties mp = new MailProperties(fp);

	    Reference ref = new Reference();
	    MailFile mf = new MailFile(ref, mp);
	    if (argc.length > 1  ) debug = true;
	    mf.open();
	    AFrame aFrame = new AFrame(mf, ref, mp);
	    System.err.println("Messages = " + ref.size());
	    aFrame.show();
	} catch (MailFileException e) {
	    e.printStackTrace();
	} catch (FileNotFoundException e) {
	    System.err.println("ץѥƥե뤬ޤ");
	} catch (IOException e) {
	    System.err.println("ץѥƥեɤޤ");
	}
    }

    /** */
    public static boolean debug = false;

    /** 
     * 줿HTMLեΥե̾
     */
    public static String htmlFileName = "/tmp/abstractmail.html";
}

/**
 */
class MailFile {
    /** Mail URL */
    public static String url = "mh:/home/jun2";
    //    public static final String url = "mh:///c|/Home/";
    //    public static final String url = "mh:/Home/Mail/";

    /** */
    public static final String ROOT = "Mail";
    //    static final String root = "inbox";

    /** 
     * Mail File Object
     * @param ref
     * @exception MailFileException
     */
    public MailFile (Reference ref, MailProperties mp) 
	throws MailFileException {
	this.ref = ref;
	this.mp = mp;
    }

    /** 
     * open the mail file and make connection to messaging store
     * @exception MailFileException 
     */
    public void open() 
	throws MailFileException {
	Properties props = System.getProperties();

	session = Session.getDefaultInstance(props, null);
	//	session.setDebug(true);

	String tmpUrl = mp.getMailPath();
	if (tmpUrl != null) url = tmpUrl;
	urln = new URLName(url);
	System.err.println("urln = " + urln);
	try {
	    store = session.getStore(urln);
	    store.connect();
	} catch (javax.mail.NoSuchProviderException e) {
	    e.printStackTrace();
	    throw new MailFileException();
	} catch (javax.mail.MessagingException e) {
	    e.printStackTrace();
	    throw new MailFileException();
	}
    }

    /** 
     * close mail file
     * @exceptioni MailFileException
     */
    public void close() 
	throws MailFileException {
	try {
	    store.close();
	} catch ( javax.mail.MessagingException e) {
	    e.printStackTrace();
	    throw new MailFileException();
	}
    }

    /**
     * List sub folders
     * @param f Folder Object
     * @return Vector
     * @exception MailFileException 
     */
    public Vector getSubFolders(String fn) 
	throws MailFileException {
	try {
	    //	    System.err.println(store.toString());
	    Folder rf = store.getFolder(fn);

	    Vector anArray = new Vector();
	    getSubFolderMain(rf, 0, anArray);
	    //	    System.err.println("Messages = " + anArray.size());
	    return anArray;
	} catch (javax.mail.MessagingException e) {
	    e.printStackTrace();
	    throw new MailFileException();
	}
    }

    /** 
     * Get the subfolders recursively
     * @param f parent folder
     * @param level level of folder ( start is "0" )
     * @param folders Mail Folder objects store in the vector object
     * @exception MessagingException
     */
    private void getSubFolderMain(Folder f, int level, Vector folders) 
        throws MessagingException {
        level++;
	folders.addElement(new MailFolder(f.getName(), f.getFullName(), level));
	f.open(Folder.READ_ONLY);
	Message[] msgs = f.getMessages();
	for ( int j =0; j<msgs.length; j++) {
	    //  msgMap.put(hdrs[0], new Integer(i));
	    ref.getReferences(msgs[j]);
	}

        Folder[] subFolders = f.listSubscribed();

        for (int i =0; i<subFolders.length; i++) {
            getSubFolderMain(subFolders[i], level, folders);
        }
    }

    /** 
     * Get Message Object within folder 
     * @param folderName
     * @return Message 
     * @exception MailFileException
     */
    public Message[] getMessages(String folderName) 
	throws MailFileException  {
	try {
	    Folder rf = store.getFolder(folderName);	
	    rf.open(Folder.READ_ONLY);
	    return rf.getMessages();
	} catch ( javax.mail.MessagingException e ) {
	    e.printStackTrace();
	    throw new MailFileException();
	}
    }

    /** 
     * Get Message Object within folder 
     * @param folderName
     * @return Message 
     * @exception MailFileException
     */
    public Folder getFolder(String folderName) 
	throws MailFileException  {
	try {
	    Folder rf = store.getFolder(folderName);	
	    rf.open(Folder.READ_ONLY);
	    return rf;
	} catch ( javax.mail.MessagingException e ) {
	    e.printStackTrace();
	    throw new MailFileException();
	}
    }

    /** */
    private Session session = null;
    /** URL Name*/
    private URLName urln = null;
    /** */
    private Store store = null;
    /** */
    private Reference ref = null;
    /** */
    private MailProperties mp = null;
}

/** 
*/
class MailFolder {
    /** 
     *
     * @param name just name of folder
     * @param fullName 
     * @param level
     */
    public MailFolder (String name, String fullName, int level) {
	this.name = name;
	this.fullName = fullName;
	this.level = level;
    }

    /** 
     * Get the name of folder
     * @return String
     */
    public String getName() {
	return this.name;
    }

    /** 
     * Get the full name of Folder
     * @return String
     */
    public String getFullName() {
	return this.fullName;
    }

    /** 
     * Get the level of Folder
     * @return int
     */
    public int getLevel() {
	return this.level;
    }

    /** */
    private String name = null;
    /** */
    private String fullName = null;
    /** */
    private int level = 0;
}

/**
 */
class AFrame 
    extends Frame {
    /** 
     *
     * @param mf Mail File Object 
     * @param ref
     */
    public AFrame (MailFile mf, Reference ref, MailProperties mp) {
	super();

	/* */
	setSize(700,600);
	//	setSize(700,700);
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	setLayout(gbl);

	/* Create object*/
	TextField sentences = new TextField(new Integer(MailSentence.SENTENCES).toString());
	TextField topWords = new TextField(new Integer(MailSentence.TOPWORDS).toString());
	TextField topWordsAll = new TextField(new Integer(MailSentence.TOPWORDSALL).toString());
	MailContents aContents = new MailContents(mf);
	AbsContents absContents = new AbsContents(ref, mp);
	SubjectList bList = new SubjectList(8, mf, aContents);
	//	SubjectList bList = new SubjectList(10, mf, aContents);
	FolderList aList = new FolderList(20, mf, bList, mp);
	MailGraphDrawing mgd = new MailGraphDrawing();
	CmdButton cmdButton = new CmdButton("Graph", ref, mgd);
	// CmdButton cmdButton = new CmdButton("Graph", ref, this);
	AbsButton absButton = new AbsButton("Summary", ref, absContents, mp);
	AbsButton2 absButton2 = new AbsButton2("Summary From Graph", ref, absContents, mgd, mp);
	// AbsButton2 absButton2 = new AbsButton2("Summary From Graph", ref, absContents, this, mp);

	/* setup listeners */
	this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	//	this.addWindowListener(new AFrameAdapter());

	/* set layout */

	int y = 0;

	// cmdButton
	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	gbc.fill = GridBagConstraints.VERTICAL;
	gbl.setConstraints(cmdButton, gbc);
	add(cmdButton);

	// absButton
	gbc.weightx = 0;
	gbc.gridx = 1;
	gbc.gridy = y;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	//	gbc.fill = GridBagConstraints.BOTH;
	gbc.fill = GridBagConstraints.VERTICAL;
	gbl.setConstraints(absButton, gbc);
	add(absButton);

	// absButton2
	gbc.weightx = 0;
	gbc.gridx = 2;
	gbc.gridy = y;
	gbc.gridwidth = 1;
	gbc.gridheight = 1;
	//	gbc.fill = GridBagConstraints.BOTH;
	gbc.fill = GridBagConstraints.VERTICAL;
	gbl.setConstraints(absButton2, gbc);
	add(absButton2);

	y++;

	//aList ե
	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 1;
	gbc.gridheight = 3;
	gbc.fill = GridBagConstraints.BOTH;
	gbl.setConstraints(aList, gbc);
	add(aList);

	//bList ֥Ȱ
	gbc.weightx = 0;
	gbc.gridx = 1;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 1;
	gbl.setConstraints(bList, gbc);
	add(bList);

	// ޤʤβ
	y++;
	Label dummyLabel = new Label();
	gbc.weightx = 0;
	gbc.gridx = 1;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 1;
	gbl.setConstraints(dummyLabel, gbc);
	add(dummyLabel);

	y++;

	//MailContents
	gbc.weightx = 0;
	gbc.gridx = 1;
	gbc.gridy = y;
	gbc.gridwidth = 2;
	gbc.gridheight = 1;
	gbl.setConstraints(aContents, gbc);
	add(aContents);

	y++;

	//AbsContents
	gbc.weightx = 0;
	gbc.gridx = 0;
	gbc.gridy = y;
	gbc.gridwidth = 3;
	gbc.gridheight = 1;
	gbl.setConstraints(absContents, gbc);
	add(absContents);

	//	setSize(getPreferredSize());

    }

    /** 
     * close the window & shutdown the tool
     * @param e Window event occar in the frame
     */
    protected void processWindowEvent(WindowEvent e) {
	if (e.getID() == WindowEvent.WINDOW_CLOSING) {
	    System.exit(0);
	}
    }

    /** */
    public MailGraphDrawing mgd = null;
}

/**
 */
class CmdButton 
    extends Button
    implements ActionListener {

    /** 
     * 
     * @param name
     * @param ref
     * @param mgd
     */
    public CmdButton (String name, Reference ref, 
		      MailGraphDrawing mgd
		      //		      AFrame aFrame
		      ) {
	super(name);

	addActionListener(this);

	this.ref = ref;
	this.mgd = mgd;
	/*
	  this.aFrame = aFrame;
	*/
    }

    /**
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
	//	System.err.print("Pushed  ");
	//	System.err.println(selection.get());

	if (Selection.get() == null) return;

	mgd.clear();
	mgd.show();

	/*
	  if (aFrame.mgd != null) 
	  aFrame.mgd.destroy();
	  aFrame.mgd = new MailGraphDrawing();
	  aFrame.mgd.clear();
	  aFrame.mgd.show();
	*/

	//	String top = ref.draw(Selection.get(), mgd);
	//	mgd.draw(top);
	mgd.draw(Selection.get(), ref);
	/*
	  aFrame.mgd.draw(Selection.get(), ref);
	*/
    }

    /** */
    private MailGraphDrawing mgd = null;
    /** */
    private Reference ref = null;
    /** */
    private AFrame aFrame = null;
}

/**
 */
class AbsButton 
    extends Button
    implements ActionListener {

    /** 
     * Create Abstract Button Object
     * @param name Name of Button
     * @param ref Mail References
     * @param ac
     * @param mp
     */
    public AbsButton (String name, 
		      Reference ref, 
		      AbsContents ac,
		      MailProperties mp) {
	super(name);

	addActionListener(this);

	this.ref = ref;
	this.ac = ac;
	this.mp = mp;
    }

    /**
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
	String msgId = Selection.get();
	if (msgId == null) return;
	try {
	    ac.change(msgId);
	    String tmpFilePath = mp.getHTMLPath();
	    //	    StartBrowser.openBrowser(FILEPATH);
	} catch (MailFileException mfe) {
	    mfe.printStackTrace();
	}
    }

    /** */
    private Reference ref = null;
    /** */
    private AbsContents ac = null;
    /** */
    private MailProperties mp = null;

    /** */
    static private final String FILEPATH = "/tmp/a.html";
}

/**
 */
class AbsButton2
    extends Button
    implements ActionListener {

    /** 
     * Create Abstract Button Object
     * @param name Name of Button
     * @param ref Mail References
     * @param ac  
     * @param mgd 
     * @param mp  
     */
    public AbsButton2(String name, 
		      Reference ref, 
		      AbsContents ac,
		      MailGraphDrawing mgd,
		      // AFrame aFrame,
		      MailProperties mp) {
	super(name);

	addActionListener(this);

	this.ref = ref;
	this.ac = ac;
	this.mgd = mgd;
	/* 
	   this.aFrame = aFrame;
	 */
	this.mp = mp;
    }

    /**
     * @param e
     */
    public void actionPerformed(ActionEvent e) {
	/*
	String msgId = aFrame.mgd.getSelectedMsgId();
	*/
	String msgId = mgd.getSelectedMsgId();
	if (msgId == null) return;
	try {
	    ac.change(msgId);
	    String tmpFilePath = mp.getHTMLPath();
	    //	    StartBrowser.openBrowser(FILEPATH);
	} catch (MailFileException mfe) {
	    mfe.printStackTrace();
	}
    }

    /** */
    private Reference ref = null;
    /** */
    private AbsContents ac = null;
    /** */
    private MailGraphDrawing mgd = null;
    /** */
    private MailProperties mp = null;
    /** */
    static private String FILEPATH = "/tmp/a.html";

    /** */
    private AFrame aFrame = null;
}

/** */
class FolderList 
    extends List 
    implements ItemListener {
    /** 
     *
     * @param nRow
     * @param mf
     * @param sl
     * @param mp
     */
    public FolderList(int nRow, 
		      MailFile mf, 
		      SubjectList sl,
		      MailProperties mp) {
	super(nRow);
	try {
	    this.mf = mf;
	    subFolders = mf.getSubFolders(mp.getMailDir());
	    showList();
	    //	aList.makeVisible(0);

	} catch (MailFileException e) {
	    e.printStackTrace();
	}
	this.sl = sl;
	addItemListener(this);
    }

    /** 
     * 
     */
    private void showList () {
	this.setVisible(false);
	Enumeration folders = subFolders.elements();
	while(folders.hasMoreElements()) {
	    MailFolder folder = (MailFolder)folders.nextElement();
	    int level = folder.getLevel();
	    StringBuffer sb = new StringBuffer();
	    for(int j=0;j<level;j++) 
		sb.append("");
	    
	    String s = sb.toString();
	    this.add(s + folder.getName());
	}
	this.setVisible(true);
    }

    /** 
     *
     * @param index
     * @return MailFolder
     */
    public MailFolder getMailFolder(int index) {
	return (MailFolder)subFolders.elementAt(index);
    }

    /** 
     *
     * @param e
     */
    public void itemStateChanged (ItemEvent e) {
	try { 
	    if ( e.getStateChange() == java.awt.event.ItemEvent.SELECTED ) {
		Integer item = (Integer)e.getItem();
	    
		sl.change(getMailFolder(item.intValue()));
	    };
	} catch (MailFileException me) {
	}
    }

    /** */
    private SubjectList sl = null;

    /** */
    private MailFile mf = null;

    /** */
    private Vector subFolders = null;
}

/** */
class SubjectList 
    extends List 
    implements ItemListener{

    /** 
     *
     * @param nRow number of rows
     * @param mf Mail File Object
     * @param mc Mail Contents Object
     */
    public SubjectList(int nRow, MailFile mf, MailContents mc) {
	super(nRow);
	//	aList.makeVisible(0);
	this.mf = mf;
	this.mc = mc;
	addItemListener(this);
    }

    /** 
     *
     * @param mFolder
     * @exception MailFileException
     */
    public void change(MailFolder mFolder ) 
	throws MailFileException  {
	try {
	    this.mFolder = mFolder;
	    showList();
	} catch (MessagingException e) {
	    e.printStackTrace();
	    throw new MailFileException();
	} 
    }

    /**
     * Show the Header Fields Value
     * @exception MessagingException 
     * @exception MailFileException
     */
    public void showList()
	throws MessagingException, MailFileException {    

	this.removeAll();
	Folder f = mf.getFolder(mFolder.getFullName());
	//	Message[] tmpMsgs = mf.getMessages(mFolder.getFullName());
	//	msgs = new MailMessage[tmpMsgs.length];
	// 2002/01/20
	// Message֥ȤȤΤǤϤʤե֥Ȥȥݥ󥿤ǥåؤˡѹ
	msgs = new MailMessage[f.getMessageCount()];
	//	if ( folderName != null) mf.getMessages(folderName);
	//	else mf.getMessages(urlName);
	Date[] dates = new Date[f.getMessageCount()];

	for (int i =0; i < msgs.length; i++) {
	    //	    msgs[i] = new MailMessage(tmpMsgs[i]);
	    msgs[i] = new MailMessage(f.getMessage(i+1));
	    dates[i] = msgs[i].getMessage().getSentDate();
	}

	for (int i=0; i< msgs.length; i++) {
	    for (int j=i+1; j<msgs.length; j++) {
		int k = dates[i].compareTo(dates[j]); 
		if (k<=0) continue;
		
		MailMessage tmp = msgs[i];
		msgs[i] = msgs[j];
		msgs[j] = tmp;

		Date sTmp = dates[i];
		dates[i] = dates[j];
		dates[j] = sTmp;
	    }
	}
	for ( int i =0;i <msgs.length; i++) {
	    Message msg = msgs[i].getMessage();
	    StringBuffer sb = new StringBuffer();

	    //getFrom(msg,sb);
	    //	    sb.append(":");
	    //	    this.getTo(msg,sb);
	    //	    sb.append(":");
	    String x = MailFieldConvert.convertFrom(msg) + "          ";
	    sb.append(msg.getSentDate().toString().substring(4,20));
	    sb.append(" | ");
	    sb.append(x.substring(0,20)); //
	    sb.append(" | ");
	    sb.append(MailFieldConvert.convertSubject(msg));
	    this.add(sb.toString());
	}
    } 

    /** 
     * Add From Fields values to StringBuffer
     * @param Message 
     * @param StringBuffer
     * @exception MailFileException throws when something 
     *            MessagingException occars
     */
    private void getFrom(Message msg, StringBuffer sb) 
	throws MailFileException {
	try {
	    Address[] froms = msg.getFrom();
	    if (froms != null) 
		for(int j=0;j<froms.length;j++) {
		    //		    if (j>0) System.err.print(", ");
		    //		    System.err.print(froms[j].toString());
		    sb.append(froms[j]);
		}
	    //	    System.err.println("");
	} catch ( MessagingException me) {
	    me.printStackTrace();
	    throw new MailFileException();
	}
    }

    /** 
     * Add To Fields values to StringBuffer
     * @param msg
     * @param sb 
     */
    private void getTo(Message msg, StringBuffer sb)  {
	try {
	    Address[] tos = msg.getRecipients(Message.RecipientType.TO);
	    if (tos != null) 
		for(int j=0;j<tos.length;j++) {
		    if (j>0) sb.append(", ");
		    sb.append(tos[j].toString());
		}
	} catch (MessagingException me) {
	    me.printStackTrace();
	    //	    throw new MailFileException();
	}
    }

    /** 
     * Get Message Object with index
     * @param idx index value
     * @return Message
     * @exception MailFileException
     */
    public Message getMail(int idx) 
	throws MailFileException {
	//	Message msgs[] = mf.getMessages(mFolder.getFullName());
	return msgs[idx].getMessage();
    }

    /** 
     * @param e Event occars in a Subject List Object
     */
    public void itemStateChanged (ItemEvent e) {
	try { 
	    //	System.err.println("Called");
	    if ( e.getStateChange() == java.awt.event.ItemEvent.SELECTED ) {
		Integer item = (Integer)e.getItem();
		//System.err.println("changed = " + item.toString());
		Message msg = getMail(item.intValue());
		mc.change(msg);
		if (Preface.debug) {
		    System.err.println("Bare Subject = " + MailFieldConvert.getBareSubject(msg));
		    System.err.println("Bare Subject = " + MailFieldConvert.getBareSubject(msg).length());
		    System.err.println("Bare Subject = " + msg.getSentDate());
		}
	    };
	} catch (MailFileException me) {
	} catch (MessagingException me) {
	}
    }

    /** Mail Contents Object */
    private MailContents mc = null;

    /** */
    private MailFile mf = null;

    /** */
    private MailFolder mFolder = null;

    /** */
    private MailMessage[] msgs = null;
}

/** */
class MailContents 
    extends TextArea {
    /** */
    public static final int NOMESSAGE = -1;

    /** 
     * @param mf
     */
    public MailContents(MailFile mf) {
	//	super("",11,60,TextArea.SCROLLBARS_VERTICAL_ONLY);
	super("",9,60,TextArea.SCROLLBARS_VERTICAL_ONLY);
	this.setEditable(false);
	this.mf = mf;
    }

    /** 
     * show the contents of message
     * @param msg
     */
    public synchronized void change(Message msg) 
	throws MailFileException {
	String body = "";
	setMsg(msg);
	this.setText("\n");
	body = MailFieldConvert.getBodyText(msg);
	this.insert(body, 0);
    }

    /** 
     * Selection֥Ȥ򤵤줿MessageId򥻥åȤ롣
     * @param msg 
     */
    private void setMsg(Message msg) {
	try {
	    String hdrs[] = msg.getHeader("Message-Id");	
	    if ( hdrs == null ) {
		Selection.set(null);		
		return;
	    }
	    Selection.set(hdrs[0]);
	} catch ( MessagingException me ) {
	    me.printStackTrace();
	}
    }

    /** */
    private MailFile mf = null;
    /** */
    private String folderName = null;
    /** */
    private int index = NOMESSAGE;
}
