/*
  (c) 2002, Jun Kurabe and Hiroshi Ichiji. All rights reserved.
 */
// Created by Jun Kurabe
// 2001/09/16
// 2002/01/25
// 2002/02/23

//package jp.co.lmer.mail;

import java.util.GregorianCalendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Vector;
import java.util.StringTokenizer;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Folder;
import MailDraw;
import ReferenceInterface;
import MailFileException;
import MailMessage;

/**
 * @author Jun Kurabe
 * @see MailDraw
 */
public class Reference {

    /**
     * 
     */
    public Reference () {
	//	isTop = new HashMap();
	refMap = new HashMap();
	replyMap = new HashMap();
	cntRefMap = new HashMap();
	cntReplyMap = new HashMap();

	subjectMap = new HashMap();

	msgMap = new HashMap();
    }

    /**
     * Return number of messages
     * @return int
     */
    public int size() {
	return msgMap.size();
    }

    /**
     * Get Reference and put the reference into refMap
     * @param id MessageId
     * @param msg Message Object
     */

    public void getReferences(Message msg) {
	String hdrs[] = null;
	try {
	    hdrs = msg.getHeader("Message-ID");
	} catch (MessagingException me) {
	    return;
	}

	if ( hdrs == null ) return;
	String id = hdrs[0];

	msgMap.put(id, new MailMessage(msg));
        //if (id.indexOf("mediafront")!=-1) System.err.println("put = " + id);
	getCntRelation(id, msg, "In-Reply-to", cntReplyMap);
	getCntRelation(id, msg, "References", cntRefMap);

	getRelation(id, msg, "In-Reply-to", replyMap);
	getRelation(id, msg, "References", refMap);

	makeSubjectMap(id, msg);
    }

    /**
     * Get Message Object from Id
     * @param id
     * @return Message
     */
    public Message getMsg(String id) 
	throws MailFileException  {
	MailMessage mm = (MailMessage)msgMap.get(id);
	if (mm == null) throw new MailFileException();
	return mm.getMessage();
    }

    /**
     * Get Relation 
     * @param id MessageId
     * @param msg Message Object
     * @param kw Header Field Name
     * @param refMap Reference Map
     */
    private void getRelation (String id, Message msg,
			      String kw, HashMap map) {
        try {
            // Get Value of Reference
            String refs[] = msg.getHeader(kw);
            if (refs == null ) return;

            // Sprit Value into elements
	    Vector rs = new Vector();
            for (int i = 0; i<refs.length; i++) {
		//   System.err.println("ref[" + i + "]=" + refs[i]);
                StringTokenizer st = new StringTokenizer(refs[i]);
                while(st.hasMoreTokens()) {
                    String ss = st.nextToken();
		    ss = ss.substring(0,ss.indexOf(">")+1);
		    //		    System.err.println("ss =" + ss);
                    if ( ss.indexOf("@") == -1) continue;
                    if ( ss.indexOf("<") == -1) continue;
                    if ( id.equals(ss) ) continue;
                    if (ss == null) continue;
                    rs.addElement(ss);
                }
	    map.put(id, rs);	    
            }
        } catch (MessagingException me) {
            me.printStackTrace();
        }
    }

    /**
     * Get Counter Relation 
     * @param id MessageId
     * @param msg Message Object
     * @param kw  Header Field Name
     * @param refMap Reference Map
     */
    private void getCntRelation (String id, Message msg,
				 String kw, HashMap map) {
        try {
            // Get Value of Reference
            String refs[] = msg.getHeader(kw);
            if (refs == null ) return;

            // Sprit Value into elements
            for (int i = 0; i<refs.length; i++) {
                StringTokenizer st = new StringTokenizer(refs[i]);
                while(st.hasMoreTokens()) {
                    String ss = st.nextToken();
		    ss = ss.substring(0,ss.indexOf(">")+1);
                    if ( ss.indexOf("@") == -1) continue;
                    if ( ss.indexOf("<") == -1) continue;
                    if (id.equals(ss)) continue;

                    // Add Reference to Map
                    Vector rs = (Vector)map.get(ss);
                    if ( rs == null ) rs = new Vector();

                    if (!rs.contains(id)) {
                        rs.addElement(id);
                        map.put(ss, rs);
                    }
                }
            }
	    //            isTop.put(id,new Boolean(false));
        } catch (MessagingException me) {
            me.printStackTrace();
        }
    }

    /** 
     * Draw graph follow mail relation and return top id subject
     * @param msgId
     * @param md
     * @return String
     */
    public String draw(String msgId, MailDraw md) {
	if (Preface.debug) System.err.println("msgId = " + msgId);
	passed = new HashMap();

	passed.put(msgId, msgId);
	String topId = getTop(msgId);
	if (Preface.debug) System.err.println("Top id = " + topId);

	passed = new HashMap();

	//	md.addNode(topId, (Message)msgMap.get(msgId));
	md.addNode(topId, ((MailMessage)msgMap.get(topId)).getMessage());
	followRef(topId, md);
	String subject = "";
	try {
	    subject = (((MailMessage)msgMap.get(msgId)).getMessage()).getSubject();
	} catch (MessagingException me) {
	    me.printStackTrace();
	}

	return subject;
    }

    /**
     * @param msgId
     * @return String 
     */
    public String getTop(String msgId) {
	/**
	 */
	class GetTopOne 
	    extends RIImpl {
	    /**
	     */
	    public GetTopOne () {
		topId = null;
	    }

	    /**
	     * @param msgId
	     * @return String
	     */
	    public boolean doIt (String msgId) {
		if (Preface.debug) System.err.println("xGetTop = " + msgId );
		this.topId = msgId;
		return false;
	    }

	    /**
	     * @return String
	     */
	    public String getTopId() {
		return topId;
	    }

	    /** */
	    private String topId = null;
	}

	GetTopOne gto = new GetTopOne();

	try {
	    //	    this.enumerationToTop(msgId, this);
	    this.enumerationToTop(msgId, gto);
	} catch (MailFileException e) {
	    e.printStackTrace();
	}
	return gto.getTopId();
    }

    /** 
     * in-reply-toδط̤ꡢåɤƬmessage-idꤹ롣
     * @param msgId
     * @return String
     */
    /*
    public String getTop(String msgId) {
	passed.put(msgId, msgId);
	Vector v = (Vector)replyMap.get(msgId);
	System.err.println("getTop = " + msgId );

	// replyMapˤʤrefMap˴طϡreplyMapɤѤ
	if ( v == null ) {
	    v = (Vector)refMap.get(msgId);
	    replyMap.put(msgId, v);
	    System.err.println("REF->REP");
	    System.err.println("size = " );

	    if ( v != null) {
		for (int i = 0; i < v.size(); i++) {
		    String tmp = (String)v.elementAt(i);
		    Vector tmpV = (Vector)cntReplyMap.get(tmp);
		    if (tmpV == null ) tmpV = new Vector();
		    if (!tmpV.contains(msgId)) {
			tmpV.addElement(msgId);
			cntReplyMap.put(tmp, tmpV);
		    }
		    
		}
	    }
	}
	//	    System.err.println("Using");
	if ( v == null) {
	    //		System.err.println("called");
	    try {
		MailMessage mm = (MailMessage)msgMap.get(msgId);
		if (mm == null) return null;

		Message m = mm.getMessage();
		Date sentDate = m.getSentDate();

		String idFromBody = getReferenceFromBodyText(msgId, sentDate);
		if (idFromBody == null ) return msgId;

		System.err.println("Find = " + idFromBody);
		// ȯ줿طɲä 
		v = (Vector)cntReplyMap.get(idFromBody);
		if ( v == null) v = new Vector();
		if (!v.contains(msgId)) {
		    v.addElement(msgId);
		    cntReplyMap.put(idFromBody, v);
		}

		v = new Vector();
		v.addElement(idFromBody);
		replyMap.put(msgId, v);
	    } catch (MessagingException e) {
		e.printStackTrace();
		System.err.println("msgId = " + msgId);
		return(msgId);
	    } catch (NullPointerException e) {
		e.printStackTrace();
		return(msgId);
	    }

	}

	// Υᥤ뤬ܥġǡ¸ߤƤmsgid֤롣
	// ʤ null ֤롣
	String rv = msgId;
	Message m = ((MailMessage)msgMap.get(msgId)).getMessage();
	Date xSentDate = null;
	try {
	    xSentDate =  m.getSentDate();
	} catch (MessagingException e) {
	}

	for (int i = 0; i < v.size(); i++) {
	    String tmp = (String)v.elementAt(i);
	    if ( passed.get(tmp) != null) continue;

	    if ( tmp.indexOf("@") == -1 ) continue;
	    System.err.println("GetTop try= " + tmp);
	    String tmpRv = getTop(tmp);
	    try {
		m = ((MailMessage)msgMap.get(tmpRv)).getMessage();
		if ( xSentDate.compareTo(m.getSentDate())>0) {
		    rv = tmpRv;
		    xSentDate = m.getSentDate();
		}

//		  if ( tmpRv != null) rv = tmpRv;

	    } catch (MessagingException e) {
	    }
	}
	System.err.println("GetTop = " + rv);
	return rv;
    }
*/
    /**
     * idʬǻȤƤåΤǤ⿷åid֤
     * @param id åid
     * @return String åid
     */
    private String getReferenceFromBodyText(String id, Date lastSentDate) {
	MailMessage mm = (MailMessage)msgMap.get(id);
	if (Preface.debug) System.err.println("id = " + id );
	Message msg = mm.getMessage();

	String subject = MailFieldConvert.getBareSubject(msg);
        if (Preface.debug) System.err.println("Bare = " + subject);
	String rv = null;

	Vector v = (Vector)subjectMap.get(subject);
	if (v == null) return null;

	try {
	    String bodyText = MailFieldConvert.getBodyText(msg);
	    String refLine = null;
	    int p = 0;
            String kw = ">";
	    while(p!=-1) {
		p = bodyText.indexOf(kw, p);
		if (p==-1) break;
                kw = "\n>";

		int pCR = bodyText.indexOf("\n", p+2);
		int pGT = bodyText.indexOf(">", p+2);

		if (Preface.debug) System.err.println("pCR = " + pCR + " pGT = " + pGT );
		if ( pGT == -1 || pGT > pCR ) {
                    
		    refLine = bodyText.substring(p+2, pCR-1);
		    if (refLine.length() < 3) {
                        p++;
                        continue;
                    }
		    break;
		}
                p++;
	    }

	    if (Preface.debug) System.err.println("refLine = " + refLine);
            if (refLine == null) return null;
	    refLine = "\n" + refLine.trim() ;

	    for(int i = 0; i< v.size(); i++) {
		String targetId = (String)v.elementAt(i);

                if (Preface.debug) System.err.println("targetid2 = " + targetId);
	    // Ǥõ
		if ( passed.get(targetId) != null ) continue;
	    //	    System.err.println("targetId = " + targetId );

		MailMessage tmm = (MailMessage)msgMap.get(targetId);
		Message targetMsg = tmm.getMessage();

		String sender = MailFieldConvert.convertFrom(msg);
		String targetBodyText = MailFieldConvert.getBodyText(targetMsg);
		//		System.err.println(bodyText);
		//		if (bodyText.indexOf(sender)!=-1) {
		if (targetBodyText.indexOf(refLine)!=-1) {
                    /*		    if (lastSentDate == null) {
			lastSentDate = targetMsg.getSentDate();
			rv = targetId;
			System.err.println("Checked");
		    }
		    else if (lastSentDate.compareTo(targetMsg.getSentDate())>0) {
			lastSentDate = targetMsg.getSentDate();
			rv = targetId;
			System.err.println("Checked");
		    }
                    */
                    return targetId;
		}
	    }
	} catch (MailFileException e) {
	    e.printStackTrace();
	} catch (StringIndexOutOfBoundsException e) {
            //	    e.printStackTrace();
        }

	return rv;
    }

    /**
     * åɤƬޤ̤ĤġReferenceInterface.doItεǽ򤽤줾ΥåǼ¹Ԥ롣
     * @param msgId åID
     * @param ri    ReferenceInterface֥
     */
    public boolean enumerationToTop(String msgId, ReferenceInterface ri) 
	throws MailFileException  {
	passed = new HashMap();
	return enumerationToTop(msgId, ri, false);
    }

    /**
     * åɤƬޤ̤ĤġReferenceInterface.doItεǽ򤽤줾ΥåǼ¹Ԥ롣
     * @param msgId åID
     * @param ri    ReferenceInterface֥
     * @param dummy Dummy Parameter No Use
     */
    private boolean enumerationToTop(String msgId, ReferenceInterface ri, 
				     boolean dummy) 
	throws MailFileException  {
	if (ri.doIt(msgId)) return false;
	Vector v = (Vector)replyMap.get(msgId);
	System.err.println(msgId);
	//	if ( v == null ) return true;

	// replyMapˤʤrefMap˴طϡreplyMapɤѤ
	if ( v == null ) {
	    v = (Vector)refMap.get(msgId);
	    replyMap.put(msgId, v);

	    if ( v != null) {
		for (int i = 0; i < v.size(); i++) {
		    String tmp = (String)v.elementAt(i);
		    Vector tmpV = (Vector)cntReplyMap.get(tmp);
		    if (tmpV == null ) tmpV = new Vector();
		    if (!tmpV.contains(msgId)) {
			tmpV.addElement(msgId);
			cntReplyMap.put(tmp, tmpV);
		    }
		    
		}
	    }
	}
	    //	    System.err.println("Using");
	if ( v == null) {
	    //		System.err.println("called");
	    try {
		MailMessage mm = (MailMessage)msgMap.get(msgId);
		if (mm == null) return false;

		Message m = mm.getMessage();
		Date sentDate = m.getSentDate();

		String idFromBody = getReferenceFromBodyText(msgId, sentDate);
		if (idFromBody == null ) return false;

		System.err.println("Find = " + idFromBody);
		/* ȯ줿طɲä */
		v = (Vector)cntReplyMap.get(idFromBody);
		if ( v == null) v = new Vector();
		if (!v.contains(msgId)) {
		    v.addElement(msgId);
		    cntReplyMap.put(idFromBody, v);
		}

		v = new Vector();
		v.addElement(idFromBody);
		replyMap.put(msgId, v);
	    } catch (MessagingException e) {
		e.printStackTrace();
		System.err.println("msgId = " + msgId);
		return false;
	    } catch (NullPointerException e) {
		e.printStackTrace();
		return false;
	    }

	}

	// Υᥤ뤬ܥġǡ¸ߤƤmsgid֤롣
	// ʤ null ֤롣
	String rv = msgId;

	// Get Most recent date
	String xTmp = null;
	Date xSentDate = (new GregorianCalendar(2100,0,1)).getTime(); // tempolary big date
	for (int i = 0; i < v.size(); i++) {
	    String tmp = (String)v.elementAt(i);
	    tmp = tmp.substring(0,tmp.indexOf(">")+1);
	    if ( passed.get(tmp) != null) continue;

	    if ( tmp.indexOf("@") == -1 ) continue;
	    //	    String tmpRv = getTop(tmp);
	    try {
		MailMessage mm = (MailMessage)msgMap.get(tmp);
		Message m = mm.getMessage();
		//System.err.println("Date:"+ xSentDate + ":" + m.getSentDate());
		if (xSentDate.compareTo(m.getSentDate())>0 ) {
		    xTmp = tmp;
		    xSentDate = m.getSentDate();
		}
	    } catch (MessagingException e) {
	    }
	    //	    if ( tmpRv != null) rv = tmpRv;
	}
	if (!enumerationToTop(xTmp, ri, dummy)) return false;
	return false;
    }

    /**
     * ᥤin-reply-toδط̤Ĥġط򥰥դɽ롣
     * @param id åID
     * @param md MailDraw֥
     */
    private void followRef(String id, MailDraw md) {
	passed.put(id, id);
	
	//	Vector v = (Vector)cntRefMap.get(id);
	Vector v = (Vector)cntReplyMap.get(id);
	if ( v == null ) return;

	Enumeration e = v.elements();
	while(e.hasMoreElements()) {
	    String nextId = (String)e.nextElement();
	    //	    if ( id.equals(nextId) ) continue;
	    if (passed.get(nextId) != null) {
		md.addEdge(id, nextId);
		if (Preface.debug) System.err.println(id + "-->" + nextId);
		continue;
	    }

	    md.addNode(nextId, ((MailMessage)msgMap.get(nextId)).getMessage());
	    md.addEdge(id, nextId);
	    if (Preface.debug) System.err.println(id + "-->" + nextId);
	    followRef(nextId, md);
	}
    }

    /**
     * ᥤin-reply-toδط̤Ĥġط򥰥դɽ롣
     * @param id åID
     * @param md MailDraw֥
     */
    public void followRef(String id, ReferenceInterface ri) {
	passed = new HashMap();
	followRefMain(id, ri);
    }

    private void followRefMain(String id, ReferenceInterface ri) {
	passed.put(id, id);
	
	//	Vector v = (Vector)cntRefMap.get(id);
	Vector v = (Vector)cntReplyMap.get(id);
	if ( v == null ) return;

	Enumeration e = v.elements();
	while(e.hasMoreElements()) {
	    String nextId = (String)e.nextElement();
	    //	    if ( id.equals(nextId) ) continue;
	    if (passed.get(nextId) != null) {
		ri.followDoIt(id, nextId);
		continue;
	    }

	    ri.followDoIt(id, nextId);
	    followRefMain(nextId, ri);
	}
    }
    

    /**
     * Ʊ֥ȤΥޥåפ
     * @param id åID
     * @param msg å֥
     */
    private void makeSubjectMap(String id, Message msg) {
	String orgSubject = MailFieldConvert.getBareSubject(msg);
	if (orgSubject == null )  orgSubject = "NULL";
	
	Vector v = (Vector)subjectMap.get(orgSubject);
	if ( v == null ) v = new Vector();
	if (!v.contains(id)) {
	    v.addElement(id);
	    subjectMap.put(orgSubject,v);
	}
    }

    /** */
    //    private HashMap isTop = null;
    /** */
    private HashMap refMap = null;
    /** */
    private HashMap replyMap = null;

    /** */
    private HashMap cntRefMap = null;
    /** */
    private HashMap cntReplyMap = null;
    /** */
    private HashMap msgMap = null;
    /** */ 
    private HashMap subjectMap = null;

    /** */
    private HashMap passed = null;

}


